;;  Horn Clause Representation of Guahibo Kinship Term-of-Reference Rules

;;  The following 'header' gives some basic parameters of this kinship system:
(languageName, "Guahibo") (author, "Riena Kondo and William Merrifield") (date, "1985-01-01") (citation, "Riena Kondo and William Merrifield in SOUTH AMERICAN KINSHIP pp. 71-78") 
(non_term, [aux], brother, children, half_brother, half_sister, parents, sibling, siblings, sister, spice, step_brother, step_daughter, step_father, step_mother, step_sister, step_son) (partial, false) (polygamyOK, true) (address, false) (recursiveLevels, 1)
(synonyms, (amojo, nerimani), (amojova, neriva))
(overlaps, (juyapijini, (matapijini)), (juyapijiva, (matapijiva)), (matapijini, (juyapijini)), (matapijiva, (juyapijiva)))
(umbrellas, (cotiva, (banani, banava)))


;;  Kin Term Definitions:
;;	(Standard Macros are automatically incorporated.)

acue(Alter, Ego) :-  two_gen[aux]16(Alter, Ego), female(Alter).
                 |   spousal_two_gen[aux]16(Alter, Ego), female(Alter).
{"FaFaBroWi_FaFaFaBroDa_FaFaFaBroSoWi_FaFaFaSisDa_FaFaFaSisSoWi_FaFaMoBroDa_FaFaMoBroSoWi_FaFaMoSisDa_FaFaMoSisSoWi_FaFaSis_FaMo_FaMoBroWi_FaMoFaBroDa_FaMoFaBroSoWi_FaMoFaSisDa_FaMoFaSisSoWi_FaMoMoBroDa_FaMoMoBroSoWi_FaMoMoSisDa_FaMoMoSisSoWi_FaMoSis_HuFaFaFaBroDa_HuFaFaFaSisDa_HuFaFaMoBroDa_HuFaFaMoSisDa_HuFaFaSis_HuFaMo_HuFaMoFaBroDa_HuFaMoFaSisDa_HuFaMoMoBroDa_HuFaMoMoSisDa_HuFaMoSis_HuMoFaFaBroDa_HuMoFaFaSisDa_HuMoFaMoBroDa_HuMoFaMoSisDa_HuMoFaSis_HuMoMo_HuMoMoFaBroDa_HuMoMoFaSisDa_HuMoMoMoBroDa_HuMoMoMoSisDa_HuMoMoSis_MoFaBroWi_MoFaFaBroDa_MoFaFaBroSoWi_MoFaFaSisDa_MoFaFaSisSoWi_MoFaMoBroDa_MoFaMoBroSoWi_MoFaMoSisDa_MoFaMoSisSoWi_MoFaSis_MoMo_MoMoBroWi_MoMoFaBroDa_MoMoFaBroSoWi_MoMoFaSisDa_MoMoFaSisSoWi_MoMoMoBroDa_MoMoMoBroSoWi_MoMoMoSisDa_MoMoMoSisSoWi_MoMoSis_WiFaFaFaBroDa_WiFaFaFaSisDa_WiFaFaMoBroDa_WiFaFaMoSisDa_WiFaFaSis_WiFaMo_WiFaMoFaBroDa_WiFaMoFaSisDa_WiFaMoMoBroDa_WiFaMoMoSisDa_WiFaMoSis_WiMoFaFaBroDa_WiMoFaFaSisDa_WiMoFaMoBroDa_WiMoFaMoSisDa_WiMoFaSis_WiMoMo_WiMoMoFaBroDa_WiMoMoFaSisDa_WiMoMoMoBroDa_WiMoMoMoSisDa_WiMoMoSis"}
;; 0
%acue:0, two_gen[aux]16:0, parents:0%
 Lvl=2,  PC=2, S=0, Star=0,  {MoMo}  
 mother(A, Ego), parent(Alter, A), female(Alter).
;; 1
%acue:0, two_gen[aux]16:0, parents:1%
 Lvl=2,  PC=2, S=0, Star=0,  {FaMo}  
 father(A, Ego), parent(Alter, A), female(Alter).
;; 2
%acue:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoMoSis}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 3
%acue:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoBroDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 4
%acue:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoSisDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 5
%acue:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaBroDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 6
%acue:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaSisDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 7
%acue:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoFaSis}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 8
%acue:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoBroDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 9
%acue:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoSisDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 10
%acue:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaBroDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 11
%acue:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaSisDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 12
%acue:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaMoSis}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 13
%acue:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoBroDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 14
%acue:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoSisDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 15
%acue:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaBroDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 16
%acue:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaSisDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 17
%acue:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaFaSis}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 18
%acue:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoBroDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 19
%acue:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoSisDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 20
%acue:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaBroDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), female(Alter).
;; 21
%acue:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaSisDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), female(Alter).
;; 22
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {HuMoMo}  
 husband(A, Ego), mother(B, A), parent(Alter, B), female(Alter).
;; 23
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {HuFaMo}  
 husband(A, Ego), father(B, A), parent(Alter, B), female(Alter).
;; 24
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuMoMoSis}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 25
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoMoBroDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 26
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoMoSisDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 27
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoFaBroDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 28
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoFaSisDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 29
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuMoFaSis}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 30
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaMoBroDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 31
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaMoSisDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 32
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaFaBroDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 33
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaFaSisDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 34
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuFaMoSis}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 35
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoMoBroDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 36
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoMoSisDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 37
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoFaBroDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 38
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoFaSisDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 39
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuFaFaSis}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 40
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaMoBroDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 41
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaMoSisDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 42
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaFaBroDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 43
%acue:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaFaSisDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 44
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {WiMoMo}  
 wife(A, Ego), mother(B, A), parent(Alter, B), female(Alter).
;; 45
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {WiFaMo}  
 wife(A, Ego), father(B, A), parent(Alter, B), female(Alter).
;; 46
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiMoMoSis}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 47
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoMoBroDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 48
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoMoSisDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 49
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoFaBroDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 50
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoFaSisDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 51
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiMoFaSis}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 52
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaMoBroDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 53
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaMoSisDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 54
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaFaBroDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 55
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaFaSisDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 56
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiFaMoSis}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 57
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoMoBroDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 58
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoMoSisDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 59
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoFaBroDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 60
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoFaSisDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 61
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiFaFaSis}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 62
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaMoBroDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 63
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaMoSisDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 64
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaFaBroDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 65
%acue:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaFaSisDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 66
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {MoMo}  
 mother(A, Ego), parent(B, A), spouse(Alter, B), female(Alter).
;; 67
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {FaMo}  
 father(A, Ego), parent(B, A), spouse(Alter, B), female(Alter).
;; 68
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoMoBroWi}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), female(Alter).
;; 69
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoBroSoWi}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 70
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoSisSoWi}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 71
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaBroSoWi}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 72
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaSisSoWi}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 73
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoFaBroWi}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), female(Alter).
;; 74
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoBroSoWi}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 75
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoSisSoWi}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 76
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaBroSoWi}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 77
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaSisSoWi}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 78
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaMoBroWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), female(Alter).
;; 79
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoBroSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 80
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoSisSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 81
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaBroSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 82
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaSisSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 83
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaFaBroWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), female(Alter).
;; 84
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoBroSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 85
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoSisSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).
;; 86
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaBroSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), female(Alter).
;; 87
%acue:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaSisSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), female(Alter).


ame(Alter, Ego) :-  cross_up1[aux]16(Alter, Ego), female(Alter).
                |   spice(A, Ego), mother(Alter, A).
                |  [ext],  spice(A, Ego), para_up1[aux]16(Alter, A), female(Alter).
                |  [ext],  para_up1[aux]16(A, Ego), wife(Alter, A).
{"FaBroWi_FaFaBroDa_FaFaBroSoWi_FaMoSisDa_FaMoSisSoWi_FaSis_HuFaFaSisDa_HuFaMoBroDa_HuMo_HuMoFaBroDa_HuMoMoSisDa_HuMoSis_MoFaSisDa_MoFaSisSoWi_MoMoBroDa_MoMoBroSoWi_WiFaFaSisDa_WiFaMoBroDa_WiMo_WiMoFaBroDa_WiMoMoSisDa_WiMoSis"}
;; 0
%ame:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {FaSis}  
 parent(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, A), gender(E, Alter), not(equal(D, E)), female(Alter).
;; 1
%ame:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoBroDa}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(H, Alter), female(Alter).
;; 2
%ame:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaSisDa}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(H, Alter), female(Alter).
;; 3
%ame:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoSisDa}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(H, Alter), not(equal(G, H)), female(Alter).
;; 4
%ame:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaBroDa}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(H, Alter), not(equal(G, H)), female(Alter).
;; 5
%ame:1, spice:0%
 Lvl=1,  PC=1, S=1, Star=0,  {HuMo}  
 husband(A, Ego), mother(Alter, A).
;; 6
%ame:1, spice:1%
 Lvl=1,  PC=1, S=1, Star=0,  {WiMo}  
 wife(A, Ego), mother(Alter, A).
;; 7
%ame:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {HuMoSis}  
[ext],  husband(A, Ego), parent(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), gender(E, B), gender(E, Alter), female(Alter).
;; 8
%ame:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoMoSisDa}  
[ext], [ext],  husband(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(H, Alter), female(Alter).
;; 9
%ame:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoFaBroDa}  
[ext], [ext],  husband(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(H, Alter), female(Alter).
;; 10
%ame:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaMoBroDa}  
[ext], [ext],  husband(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(J, Alter), not(equal(I, J)), female(Alter).
;; 11
%ame:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaFaSisDa}  
[ext], [ext],  husband(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(J, Alter), not(equal(I, J)), female(Alter).
;; 12
%ame:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {WiMoSis}  
[ext],  wife(A, Ego), parent(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), gender(E, B), gender(E, Alter), female(Alter).
;; 13
%ame:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoMoSisDa}  
[ext], [ext],  wife(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(H, Alter), female(Alter).
;; 14
%ame:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoFaBroDa}  
[ext], [ext],  wife(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(H, Alter), female(Alter).
;; 15
%ame:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaMoBroDa}  
[ext], [ext],  wife(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(J, Alter), not(equal(I, J)), female(Alter).
;; 16
%ame:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaFaSisDa}  
[ext], [ext],  wife(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(J, Alter), not(equal(I, J)), female(Alter).
;; 17
%ame:3, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {FaBroWi}  
[ext],  parent(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), wife(Alter, D).
;; 18
%ame:3, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoSisSoWi}  
[ext], [ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), wife(Alter, G).
;; 19
%ame:3, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaBroSoWi}  
[ext], [ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), wife(Alter, G).
;; 20
%ame:3, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoBroSoWi}  
[ext], [ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), wife(Alter, H).
;; 21
%ame:3, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaSisSoWi}  
[ext], [ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), wife(Alter, H).


amo(Alter, Ego) :-  two_gen[aux]16(Alter, Ego), male(Alter).
                |   spousal_two_gen[aux]16(Alter, Ego), male(Alter).
{"FaFa_FaFaBro_FaFaFaBroDaHu_FaFaFaBroSo_FaFaFaSisDaHu_FaFaFaSisSo_FaFaMoBroDaHu_FaFaMoBroSo_FaFaMoSisDaHu_FaFaMoSisSo_FaFaSisHu_FaMoBro_FaMoFaBroDaHu_FaMoFaBroSo_FaMoFaSisDaHu_FaMoFaSisSo_FaMoMoBroDaHu_FaMoMoBroSo_FaMoMoSisDaHu_FaMoMoSisSo_FaMoSisHu_HuFaFa_HuFaFaBro_HuFaFaFaBroSo_HuFaFaFaSisSo_HuFaFaMoBroSo_HuFaFaMoSisSo_HuFaMoBro_HuFaMoFaBroSo_HuFaMoFaSisSo_HuFaMoMoBroSo_HuFaMoMoSisSo_HuMoFa_HuMoFaBro_HuMoFaFaBroSo_HuMoFaFaSisSo_HuMoFaMoBroSo_HuMoFaMoSisSo_HuMoMoBro_HuMoMoFaBroSo_HuMoMoFaSisSo_HuMoMoMoBroSo_HuMoMoMoSisSo_MoFa_MoFaBro_MoFaFaBroDaHu_MoFaFaBroSo_MoFaFaSisDaHu_MoFaFaSisSo_MoFaMoBroDaHu_MoFaMoBroSo_MoFaMoSisDaHu_MoFaMoSisSo_MoFaSisHu_MoMoBro_MoMoFaBroDaHu_MoMoFaBroSo_MoMoFaSisDaHu_MoMoFaSisSo_MoMoMoBroDaHu_MoMoMoBroSo_MoMoMoSisDaHu_MoMoMoSisSo_MoMoSisHu_WiFaFa_WiFaFaBro_WiFaFaFaBroSo_WiFaFaFaSisSo_WiFaFaMoBroSo_WiFaFaMoSisSo_WiFaMoBro_WiFaMoFaBroSo_WiFaMoFaSisSo_WiFaMoMoBroSo_WiFaMoMoSisSo_WiMoFa_WiMoFaBro_WiMoFaFaBroSo_WiMoFaFaSisSo_WiMoFaMoBroSo_WiMoFaMoSisSo_WiMoMoBro_WiMoMoFaBroSo_WiMoMoFaSisSo_WiMoMoMoBroSo_WiMoMoMoSisSo"}
;; 0
%amo:0, two_gen[aux]16:0, parents:0%
 Lvl=2,  PC=2, S=0, Star=0,  {MoFa}  
 mother(A, Ego), parent(Alter, A), male(Alter).
;; 1
%amo:0, two_gen[aux]16:0, parents:1%
 Lvl=2,  PC=2, S=0, Star=0,  {FaFa}  
 father(A, Ego), parent(Alter, A), male(Alter).
;; 2
%amo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoMoBro}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 3
%amo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoBroSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 4
%amo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoSisSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 5
%amo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaBroSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 6
%amo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaSisSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 7
%amo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoFaBro}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 8
%amo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoBroSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 9
%amo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoSisSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 10
%amo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaBroSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 11
%amo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaSisSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 12
%amo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaMoBro}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 13
%amo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoBroSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 14
%amo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoSisSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 15
%amo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaBroSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 16
%amo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaSisSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 17
%amo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaFaBro}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 18
%amo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoBroSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 19
%amo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoSisSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 20
%amo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaBroSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F), male(Alter).
;; 21
%amo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaSisSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F), male(Alter).
;; 22
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {HuMoFa}  
 husband(A, Ego), mother(B, A), parent(Alter, B), male(Alter).
;; 23
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {HuFaFa}  
 husband(A, Ego), father(B, A), parent(Alter, B), male(Alter).
;; 24
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuMoMoBro}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 25
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoMoBroSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 26
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoMoSisSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 27
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoFaBroSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 28
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoFaSisSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 29
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuMoFaBro}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 30
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaMoBroSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 31
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaMoSisSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 32
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaFaBroSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 33
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaFaSisSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 34
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuFaMoBro}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 35
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoMoBroSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 36
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoMoSisSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 37
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoFaBroSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 38
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoFaSisSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 39
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuFaFaBro}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 40
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaMoBroSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 41
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaMoSisSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 42
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaFaBroSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 43
%amo:1, spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaFaSisSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 44
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {WiMoFa}  
 wife(A, Ego), mother(B, A), parent(Alter, B), male(Alter).
;; 45
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {WiFaFa}  
 wife(A, Ego), father(B, A), parent(Alter, B), male(Alter).
;; 46
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiMoMoBro}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 47
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoMoBroSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 48
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoMoSisSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 49
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoFaBroSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 50
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoFaSisSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 51
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiMoFaBro}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 52
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaMoBroSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 53
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaMoSisSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 54
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaFaBroSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 55
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaFaSisSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 56
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiFaMoBro}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 57
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoMoBroSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 58
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoMoSisSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 59
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoFaBroSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 60
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoFaSisSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 61
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiFaFaBro}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 62
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaMoBroSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 63
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaMoSisSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 64
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaFaBroSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 65
%amo:1, spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaFaSisSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 66
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {MoFa}  
 mother(A, Ego), parent(B, A), spouse(Alter, B), male(Alter).
;; 67
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {FaFa}  
 father(A, Ego), parent(B, A), spouse(Alter, B), male(Alter).
;; 68
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoMoSisHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), male(Alter).
;; 69
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoBroDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 70
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoSisDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 71
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaBroDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 72
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaSisDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 73
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoFaSisHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), male(Alter).
;; 74
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoBroDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 75
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoSisDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 76
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaBroDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 77
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaSisDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 78
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaMoSisHu}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), male(Alter).
;; 79
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoBroDaHu}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 80
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoSisDaHu}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 81
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaBroDaHu}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 82
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaSisDaHu}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 83
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaFaSisHu}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E), male(Alter).
;; 84
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoBroDaHu}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 85
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoSisDaHu}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).
;; 86
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaBroDaHu}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G), male(Alter).
;; 87
%amo:1, spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaSisDaHu}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G), male(Alter).


amojo(Alter, Ego) :-  cross_cousin[aux]16(Alter, Ego), male(Ego), male(Alter).
{"FaFaBroDaSo_FaFaSisSoSo_FaMoBroSoSo_FaMoSisDaSo_FaSisSo_MoBroSo_MoFaBroSoSo_MoFaSisDaSo_MoMoBroDaSo_MoMoSisSoSo_SisHu_WiBro_WiFaSisDaHu_WiMoBroDaHu"}
;; 0
%amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), male(Ego), male(Alter).
;; 1
%amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), male(Alter).
;; 2
%amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), male(Alter).
;; 3
%amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), male(Alter).
;; 4
%amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), male(Alter).
;; 5
%amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), male(Ego), male(Alter).
;; 6
%amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), male(Alter).
;; 7
%amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), male(Alter).
;; 8
%amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), male(Alter).
;; 9
%amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), male(Alter).
;; 10
%amojo:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {WiBro}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Ego), male(Alter).
;; 11
%amojo:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {SisHu}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C), male(Ego), male(Alter).
;; 12
%amojo:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiMoBroDaHu}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), male(Ego), male(Alter).
;; 13
%amojo:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiFaSisDaHu}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), male(Ego), male(Alter).


amojova(Alter, Ego) :-  cross_cousin[aux]16(Alter, Ego), female(Ego), female(Alter).
{"BroWi_FaFaBroDaDa_FaFaSisSoDa_FaMoBroSoDa_FaMoSisDaDa_FaSisDa_HuFaSisSoWi_HuMoBroSoWi_HuSis_MoBroDa_MoFaBroSoDa_MoFaSisDaDa_MoMoBroDaDa_MoMoSisSoDa"}
;; 0
%amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), female(Ego), female(Alter).
;; 1
%amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), female(Alter).
;; 2
%amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), female(Alter).
;; 3
%amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), female(Alter).
;; 4
%amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), female(Alter).
;; 5
%amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), female(Ego), female(Alter).
;; 6
%amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), female(Alter).
;; 7
%amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), female(Alter).
;; 8
%amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), female(Alter).
;; 9
%amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), female(Alter).
;; 10
%amojova:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {HuSis}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Ego), female(Alter).
;; 11
%amojova:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {BroWi}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C), female(Ego), female(Alter).
;; 12
%amojova:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuMoBroSoWi}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), female(Ego), female(Alter).
;; 13
%amojova:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuFaSisSoWi}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), female(Ego), female(Alter).


amono(Alter, Ego) :-  husband(Alter, Ego).
{"Hu"}
;; 0
%amono:0%
 Lvl=0,  PC=0, S=1, Star=0,  {Hu}  
 husband(Alter, Ego).


apa(Alter, Ego) :-  father(Alter, Ego).
                |  [ext],  step_father(Alter, Ego).
{"Fa_Stfa"}
;; 0
%apa:0%
 Lvl=1,  PC=1, S=0, Star=0,  {Fa}  
 father(Alter, Ego).
;; 1
%apa:1, step_father:0%
 Lvl=1,  PC=2, S=1, Star=0,  {Stfa}  
[ext],  father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).


axu(Alter, Ego) :-  cross_up1[aux]16(Alter, Ego), male(Alter).
                |   spice(A, Ego), father(Alter, A).
                |  [ext],  spice(A, Ego), para_up1[aux]16(Alter, A), male(Alter).
                |  [ext],  para_up1[aux]16(A, Ego), husband(Alter, A).
{"FaFaSisDaHu_FaFaSisSo_FaMoBroDaHu_FaMoBroSo_HuFa_HuFaBro_HuFaFaBroSo_HuFaMoSisSo_HuMoFaSisSo_HuMoMoBroSo_MoBro_MoFaBroDaHu_MoFaBroSo_MoMoSisDaHu_MoMoSisSo_MoSisHu_WiFa_WiFaBro_WiFaFaBroSo_WiFaMoSisSo_WiMoFaSisSo_WiMoMoBroSo"}
;; 0
%axu:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {MoBro}  
 parent(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, A), gender(E, Alter), not(equal(D, E)), male(Alter).
;; 1
%axu:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoBroSo}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(H, Alter), male(Alter).
;; 2
%axu:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaSisSo}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(H, Alter), male(Alter).
;; 3
%axu:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoSisSo}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(H, Alter), not(equal(G, H)), male(Alter).
;; 4
%axu:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaBroSo}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(H, Alter), not(equal(G, H)), male(Alter).
;; 5
%axu:1, spice:0%
 Lvl=1,  PC=1, S=1, Star=0,  {HuFa}  
 husband(A, Ego), father(Alter, A).
;; 6
%axu:1, spice:1%
 Lvl=1,  PC=1, S=1, Star=0,  {WiFa}  
 wife(A, Ego), father(Alter, A).
;; 7
%axu:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {HuFaBro}  
[ext],  husband(A, Ego), parent(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), gender(E, B), gender(E, Alter), male(Alter).
;; 8
%axu:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaMoSisSo}  
[ext], [ext],  husband(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(H, Alter), male(Alter).
;; 9
%axu:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaFaBroSo}  
[ext], [ext],  husband(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(H, Alter), male(Alter).
;; 10
%axu:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoMoBroSo}  
[ext], [ext],  husband(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(J, Alter), not(equal(I, J)), male(Alter).
;; 11
%axu:2, spice:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoFaSisSo}  
[ext], [ext],  husband(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(J, Alter), not(equal(I, J)), male(Alter).
;; 12
%axu:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {WiFaBro}  
[ext],  wife(A, Ego), parent(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), gender(E, B), gender(E, Alter), male(Alter).
;; 13
%axu:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaMoSisSo}  
[ext], [ext],  wife(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(H, Alter), male(Alter).
;; 14
%axu:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaFaBroSo}  
[ext], [ext],  wife(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(H, Alter), male(Alter).
;; 15
%axu:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoMoBroSo}  
[ext], [ext],  wife(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(J, Alter), not(equal(I, J)), male(Alter).
;; 16
%axu:2, spice:1, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoFaSisSo}  
[ext], [ext],  wife(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(J, Alter), not(equal(I, J)), male(Alter).
;; 17
%axu:3, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {MoSisHu}  
[ext],  parent(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), husband(Alter, D).
;; 18
%axu:3, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoSisDaHu}  
[ext], [ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), husband(Alter, G).
;; 19
%axu:3, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaBroDaHu}  
[ext], [ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), husband(Alter, G).
;; 20
%axu:3, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoBroDaHu}  
[ext], [ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), husband(Alter, H).
;; 21
%axu:3, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaSisDaHu}  
[ext], [ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), husband(Alter, H).


axuani(Alter, Ego) :-  para_up1[aux]16(Alter, Ego), male(Alter).
                   |  [ext],  spice(A, Ego), cross_up1[aux]16(Alter, A), male(Alter).
                   |  [ext],  cross_up1[aux]16(A, Ego), husband(Alter, A), not(spouse(B, Ego), father(Alter, B)).
{"FaBro_FaFaBroDaHu_FaFaBroSo_FaMoSisDaHu_FaMoSisSo_FaSisHu_HuFaFaSisSo_HuFaMoBroSo_HuMoBro_HuMoFaBroSo_HuMoMoSisSo_MoFaSisDaHu_MoFaSisSo_MoMoBroDaHu_MoMoBroSo_WiFaFaSisSo_WiFaMoBroSo_WiMoBro_WiMoFaBroSo_WiMoMoSisSo"}
;; 0
%axuani:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {FaBro}  
 parent(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, A), gender(D, Alter), male(Alter).
;; 1
%axuani:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoSisSo}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(G, Alter), male(Alter).
;; 2
%axuani:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaBroSo}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(G, Alter), male(Alter).
;; 3
%axuani:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoBroSo}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(I, Alter), not(equal(H, I)), male(Alter).
;; 4
%axuani:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaSisSo}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(I, Alter), not(equal(H, I)), male(Alter).
;; 5
%axuani:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {HuMoBro}  
[ext],  husband(A, Ego), parent(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), gender(E, B), gender(F, Alter), not(equal(E, F)), male(Alter).
;; 6
%axuani:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaMoBroSo}  
[ext], [ext],  husband(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(I, Alter), male(Alter).
;; 7
%axuani:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaFaSisSo}  
[ext], [ext],  husband(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(I, Alter), male(Alter).
;; 8
%axuani:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoMoSisSo}  
[ext], [ext],  husband(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(I, Alter), not(equal(H, I)), male(Alter).
;; 9
%axuani:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoFaBroSo}  
[ext], [ext],  husband(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(I, Alter), not(equal(H, I)), male(Alter).
;; 10
%axuani:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {WiMoBro}  
[ext],  wife(A, Ego), parent(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), gender(E, B), gender(F, Alter), not(equal(E, F)), male(Alter).
;; 11
%axuani:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaMoBroSo}  
[ext], [ext],  wife(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(I, Alter), male(Alter).
;; 12
%axuani:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaFaSisSo}  
[ext], [ext],  wife(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(I, Alter), male(Alter).
;; 13
%axuani:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoMoSisSo}  
[ext], [ext],  wife(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(I, Alter), not(equal(H, I)), male(Alter).
;; 14
%axuani:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoFaBroSo}  
[ext], [ext],  wife(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(I, Alter), not(equal(H, I)), male(Alter).
;; 15
%axuani:2, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=5, S=1, Star=0,  {FaSisHu}  
[ext],  parent(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), husband(Alter, D), not(spouse(G, Ego), father(Alter, G)).
;; 16
%axuani:2, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoBroDaHu}  
[ext], [ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(I, H), husband(Alter, H), not(spouse(J, Ego), father(Alter, J)).
;; 17
%axuani:2, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaSisDaHu}  
[ext], [ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(I, H), husband(Alter, H), not(spouse(J, Ego), father(Alter, J)).
;; 18
%axuani:2, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoSisDaHu}  
[ext], [ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), husband(Alter, G), not(spouse(J, Ego), father(Alter, J)).
;; 19
%axuani:2, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaBroDaHu}  
[ext], [ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), husband(Alter, G), not(spouse(J, Ego), father(Alter, J)).


banani(Alter, Ego) :-  cross_cousin[aux]16(Alter, Ego), female(Ego), male(Alter).
{"FaFaBroDaSo_FaFaSisSoSo_FaMoBroSoSo_FaMoSisDaSo_FaSisSo_HuBro_HuFaSisDaHu_HuMoBroDaHu_MoBroSo_MoFaBroSoSo_MoFaSisDaSo_MoMoBroDaSo_MoMoSisSoSo_SisHu"}
;; 0
%banani:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), female(Ego), male(Alter).
;; 1
%banani:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), male(Alter).
;; 2
%banani:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), male(Alter).
;; 3
%banani:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), male(Alter).
;; 4
%banani:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), male(Alter).
;; 5
%banani:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), female(Ego), male(Alter).
;; 6
%banani:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), male(Alter).
;; 7
%banani:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), male(Alter).
;; 8
%banani:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), male(Alter).
;; 9
%banani:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), male(Alter).
;; 10
%banani:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {HuBro}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Ego), male(Alter).
;; 11
%banani:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {SisHu}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C), female(Ego), male(Alter).
;; 12
%banani:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuMoBroDaHu}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), female(Ego), male(Alter).
;; 13
%banani:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuFaSisDaHu}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), female(Ego), male(Alter).


banava(Alter, Ego) :-  cross_cousin[aux]16(Alter, Ego), male(Ego), female(Alter).
{"BroWi_FaFaBroDaDa_FaFaSisSoDa_FaMoBroSoDa_FaMoSisDaDa_FaSisDa_MoBroDa_MoFaBroSoDa_MoFaSisDaDa_MoMoBroDaDa_MoMoSisSoDa_WiFaSisSoWi_WiMoBroSoWi_WiSis"}
;; 0
%banava:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), male(Ego), female(Alter).
;; 1
%banava:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), female(Alter).
;; 2
%banava:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), female(Alter).
;; 3
%banava:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), female(Alter).
;; 4
%banava:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), female(Alter).
;; 5
%banava:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), male(Ego), female(Alter).
;; 6
%banava:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), female(Alter).
;; 7
%banava:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), female(Alter).
;; 8
%banava:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), female(Alter).
;; 9
%banava:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), female(Alter).
;; 10
%banava:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {WiSis}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Ego), female(Alter).
;; 11
%banava:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {BroWi}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C), male(Ego), female(Alter).
;; 12
%banava:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiMoBroSoWi}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), male(Ego), female(Alter).
;; 13
%banava:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiFaSisSoWi}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), male(Ego), female(Alter).


brother(Alter, Ego) :-  sibling(Alter, Ego), male(Alter).
;; 0
%brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).


children(Alter, Ego) :-  son(Alter, Ego).
                     |   daughter(Alter, Ego).
;; 0
%children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(Alter, Ego).
;; 1
%children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(Alter, Ego).


cotiva(Alter, Ego) :-  cross_cousin[aux]16(Alter, Ego), male(Ego), female(Alter).
                   |   cross_cousin[aux]16(Alter, Ego), female(Ego), male(Alter).
{"BroWi_FaFaBroDaDa_FaFaBroDaSo_FaFaSisSoDa_FaFaSisSoSo_FaMoBroSoDa_FaMoBroSoSo_FaMoSisDaDa_FaMoSisDaSo_FaSisDa_FaSisSo_HuBro_HuFaSisDaHu_HuMoBroDaHu_MoBroDa_MoBroSo_MoFaBroSoDa_MoFaBroSoSo_MoFaSisDaDa_MoFaSisDaSo_MoMoBroDaDa_MoMoBroDaSo_MoMoSisSoDa_MoMoSisSoSo_SisHu_WiFaSisSoWi_WiMoBroSoWi_WiSis"}
;; 0
%cotiva:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), male(Ego), female(Alter).
;; 1
%cotiva:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), female(Alter).
;; 2
%cotiva:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), female(Alter).
;; 3
%cotiva:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), female(Alter).
;; 4
%cotiva:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), female(Alter).
;; 5
%cotiva:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), male(Ego), female(Alter).
;; 6
%cotiva:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), female(Alter).
;; 7
%cotiva:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), female(Alter).
;; 8
%cotiva:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), female(Alter).
;; 9
%cotiva:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), female(Alter).
;; 10
%cotiva:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {WiSis}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Ego), female(Alter).
;; 11
%cotiva:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {BroWi}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C), male(Ego), female(Alter).
;; 12
%cotiva:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiMoBroSoWi}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), male(Ego), female(Alter).
;; 13
%cotiva:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiFaSisSoWi}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), male(Ego), female(Alter).
;; 14
%cotiva:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), female(Ego), male(Alter).
;; 15
%cotiva:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), male(Alter).
;; 16
%cotiva:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), male(Alter).
;; 17
%cotiva:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), male(Alter).
;; 18
%cotiva:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), male(Alter).
;; 19
%cotiva:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), female(Ego), male(Alter).
;; 20
%cotiva:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), male(Alter).
;; 21
%cotiva:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), male(Alter).
;; 22
%cotiva:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), male(Alter).
;; 23
%cotiva:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), male(Alter).
;; 24
%cotiva:1, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {HuBro}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Ego), male(Alter).
;; 25
%cotiva:1, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {SisHu}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C), female(Ego), male(Alter).
;; 26
%cotiva:1, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuMoBroDaHu}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), female(Ego), male(Alter).
;; 27
%cotiva:1, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuFaSisDaHu}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), female(Ego), male(Alter).


cross_cousin[aux]16(Alter, Ego) :-  parents(A, Ego), odd_gen[aux]16small(B, A), child(Alter, B).
                                |  [ext],  spouse(A, Ego), sibling(Alter, A).
                                |  [ext],  sibling(A, Ego), spouse(Alter, A).
                                |  [ext],  spouse(A, Ego), parents(B, A), odd_gen[aux]16small(C, B), child(D, C), spouse(Alter, D).
;; 0
%cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D).
;; 1
%cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H).
;; 2
%cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H).
;; 3
%cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G).
;; 4
%cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G).
;; 5
%cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D).
;; 6
%cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H).
;; 7
%cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H).
;; 8
%cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G).
;; 9
%cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G).
;; 10
%cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 11
%cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C).
;; 12
%cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H).
;; 13
%cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 14
%cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 15
%cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 16
%cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 17
%cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H).
;; 18
%cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 19
%cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 20
%cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 21
%cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).


cross_cousin[aux]16egs(Alter, Ego) :-  parents(A, Ego), odd_gen[aux]16small(B, A), child(Alter, B).
                                   |  [ext],  spice(A, Ego), sibling(Alter, A).
                                   |  [ext],  sibling(A, Ego), spouse(Alter, A).
                                   |  [ext],  spice(A, Ego), parents(B, A), odd_gen[aux]16small(C, B), child(D, C), spouse(Alter, D).
;; 0
%cross_cousin[aux]16egs:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D).
;; 1
%cross_cousin[aux]16egs:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H).
;; 2
%cross_cousin[aux]16egs:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H).
;; 3
%cross_cousin[aux]16egs:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G).
;; 4
%cross_cousin[aux]16egs:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G).
;; 5
%cross_cousin[aux]16egs:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D).
;; 6
%cross_cousin[aux]16egs:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H).
;; 7
%cross_cousin[aux]16egs:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H).
;; 8
%cross_cousin[aux]16egs:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G).
;; 9
%cross_cousin[aux]16egs:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G).
;; 10
%cross_cousin[aux]16egs:1, spice:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 11
%cross_cousin[aux]16egs:1, spice:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 12
%cross_cousin[aux]16egs:2, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C).
;; 13
%cross_cousin[aux]16egs:3, spice:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H).
;; 14
%cross_cousin[aux]16egs:3, spice:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 15
%cross_cousin[aux]16egs:3, spice:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 16
%cross_cousin[aux]16egs:3, spice:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 17
%cross_cousin[aux]16egs:3, spice:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 18
%cross_cousin[aux]16egs:3, spice:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H).
;; 19
%cross_cousin[aux]16egs:3, spice:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 20
%cross_cousin[aux]16egs:3, spice:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 21
%cross_cousin[aux]16egs:3, spice:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 22
%cross_cousin[aux]16egs:3, spice:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 23
%cross_cousin[aux]16egs:3, spice:1, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H).
;; 24
%cross_cousin[aux]16egs:3, spice:1, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 25
%cross_cousin[aux]16egs:3, spice:1, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 26
%cross_cousin[aux]16egs:3, spice:1, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 27
%cross_cousin[aux]16egs:3, spice:1, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 28
%cross_cousin[aux]16egs:3, spice:1, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H).
;; 29
%cross_cousin[aux]16egs:3, spice:1, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 30
%cross_cousin[aux]16egs:3, spice:1, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(H, E), child(I, E), gender(J, B), gender(J, I), not(equal(G, H)), child(K, I), spouse(Alter, K).
;; 31
%cross_cousin[aux]16egs:3, spice:1, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).
;; 32
%cross_cousin[aux]16egs:3, spice:1, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, C), gender(G, E), child(H, E), gender(I, B), gender(J, H), not(equal(I, J)), child(K, H), spouse(Alter, K).


cross_dn1[aux]16(Alter, Ego) :-  cross_up1[aux]16(Ego, Alter).
;; 0
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(E, Ego), not(equal(D, E)).
;; 1
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego).
;; 2
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego).
;; 3
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego).
;; 4
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego).
;; 5
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego).
;; 6
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego).
;; 7
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)).
;; 8
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)).
;; 9
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)).
;; 10
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)).
;; 11
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)).
;; 12
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)).
;; 13
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)).
;; 14
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)).
;; 15
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)).
;; 16
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)).
;; 17
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(E, Ego), not(equal(D, E)).
;; 18
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego).
;; 19
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego).
;; 20
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego).
;; 21
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego).
;; 22
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego).
;; 23
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego).
;; 24
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)).
;; 25
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)).
;; 26
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)).
;; 27
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)).
;; 28
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)).
;; 29
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)).
;; 30
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)).
;; 31
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)).
;; 32
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)).
;; 33
%cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)).


cross_up1[aux]16(Alter, Ego) :-  parent(A, Ego), odd_gen[aux]16(Alter, A).
;; 0
%cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 parent(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, A), gender(E, Alter), not(equal(D, E)).
;; 1
%cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(H, Alter).
;; 2
%cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(H, Alter).
;; 3
%cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(H, Alter), not(equal(G, H)).
;; 4
%cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(H, Alter), not(equal(G, H)).


ecopenayo(Alter, Ego) :-  cross_dn1[aux]16(Alter, Ego), female(Alter).
                      |  [ext],  spice(A, Ego), para_dn1[aux]16(Alter, A), female(Alter).
                      |  [ext],  para_dn1[aux]16(A, Ego), wife(Alter, A).
{"BroDa_BroSoWi_FaBroDaDa_FaBroDaSoWi_FaBroSoDa_FaBroSoSoWi_FaFaBroDaDaDa_FaFaBroDaDaSoWi_FaFaBroDaSoDa_FaFaBroDaSoSoWi_FaFaBroSoDaDa_FaFaBroSoSoDa_FaFaSisDaDaDa_FaFaSisDaDaSoWi_FaFaSisDaSoDa_FaFaSisDaSoSoWi_FaFaSisSoDaSoWi_FaFaSisSoSoSoWi_FaMoBroDaDaDa_FaMoBroDaDaSoWi_FaMoBroDaSoDa_FaMoBroDaSoSoWi_FaMoBroSoDaSoWi_FaMoBroSoSoSoWi_FaMoSisDaDaDa_FaMoSisDaDaSoWi_FaMoSisDaSoDa_FaMoSisDaSoSoWi_FaMoSisSoDaDa_FaMoSisSoSoDa_FaSisDaDa_FaSisDaSoWi_FaSisSoDa_FaSisSoSoWi_HuBroDa_HuFaBroSoDa_HuFaFaSisDaSoDa_HuFaMoBroDaSoDa_HuFaSisDaDa_HuMoBroDaDa_HuMoFaSisSoSoDa_HuMoMoBroSoSoDa_HuMoSisSoDa_MoBroDaDa_MoBroDaSoWi_MoBroSoDa_MoBroSoSoWi_MoFaBroDaDaDa_MoFaBroDaSoDa_MoFaBroSoDaDa_MoFaBroSoDaSoWi_MoFaBroSoSoDa_MoFaBroSoSoSoWi_MoFaSisDaDaSoWi_MoFaSisDaSoSoWi_MoFaSisSoDaDa_MoFaSisSoDaSoWi_MoFaSisSoSoDa_MoFaSisSoSoSoWi_MoMoBroDaDaSoWi_MoMoBroDaSoSoWi_MoMoBroSoDaDa_MoMoBroSoDaSoWi_MoMoBroSoSoDa_MoMoBroSoSoSoWi_MoMoSisDaDaDa_MoMoSisDaSoDa_MoMoSisSoDaDa_MoMoSisSoDaSoWi_MoMoSisSoSoDa_MoMoSisSoSoSoWi_MoSisDaDa_MoSisDaSoWi_MoSisSoDa_MoSisSoSoWi_SisDa_SisSoWi_WiFaBroDaDa_WiFaFaSisDaDaDa_WiFaMoBroDaDaDa_WiFaSisSoDa_WiMoBroSoDa_WiMoFaSisSoDaDa_WiMoMoBroSoDaDa_WiMoSisDaDa_WiSisDa"}
;; 0
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {SisDa}  
 male(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(E, Ego), not(equal(D, E)), female(Alter).
;; 1
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisSoDa}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego), female(Alter).
;; 2
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaSoDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), female(Alter).
;; 3
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaSoDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), female(Alter).
;; 4
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroSoDa}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego), female(Alter).
;; 5
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoSoDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), female(Alter).
;; 6
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoSoDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), female(Alter).
;; 7
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisDaDa}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)), female(Alter).
;; 8
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisDaDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), female(Alter).
;; 9
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroDaDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), female(Alter).
;; 10
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), female(Alter).
;; 11
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), female(Alter).
;; 12
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroDaDa}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)), female(Alter).
;; 13
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisSoDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), female(Alter).
;; 14
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroSoDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), female(Alter).
;; 15
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), female(Alter).
;; 16
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), female(Alter).
;; 17
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {HuBroDa}  
[ext],  husband(A, Ego), parent(B, Alter), mother(C, B), father(D, B), child(A, C), child(A, D), not(equal(A, B)), gender(E, B), gender(E, A), female(Alter).
;; 18
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoSisSoDa}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(H, A), female(Alter).
;; 19
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroDaSoDa}  
[ext], [ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), female(Alter).
;; 20
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisDaSoDa}  
[ext], [ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), female(Alter).
;; 21
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaBroSoDa}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(H, A), female(Alter).
;; 22
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroSoSoDa}  
[ext], [ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), female(Alter).
;; 23
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisSoSoDa}  
[ext], [ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), female(Alter).
;; 24
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaSisDaDa}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(J, A), not(equal(I, J)), female(Alter).
;; 25
%ecopenayo:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoBroDaDa}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(J, A), not(equal(I, J)), female(Alter).
;; 26
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {WiSisDa}  
[ext],  wife(A, Ego), parent(B, Alter), mother(C, B), father(D, B), child(A, C), child(A, D), not(equal(A, B)), gender(E, B), gender(E, A), female(Alter).
;; 27
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoSisDaDa}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(H, A), female(Alter).
;; 28
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroDaDaDa}  
[ext], [ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), female(Alter).
;; 29
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisDaDaDa}  
[ext], [ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), female(Alter).
;; 30
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaBroDaDa}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(H, A), female(Alter).
;; 31
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroSoDaDa}  
[ext], [ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), female(Alter).
;; 32
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisSoDaDa}  
[ext], [ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), female(Alter).
;; 33
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaSisSoDa}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(J, A), not(equal(I, J)), female(Alter).
;; 34
%ecopenayo:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoBroSoDa}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(J, A), not(equal(I, J)), female(Alter).
;; 35
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {BroSoWi}  
[ext],  male(Ego), parent(A, B), mother(C, A), father(D, A), child(Ego, C), child(Ego, D), not(equal(Ego, A)), gender(E, A), gender(E, Ego), wife(Alter, B).
;; 36
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisSoSoWi}  
[ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(H, Ego), wife(Alter, B).
;; 37
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroDaSoSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), wife(Alter, B).
;; 38
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisDaSoSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), wife(Alter, B).
;; 39
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroSoSoWi}  
[ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(H, Ego), wife(Alter, B).
;; 40
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroSoSoSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), wife(Alter, B).
;; 41
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisSoSoSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), wife(Alter, B).
;; 42
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisDaSoWi}  
[ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(J, Ego), not(equal(I, J)), wife(Alter, B).
;; 43
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroDaDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 44
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisDaDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 45
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisDaDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 46
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroDaDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 47
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroDaSoWi}  
[ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(J, Ego), not(equal(I, J)), wife(Alter, B).
;; 48
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroSoDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 49
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisSoDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 50
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisSoDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 51
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroSoDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 52
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {BroDa}  
 female(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(E, Ego), not(equal(D, E)), female(Alter).
;; 53
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisDaDa}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego), female(Alter).
;; 54
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaDaDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), female(Alter).
;; 55
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaDaDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), female(Alter).
;; 56
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroDaDa}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego), female(Alter).
;; 57
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoDaDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), female(Alter).
;; 58
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoDaDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), female(Alter).
;; 59
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisSoDa}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)), female(Alter).
;; 60
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisDaSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), female(Alter).
;; 61
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroDaSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), female(Alter).
;; 62
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), female(Alter).
;; 63
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), female(Alter).
;; 64
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroSoDa}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)), female(Alter).
;; 65
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisSoSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), female(Alter).
;; 66
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroSoSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), female(Alter).
;; 67
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), female(Alter).
;; 68
%ecopenayo:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), female(Alter).
;; 69
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {SisSoWi}  
[ext],  female(Ego), parent(A, B), mother(C, A), father(D, A), child(Ego, C), child(Ego, D), not(equal(Ego, A)), gender(E, A), gender(E, Ego), wife(Alter, B).
;; 70
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisDaSoWi}  
[ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(H, Ego), wife(Alter, B).
;; 71
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroDaDaSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), wife(Alter, B).
;; 72
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisDaDaSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), wife(Alter, B).
;; 73
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroDaSoWi}  
[ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(H, Ego), wife(Alter, B).
;; 74
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroSoDaSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), wife(Alter, B).
;; 75
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisSoDaSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), wife(Alter, B).
;; 76
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisSoSoWi}  
[ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(J, Ego), not(equal(I, J)), wife(Alter, B).
;; 77
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroDaSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 78
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisDaSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 79
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisDaSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 80
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroDaSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 81
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroSoSoWi}  
[ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(J, Ego), not(equal(I, J)), wife(Alter, B).
;; 82
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroSoSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 83
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisSoSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 84
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisSoSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).
;; 85
%ecopenayo:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroSoSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), wife(Alter, B).


ena(Alter, Ego) :-  mother(Alter, Ego).
                |  [ext],  step_mother(Alter, Ego).
{"Mo_Stmo"}
;; 0
%ena:0%
 Lvl=1,  PC=1, S=0, Star=0,  {Mo}  
 mother(Alter, Ego).
;; 1
%ena:1, step_mother:0%
 Lvl=1,  PC=2, S=1, Star=0,  {Stmo}  
[ext],  father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).


enava(Alter, Ego) :-  para_up1[aux]16(Alter, Ego), female(Alter).
                  |  [ext],  spice(A, Ego), cross_up1[aux]16(Alter, A), female(Alter).
                  |  [ext],  cross_up1[aux]16(A, Ego), wife(Alter, A), not(spouse(B, Ego), mother(Alter, B)).
{"FaFaSisDa_FaFaSisSoWi_FaMoBroDa_FaMoBroSoWi_HuFaFaBroDa_HuFaMoSisDa_HuFaSis_HuMoFaSisDa_HuMoMoBroDa_MoBroWi_MoFaBroDa_MoFaBroSoWi_MoMoSisDa_MoMoSisSoWi_MoSis_WiFaFaBroDa_WiFaMoSisDa_WiFaSis_WiMoFaSisDa_WiMoMoBroDa"}
;; 0
%enava:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {MoSis}  
 parent(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, A), gender(D, Alter), female(Alter).
;; 1
%enava:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoSisDa}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(G, Alter), female(Alter).
;; 2
%enava:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaBroDa}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(G, Alter), female(Alter).
;; 3
%enava:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoBroDa}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(I, Alter), not(equal(H, I)), female(Alter).
;; 4
%enava:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaSisDa}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(I, Alter), not(equal(H, I)), female(Alter).
;; 5
%enava:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {HuFaSis}  
[ext],  husband(A, Ego), parent(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), gender(E, B), gender(F, Alter), not(equal(E, F)), female(Alter).
;; 6
%enava:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoMoBroDa}  
[ext], [ext],  husband(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(I, Alter), female(Alter).
;; 7
%enava:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoFaSisDa}  
[ext], [ext],  husband(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(I, Alter), female(Alter).
;; 8
%enava:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaMoSisDa}  
[ext], [ext],  husband(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(I, Alter), not(equal(H, I)), female(Alter).
;; 9
%enava:1, spice:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaFaBroDa}  
[ext], [ext],  husband(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(I, Alter), not(equal(H, I)), female(Alter).
;; 10
%enava:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {WiFaSis}  
[ext],  wife(A, Ego), parent(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), gender(E, B), gender(F, Alter), not(equal(E, F)), female(Alter).
;; 11
%enava:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoMoBroDa}  
[ext], [ext],  wife(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(I, Alter), female(Alter).
;; 12
%enava:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoFaSisDa}  
[ext], [ext],  wife(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Alter, E), gender(I, B), gender(I, Alter), female(Alter).
;; 13
%enava:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaMoSisDa}  
[ext], [ext],  wife(A, Ego), parent(B, A), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(I, Alter), not(equal(H, I)), female(Alter).
;; 14
%enava:1, spice:1, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaFaBroDa}  
[ext], [ext],  wife(A, Ego), parent(B, A), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Alter, E), gender(H, B), gender(I, Alter), not(equal(H, I)), female(Alter).
;; 15
%enava:2, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=5, S=1, Star=0,  {MoBroWi}  
[ext],  parent(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), wife(Alter, D), not(spouse(G, Ego), mother(Alter, G)).
;; 16
%enava:2, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoBroSoWi}  
[ext], [ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(I, H), wife(Alter, H), not(spouse(J, Ego), mother(Alter, J)).
;; 17
%enava:2, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaSisSoWi}  
[ext], [ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(I, H), wife(Alter, H), not(spouse(J, Ego), mother(Alter, J)).
;; 18
%enava:2, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoSisSoWi}  
[ext], [ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), wife(Alter, G), not(spouse(J, Ego), mother(Alter, J)).
;; 19
%enava:2, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0, (not)%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaBroSoWi}  
[ext], [ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), wife(Alter, G), not(spouse(J, Ego), mother(Alter, J)).


even_gen[aux]16(Alter, Ego) :-  sibling(Alter, Ego), gender(A, Ego), gender(A, Alter).
                            |  [ext],  parents(A, Ego), even_gen[aux]16(A, B), child(Alter, B), gender(C, Ego), gender(C, Alter).
                            |  [ext],  parents(A, Ego), odd_gen[aux]16(A, B), child(Alter, B), gender(C, Ego), gender(D, Alter), not(equal(C, D)).
;; 0
%even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(C, Alter).
;; 1
%even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 2
%even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 3
%even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 4
%even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 5
%even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 6
%even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 7
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), gender(G, Ego), gender(H, Alter), not(equal(G, H)).
;; 8
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(I, A), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 9
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(I, A), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 10
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 11
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 12
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), gender(G, Ego), gender(H, Alter), not(equal(G, H)).
;; 13
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(I, A), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 14
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(I, A), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 15
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 16
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 17
%even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(C, Alter).
;; 18
%even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 19
%even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 20
%even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 21
%even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 22
%even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 23
%even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 24
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), gender(G, Ego), gender(H, Alter), not(equal(G, H)).
;; 25
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(I, A), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 26
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(I, A), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 27
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 28
%even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 29
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), gender(G, Ego), gender(H, Alter), not(equal(G, H)).
;; 30
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(I, A), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 31
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(I, A), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 32
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).
;; 33
%even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(K, Alter), not(equal(J, K)).


even_gen[aux]16small(Alter, Ego) :-  sibling(Alter, Ego), gender(A, Ego), gender(A, Alter).
                                 |  [ext],  parents(A, Ego), sibling(A, B), gender(C, A), gender(C, B), child(Alter, B), gender(D, Ego), gender(D, Alter).
                                 |  [ext],  parents(A, Ego), sibling(A, B), gender(C, A), gender(D, B), child(Alter, B), gender(E, Ego), gender(F, Alter), not(equal(E, F)), not(equal(C, D)).
;; 0
%even_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(C, Alter).
;; 1
%even_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 2
%even_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 3
%even_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(F, C), child(Alter, C), gender(G, Ego), gender(H, Alter), not(equal(G, H)), not(equal(E, F)).
;; 4
%even_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(F, C), child(Alter, C), gender(G, Ego), gender(H, Alter), not(equal(G, H)), not(equal(E, F)).
;; 5
%even_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(C, Alter).
;; 6
%even_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 7
%even_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 8
%even_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(F, C), child(Alter, C), gender(G, Ego), gender(H, Alter), not(equal(G, H)), not(equal(E, F)).
;; 9
%even_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(F, C), child(Alter, C), gender(G, Ego), gender(H, Alter), not(equal(G, H)), not(equal(E, F)).


even_gen[aux]16ss(Alter, Ego) :-  sibling(Alter, Ego), gender(A, Ego), gender(A, Alter).
                              |  [ext],  parents(A, Ego), even_gen[aux]16(A, B), child(Alter, B), gender(C, Ego), gender(C, Alter).
                              |  [ext],  parents(A, Ego), parents(B, A), odd_gen[aux]16(B, C), child(D, C), child(Alter, D), gender(E, D), gender(F, A), gender(G, Ego), gender(G, Alter), not(equal(E, F)).
;; 0
%even_gen[aux]16ss:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(C, Alter).
;; 1
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 2
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(I, Alter).
;; 3
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(I, Alter).
;; 4
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 5
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 6
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 7
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(I, Alter).
;; 8
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(I, Alter).
;; 9
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 10
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 11
%even_gen[aux]16ss:2, parents:0, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H), gender(I, H), gender(J, A), gender(K, Ego), gender(K, Alter), not(equal(I, J)).
;; 12
%even_gen[aux]16ss:2, parents:0, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H), gender(I, H), gender(J, A), gender(K, Ego), gender(K, Alter), not(equal(I, J)).
;; 13
%even_gen[aux]16ss:2, parents:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H), gender(I, H), gender(J, A), gender(K, Ego), gender(K, Alter), not(equal(I, J)).
;; 14
%even_gen[aux]16ss:2, parents:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H), gender(I, H), gender(J, A), gender(K, Ego), gender(K, Alter), not(equal(I, J)).
;; 15
%even_gen[aux]16ss:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(C, Alter).
;; 16
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 17
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(I, Alter).
;; 18
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(I, Alter).
;; 19
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 20
%even_gen[aux]16ss:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 21
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(F, Alter).
;; 22
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(I, Alter).
;; 23
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(I, Alter).
;; 24
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 25
%even_gen[aux]16ss:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(K, Alter).
;; 26
%even_gen[aux]16ss:2, parents:0, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H), gender(I, H), gender(J, A), gender(K, Ego), gender(K, Alter), not(equal(I, J)).
;; 27
%even_gen[aux]16ss:2, parents:0, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H), gender(I, H), gender(J, A), gender(K, Ego), gender(K, Alter), not(equal(I, J)).
;; 28
%even_gen[aux]16ss:2, parents:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H), gender(I, H), gender(J, A), gender(K, Ego), gender(K, Alter), not(equal(I, J)).
;; 29
%even_gen[aux]16ss:2, parents:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), child(Alter, H), gender(I, H), gender(J, A), gender(K, Ego), gender(K, Alter), not(equal(I, J)).


gen[aux]16(Alter, Ego) :-  sibling(Alter, Ego).
                       |   parents(A, Ego), gen[aux]16gs(B, A), child(Alter, B).
;; 0
%gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%gen[aux]16:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%gen[aux]16:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 4
%gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 5
%gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 6
%gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 7
%gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 8
%gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 9
%gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 10
%gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 11
%gen[aux]16:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 12
%gen[aux]16:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 13
%gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 14
%gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 15
%gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 16
%gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 17
%gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 18
%gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 19
%gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 20
%gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).


gen[aux]16gs(Alter, Ego) :-  siblings(Alter, Ego).
                         |   parents(A, Ego), gen[aux]16gs(B, A), children(Alter, B).
;; 0
%gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).
;; 2
%gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 3
%gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 4
%gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 5
%gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 6
%gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 7
%gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 8
%gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 9
%gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).


gen[aux]16small(Alter, Ego) :-  sibling(Alter, Ego).
                            |   parents(A, Ego), siblings(B, A), child(Alter, B).
;; 0
%gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 4
%gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).


gen[aux]16smallGS(Alter, Ego) :-  siblings(Alter, Ego).
                              |   parents(A, Ego), siblings(B, A), children(Alter, B).
;; 0
%gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).
;; 2
%gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 3
%gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 4
%gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 5
%gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 6
%gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 7
%gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 8
%gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 9
%gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).


half_brother(Alter, Ego) :-  mother(A, Ego), father(B, Ego), wife(C, B), son(Alter, C), son(Alter, B), not(equal(C, A)).
                         |   mother(A, Ego), father(B, Ego), husband(C, A), son(Alter, C), son(Alter, A), not(equal(C, B)).
;; 0
%half_brother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), wife(C, B), son(Alter, C), son(Alter, B), not(equal(C, A)).
;; 1
%half_brother:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), husband(C, A), son(Alter, C), son(Alter, A), not(equal(C, B)).


half_sister(Alter, Ego) :-  mother(A, Ego), father(B, Ego), wife(C, B), daughter(Alter, C), daughter(Alter, B), not(equal(C, A)).
                        |   mother(A, Ego), father(B, Ego), husband(C, A), daughter(Alter, C), daughter(Alter, A), not(equal(C, B)).
;; 0
%half_sister:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), wife(C, B), daughter(Alter, C), daughter(Alter, B), not(equal(C, A)).
;; 1
%half_sister:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), husband(C, A), daughter(Alter, C), daughter(Alter, A), not(equal(C, B)).


jiani(Alter, Ego) :-  para_dn1[aux]16(Alter, Ego), male(Alter).
                  |  [ext],  spice(A, Ego), cross_dn1[aux]16(Alter, A), male(Alter).
                  |  [ext],  cross_dn1[aux]16(A, Ego), husband(Alter, A).
{"BroDaHu_BroSo_FaBroDaDaHu_FaBroDaSo_FaBroSoDaHu_FaBroSoSo_FaFaBroDaDaDaHu_FaFaBroDaDaSo_FaFaBroDaSoDaHu_FaFaBroDaSoSo_FaFaBroSoDaDaHu_FaFaBroSoSoDaHu_FaFaSisDaDaDaHu_FaFaSisDaDaSo_FaFaSisDaSoDaHu_FaFaSisDaSoSo_FaFaSisSoDaSo_FaFaSisSoSoSo_FaMoBroDaDaDaHu_FaMoBroDaDaSo_FaMoBroDaSoDaHu_FaMoBroDaSoSo_FaMoBroSoDaSo_FaMoBroSoSoSo_FaMoSisDaDaDaHu_FaMoSisDaDaSo_FaMoSisDaSoDaHu_FaMoSisDaSoSo_FaMoSisSoDaDaHu_FaMoSisSoSoDaHu_FaSisDaDaHu_FaSisDaSo_FaSisSoDaHu_FaSisSoSo_HuFaBroDaSo_HuFaSisSoSo_HuMoBroSoSo_HuMoSisDaSo_HuSisSo_MoBroDaDaHu_MoBroDaSo_MoBroSoDaHu_MoBroSoSo_MoFaBroDaDaDaHu_MoFaBroDaSoDaHu_MoFaBroSoDaDaHu_MoFaBroSoDaSo_MoFaBroSoSoDaHu_MoFaBroSoSoSo_MoFaSisDaDaSo_MoFaSisDaSoSo_MoFaSisSoDaDaHu_MoFaSisSoDaSo_MoFaSisSoSoDaHu_MoFaSisSoSoSo_MoMoBroDaDaSo_MoMoBroDaSoSo_MoMoBroSoDaDaHu_MoMoBroSoDaSo_MoMoBroSoSoDaHu_MoMoBroSoSoSo_MoMoSisDaDaDaHu_MoMoSisDaSoDaHu_MoMoSisSoDaDaHu_MoMoSisSoDaSo_MoMoSisSoSoDaHu_MoMoSisSoSoSo_MoSisDaDaHu_MoSisDaSo_MoSisSoDaHu_MoSisSoSo_SisDaHu_SisSo_WiBroSo_WiFaBroSoSo_WiFaSisDaSo_WiMoBroDaSo_WiMoSisSoSo"}
;; 0
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {BroSo}  
 male(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(D, Ego), male(Alter).
;; 1
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisSoSo}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego), male(Alter).
;; 2
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaSoSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), male(Alter).
;; 3
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaSoSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), male(Alter).
;; 4
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroSoSo}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego), male(Alter).
;; 5
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoSoSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), male(Alter).
;; 6
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoSoSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), male(Alter).
;; 7
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisDaSo}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)), male(Alter).
;; 8
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroDaDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 9
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisDaDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 10
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 11
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 12
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroDaSo}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)), male(Alter).
;; 13
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroSoDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 14
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisSoDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 15
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 16
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 17
%jiani:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {HuSisSo}  
[ext],  husband(A, Ego), parent(B, Alter), mother(C, B), father(D, B), child(A, C), child(A, D), not(equal(A, B)), gender(E, B), gender(F, A), not(equal(E, F)), male(Alter).
;; 18
%jiani:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaSisSoSo}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(I, A), male(Alter).
;; 19
%jiani:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoBroSoSo}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(I, A), male(Alter).
;; 20
%jiani:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoSisDaSo}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(I, A), not(equal(H, I)), male(Alter).
;; 21
%jiani:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaBroDaSo}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(I, A), not(equal(H, I)), male(Alter).
;; 22
%jiani:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {WiBroSo}  
[ext],  wife(A, Ego), parent(B, Alter), mother(C, B), father(D, B), child(A, C), child(A, D), not(equal(A, B)), gender(E, B), gender(F, A), not(equal(E, F)), male(Alter).
;; 23
%jiani:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaSisDaSo}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(I, A), male(Alter).
;; 24
%jiani:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoBroDaSo}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(I, A), male(Alter).
;; 25
%jiani:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoSisSoSo}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(I, A), not(equal(H, I)), male(Alter).
;; 26
%jiani:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaBroSoSo}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(I, A), not(equal(H, I)), male(Alter).
;; 27
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {SisDaHu}  
[ext],  male(Ego), parent(A, B), mother(C, A), father(D, A), child(Ego, C), child(Ego, D), not(equal(Ego, A)), gender(E, A), gender(F, Ego), not(equal(E, F)), husband(Alter, B).
;; 28
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisSoDaHu}  
[ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(I, Ego), husband(Alter, B).
;; 29
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisDaSoDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), husband(Alter, B).
;; 30
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroDaSoDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), husband(Alter, B).
;; 31
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroSoDaHu}  
[ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(I, Ego), husband(Alter, B).
;; 32
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisSoSoDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), husband(Alter, B).
;; 33
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroSoSoDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), husband(Alter, B).
;; 34
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisDaDaHu}  
[ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(I, Ego), not(equal(H, I)), husband(Alter, B).
;; 35
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisDaDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), husband(Alter, B).
;; 36
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroDaDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), husband(Alter, B).
;; 37
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroDaDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), husband(Alter, B).
;; 38
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisDaDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), husband(Alter, B).
;; 39
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroDaDaHu}  
[ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(I, Ego), not(equal(H, I)), husband(Alter, B).
;; 40
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisSoDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), husband(Alter, B).
;; 41
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroSoDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), husband(Alter, B).
;; 42
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroSoDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), husband(Alter, B).
;; 43
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisSoDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), husband(Alter, B).
;; 44
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {SisSo}  
 female(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(D, Ego), male(Alter).
;; 45
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisDaSo}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego), male(Alter).
;; 46
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaDaSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), male(Alter).
;; 47
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaDaSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), male(Alter).
;; 48
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroDaSo}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego), male(Alter).
;; 49
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoDaSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), male(Alter).
;; 50
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoDaSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), male(Alter).
;; 51
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisSoSo}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)), male(Alter).
;; 52
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroDaSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 53
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisDaSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 54
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 55
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 56
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroSoSo}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)), male(Alter).
;; 57
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroSoSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 58
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisSoSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 59
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 60
%jiani:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), male(Alter).
;; 61
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {BroDaHu}  
[ext],  female(Ego), parent(A, B), mother(C, A), father(D, A), child(Ego, C), child(Ego, D), not(equal(Ego, A)), gender(E, A), gender(F, Ego), not(equal(E, F)), husband(Alter, B).
;; 62
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisDaDaHu}  
[ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(I, Ego), husband(Alter, B).
;; 63
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisDaDaDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), husband(Alter, B).
;; 64
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroDaDaDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), husband(Alter, B).
;; 65
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroDaDaHu}  
[ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(I, Ego), husband(Alter, B).
;; 66
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisSoDaDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), husband(Alter, B).
;; 67
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroSoDaDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), husband(Alter, B).
;; 68
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisSoDaHu}  
[ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(I, Ego), not(equal(H, I)), husband(Alter, B).
;; 69
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisDaSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), husband(Alter, B).
;; 70
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroDaSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), husband(Alter, B).
;; 71
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroDaSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), husband(Alter, B).
;; 72
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisDaSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), husband(Alter, B).
;; 73
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroSoDaHu}  
[ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(I, Ego), not(equal(H, I)), husband(Alter, B).
;; 74
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisSoSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), husband(Alter, B).
;; 75
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroSoSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), husband(Alter, B).
;; 76
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroSoSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), husband(Alter, B).
;; 77
%jiani:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisSoSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), husband(Alter, B).


jianiyo(Alter, Ego) :-  para_dn1[aux]16(Alter, Ego), female(Alter).
                    |  [ext],  spice(A, Ego), cross_dn1[aux]16(Alter, A), female(Alter).
                    |  [ext],  cross_dn1[aux]16(A, Ego), wife(Alter, A).
{"BroDa_BroSoWi_FaBroDaDa_FaBroDaSoWi_FaBroSoDa_FaBroSoSoWi_FaFaBroDaDaDa_FaFaBroDaDaSoWi_FaFaBroDaSoDa_FaFaBroDaSoSoWi_FaFaBroSoDaSoWi_FaFaBroSoSoSoWi_FaFaSisDaDaDa_FaFaSisDaDaSoWi_FaFaSisDaSoDa_FaFaSisDaSoSoWi_FaFaSisSoDaDa_FaFaSisSoSoDa_FaMoBroDaDaDa_FaMoBroDaDaSoWi_FaMoBroDaSoDa_FaMoBroDaSoSoWi_FaMoBroSoDaDa_FaMoBroSoSoDa_FaMoSisDaDaDa_FaMoSisDaDaSoWi_FaMoSisDaSoDa_FaMoSisDaSoSoWi_FaMoSisSoDaSoWi_FaMoSisSoSoSoWi_FaSisDaDa_FaSisDaSoWi_FaSisSoDa_FaSisSoSoWi_HuFaBroDaDa_HuFaSisSoDa_HuMoBroSoDa_HuMoSisDaDa_HuSisDa_MoBroDaDa_MoBroDaSoWi_MoBroSoDa_MoBroSoSoWi_MoFaBroDaDaSoWi_MoFaBroDaSoSoWi_MoFaBroSoDaDa_MoFaBroSoDaSoWi_MoFaBroSoSoDa_MoFaBroSoSoSoWi_MoFaSisDaDaDa_MoFaSisDaSoDa_MoFaSisSoDaDa_MoFaSisSoDaSoWi_MoFaSisSoSoDa_MoFaSisSoSoSoWi_MoMoBroDaDaDa_MoMoBroDaSoDa_MoMoBroSoDaDa_MoMoBroSoDaSoWi_MoMoBroSoSoDa_MoMoBroSoSoSoWi_MoMoSisDaDaSoWi_MoMoSisDaSoSoWi_MoMoSisSoDaDa_MoMoSisSoDaSoWi_MoMoSisSoSoDa_MoMoSisSoSoSoWi_MoSisDaDa_MoSisDaSoWi_MoSisSoDa_MoSisSoSoWi_SisDa_SisSoWi_WiBroDa_WiFaBroSoDa_WiFaSisDaDa_WiMoBroDaDa_WiMoSisSoDa"}
;; 0
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {BroDa}  
 male(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(D, Ego), female(Alter).
;; 1
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisSoDa}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego), female(Alter).
;; 2
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaSoDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), female(Alter).
;; 3
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaSoDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), female(Alter).
;; 4
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroSoDa}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego), female(Alter).
;; 5
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoSoDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), female(Alter).
;; 6
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoSoDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), female(Alter).
;; 7
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisDaDa}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)), female(Alter).
;; 8
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroDaDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 9
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisDaDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 10
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 11
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 12
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroDaDa}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)), female(Alter).
;; 13
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroSoDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 14
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisSoDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 15
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 16
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoDaDa}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 17
%jianiyo:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {HuSisDa}  
[ext],  husband(A, Ego), parent(B, Alter), mother(C, B), father(D, B), child(A, C), child(A, D), not(equal(A, B)), gender(E, B), gender(F, A), not(equal(E, F)), female(Alter).
;; 18
%jianiyo:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaSisSoDa}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(I, A), female(Alter).
;; 19
%jianiyo:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoBroSoDa}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(I, A), female(Alter).
;; 20
%jianiyo:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoSisDaDa}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(I, A), not(equal(H, I)), female(Alter).
;; 21
%jianiyo:1, spice:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaBroDaDa}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(I, A), not(equal(H, I)), female(Alter).
;; 22
%jianiyo:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {WiBroDa}  
[ext],  wife(A, Ego), parent(B, Alter), mother(C, B), father(D, B), child(A, C), child(A, D), not(equal(A, B)), gender(E, B), gender(F, A), not(equal(E, F)), female(Alter).
;; 23
%jianiyo:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaSisDaDa}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(I, A), female(Alter).
;; 24
%jianiyo:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoBroDaDa}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(I, A), female(Alter).
;; 25
%jianiyo:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoSisSoDa}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(I, A), not(equal(H, I)), female(Alter).
;; 26
%jianiyo:1, spice:1, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaBroSoDa}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(I, A), not(equal(H, I)), female(Alter).
;; 27
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {SisSoWi}  
[ext],  male(Ego), parent(A, B), mother(C, A), father(D, A), child(Ego, C), child(Ego, D), not(equal(Ego, A)), gender(E, A), gender(F, Ego), not(equal(E, F)), wife(Alter, B).
;; 28
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisSoSoWi}  
[ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(I, Ego), wife(Alter, B).
;; 29
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisDaSoSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), wife(Alter, B).
;; 30
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroDaSoSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), wife(Alter, B).
;; 31
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroSoSoWi}  
[ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(I, Ego), wife(Alter, B).
;; 32
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisSoSoSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), wife(Alter, B).
;; 33
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroSoSoSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), wife(Alter, B).
;; 34
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisDaSoWi}  
[ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(I, Ego), not(equal(H, I)), wife(Alter, B).
;; 35
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisDaDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), wife(Alter, B).
;; 36
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroDaDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), wife(Alter, B).
;; 37
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroDaDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), wife(Alter, B).
;; 38
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisDaDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), wife(Alter, B).
;; 39
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroDaSoWi}  
[ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(I, Ego), not(equal(H, I)), wife(Alter, B).
;; 40
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisSoDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), wife(Alter, B).
;; 41
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroSoDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), wife(Alter, B).
;; 42
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroSoDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), wife(Alter, B).
;; 43
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisSoDaSoWi}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), wife(Alter, B).
;; 44
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {SisDa}  
 female(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(D, Ego), female(Alter).
;; 45
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisDaDa}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego), female(Alter).
;; 46
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaDaDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), female(Alter).
;; 47
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaDaDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), female(Alter).
;; 48
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroDaDa}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego), female(Alter).
;; 49
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoDaDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), female(Alter).
;; 50
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoDaDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego), female(Alter).
;; 51
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisSoDa}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)), female(Alter).
;; 52
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroDaSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 53
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisDaSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 54
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 55
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 56
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroSoDa}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)), female(Alter).
;; 57
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroSoSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 58
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisSoSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 59
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 60
%jianiyo:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoSoDa}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)), female(Alter).
;; 61
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {BroSoWi}  
[ext],  female(Ego), parent(A, B), mother(C, A), father(D, A), child(Ego, C), child(Ego, D), not(equal(Ego, A)), gender(E, A), gender(F, Ego), not(equal(E, F)), wife(Alter, B).
;; 62
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisDaSoWi}  
[ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(I, Ego), wife(Alter, B).
;; 63
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisDaDaSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), wife(Alter, B).
;; 64
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroDaDaSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), wife(Alter, B).
;; 65
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroDaSoWi}  
[ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(I, Ego), wife(Alter, B).
;; 66
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisSoDaSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), wife(Alter, B).
;; 67
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroSoDaSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(L, Ego), wife(Alter, B).
;; 68
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisSoSoWi}  
[ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(I, Ego), not(equal(H, I)), wife(Alter, B).
;; 69
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisDaSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), wife(Alter, B).
;; 70
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroDaSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), wife(Alter, B).
;; 71
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroDaSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), wife(Alter, B).
;; 72
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisDaSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), wife(Alter, B).
;; 73
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroSoSoWi}  
[ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(I, Ego), not(equal(H, I)), wife(Alter, B).
;; 74
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisSoSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), wife(Alter, B).
;; 75
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroSoSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(J, C), child(Ego, E), gender(K, A), gender(L, Ego), not(equal(K, L)), wife(Alter, B).
;; 76
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroSoSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), wife(Alter, B).
;; 77
%jianiyo:2, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisSoSoSoWi}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(N, Ego), not(equal(M, N)), wife(Alter, B).


juyapijini(Alter, Ego) :-  sibling(Alter, Ego), male(Alter), younger(Alter, Ego).
                       |  [ext],  parents(A, Ego), even_gen[aux]16(B, A), child(Alter, B), male(Alter), younger(Alter, Ego).
                       |  [ext],  spice(A, Ego), sibling(B, A), husband(Alter, B), younger(Alter, Ego).
                       |  [ext],  spice(A, Ego), cross_cousin[aux]16(Alter, A), male(Alter), younger(Alter, Ego).
{"Bro_FaBroSo_FaFaBroSoSo_FaFaSisDaSo_FaMoBroDaSo_FaMoSisSoSo_FaSisDaHu_HuFaSisSo_HuMoBroSo_HuSisHu_MoBroDaHu_MoFaBroDaSo_MoFaSisSoSo_MoMoBroSoSo_MoMoSisDaSo_MoSisSo_WiFaSisSo_WiMoBroSo_WiSisHu"}
;; 0
%juyapijini:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Bro}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), younger(Alter, Ego).
;; 1
%juyapijini:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), child(Alter, D), male(Alter), younger(Alter, Ego).
;; 2
%juyapijini:1, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisDaSo}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), male(Alter), younger(Alter, Ego).
;; 3
%juyapijini:1, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroDaSo}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), male(Alter), younger(Alter, Ego).
;; 4
%juyapijini:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroSoSo}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), male(Alter), younger(Alter, Ego).
;; 5
%juyapijini:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisSoSo}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), male(Alter), younger(Alter, Ego).
;; 6
%juyapijini:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), child(Alter, D), male(Alter), younger(Alter, Ego).
;; 7
%juyapijini:1, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisSoSo}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), male(Alter), younger(Alter, Ego).
;; 8
%juyapijini:1, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroSoSo}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), male(Alter), younger(Alter, Ego).
;; 9
%juyapijini:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroDaSo}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), male(Alter), younger(Alter, Ego).
;; 10
%juyapijini:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisDaSo}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), male(Alter), younger(Alter, Ego).
;; 11
%juyapijini:2, spice:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuSisHu}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), husband(Alter, D), younger(Alter, Ego).
;; 12
%juyapijini:2, spice:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiSisHu}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), husband(Alter, D), younger(Alter, Ego).
;; 13
%juyapijini:3, spice:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuMoBroSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), male(Alter), younger(Alter, Ego).
;; 14
%juyapijini:3, spice:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuFaSisSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), male(Alter), younger(Alter, Ego).
;; 15
%juyapijini:3, spice:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {Bro}  
[ext], [ext],  husband(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter), younger(Alter, Ego).
;; 16
%juyapijini:3, spice:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuSisHu}  
[ext], [ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), spouse(Alter, D), male(Alter), younger(Alter, Ego).
;; 17
%juyapijini:3, spice:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {MoBroDaHu}  
[ext], [ext],  husband(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), male(Alter), younger(Alter, Ego).
;; 18
%juyapijini:3, spice:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {FaSisDaHu}  
[ext], [ext],  husband(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), male(Alter), younger(Alter, Ego).
;; 19
%juyapijini:3, spice:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoBroSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), male(Alter), younger(Alter, Ego).
;; 20
%juyapijini:3, spice:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaSisSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), male(Alter), younger(Alter, Ego).
;; 21
%juyapijini:3, spice:1, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {Bro}  
[ext], [ext],  wife(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter), younger(Alter, Ego).
;; 22
%juyapijini:3, spice:1, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiSisHu}  
[ext], [ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), spouse(Alter, D), male(Alter), younger(Alter, Ego).
;; 23
%juyapijini:3, spice:1, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {MoBroDaHu}  
[ext], [ext],  wife(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), male(Alter), younger(Alter, Ego).
;; 24
%juyapijini:3, spice:1, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {FaSisDaHu}  
[ext], [ext],  wife(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), male(Alter), younger(Alter, Ego).


juyapijiva(Alter, Ego) :-  sibling(Alter, Ego), female(Alter), younger(Alter, Ego).
                       |  [ext],  parents(A, Ego), even_gen[aux]16(B, A), child(Alter, B), female(Alter), younger(Alter, Ego).
                       |  [ext],  spice(A, Ego), sibling(B, A), wife(Alter, B), younger(Alter, Ego).
                       |  [ext],  spice(A, Ego), cross_cousin[aux]16(Alter, A), female(Alter), younger(Alter, Ego).
{"FaBroDa_FaFaBroSoDa_FaFaSisDaDa_FaMoBroDaDa_FaMoSisSoDa_FaSisSoWi_HuBroWi_HuFaSisDa_HuMoBroDa_MoBroSoWi_MoFaBroDaDa_MoFaSisSoDa_MoMoBroSoDa_MoMoSisDaDa_MoSisDa_Sis_WiBroWi_WiFaSisDa_WiMoBroDa"}
;; 0
%juyapijiva:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Sis}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), younger(Alter, Ego).
;; 1
%juyapijiva:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), child(Alter, D), female(Alter), younger(Alter, Ego).
;; 2
%juyapijiva:1, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisDaDa}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), female(Alter), younger(Alter, Ego).
;; 3
%juyapijiva:1, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroDaDa}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), female(Alter), younger(Alter, Ego).
;; 4
%juyapijiva:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroSoDa}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), female(Alter), younger(Alter, Ego).
;; 5
%juyapijiva:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisSoDa}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), female(Alter), younger(Alter, Ego).
;; 6
%juyapijiva:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), child(Alter, D), female(Alter), younger(Alter, Ego).
;; 7
%juyapijiva:1, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisSoDa}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), female(Alter), younger(Alter, Ego).
;; 8
%juyapijiva:1, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroSoDa}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), female(Alter), younger(Alter, Ego).
;; 9
%juyapijiva:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroDaDa}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), female(Alter), younger(Alter, Ego).
;; 10
%juyapijiva:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisDaDa}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), female(Alter), younger(Alter, Ego).
;; 11
%juyapijiva:2, spice:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuBroWi}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), wife(Alter, D), younger(Alter, Ego).
;; 12
%juyapijiva:2, spice:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiBroWi}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), wife(Alter, D), younger(Alter, Ego).
;; 13
%juyapijiva:3, spice:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuMoBroDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), female(Alter), younger(Alter, Ego).
;; 14
%juyapijiva:3, spice:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuFaSisDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), female(Alter), younger(Alter, Ego).
;; 15
%juyapijiva:3, spice:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {Sis}  
[ext], [ext],  husband(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter), younger(Alter, Ego).
;; 16
%juyapijiva:3, spice:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuBroWi}  
[ext], [ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), spouse(Alter, D), female(Alter), younger(Alter, Ego).
;; 17
%juyapijiva:3, spice:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {MoBroSoWi}  
[ext], [ext],  husband(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), female(Alter), younger(Alter, Ego).
;; 18
%juyapijiva:3, spice:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {FaSisSoWi}  
[ext], [ext],  husband(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), female(Alter), younger(Alter, Ego).
;; 19
%juyapijiva:3, spice:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoBroDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), female(Alter), younger(Alter, Ego).
;; 20
%juyapijiva:3, spice:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaSisDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), female(Alter), younger(Alter, Ego).
;; 21
%juyapijiva:3, spice:1, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {Sis}  
[ext], [ext],  wife(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter), younger(Alter, Ego).
;; 22
%juyapijiva:3, spice:1, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiBroWi}  
[ext], [ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), spouse(Alter, D), female(Alter), younger(Alter, Ego).
;; 23
%juyapijiva:3, spice:1, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {MoBroSoWi}  
[ext], [ext],  wife(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), female(Alter), younger(Alter, Ego).
;; 24
%juyapijiva:3, spice:1, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {FaSisSoWi}  
[ext], [ext],  wife(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), female(Alter), younger(Alter, Ego).


matapijini(Alter, Ego) :-  sibling(Alter, Ego), male(Alter), elder(Alter, Ego).
                       |  [ext],  parents(A, Ego), even_gen[aux]16(B, A), child(Alter, B), male(Alter), elder(Alter, Ego).
                       |  [ext],  spice(A, Ego), sibling(B, A), husband(Alter, B), elder(Alter, Ego).
                       |  [ext],  spice(A, Ego), cross_cousin[aux]16(Alter, A), male(Alter), elder(Alter, Ego).
{"Bro_FaBroSo_FaFaBroSoSo_FaFaSisDaSo_FaMoBroDaSo_FaMoSisSoSo_FaSisDaHu_HuFaSisSo_HuMoBroSo_HuSisHu_MoBroDaHu_MoFaBroDaSo_MoFaSisSoSo_MoMoBroSoSo_MoMoSisDaSo_MoSisSo_WiFaSisSo_WiMoBroSo_WiSisHu"}
;; 0
%matapijini:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Bro}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), elder(Alter, Ego).
;; 1
%matapijini:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), child(Alter, D), male(Alter), elder(Alter, Ego).
;; 2
%matapijini:1, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisDaSo}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), male(Alter), elder(Alter, Ego).
;; 3
%matapijini:1, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroDaSo}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), male(Alter), elder(Alter, Ego).
;; 4
%matapijini:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroSoSo}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), male(Alter), elder(Alter, Ego).
;; 5
%matapijini:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisSoSo}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), male(Alter), elder(Alter, Ego).
;; 6
%matapijini:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), child(Alter, D), male(Alter), elder(Alter, Ego).
;; 7
%matapijini:1, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisSoSo}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), male(Alter), elder(Alter, Ego).
;; 8
%matapijini:1, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroSoSo}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), male(Alter), elder(Alter, Ego).
;; 9
%matapijini:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroDaSo}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), male(Alter), elder(Alter, Ego).
;; 10
%matapijini:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisDaSo}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), male(Alter), elder(Alter, Ego).
;; 11
%matapijini:2, spice:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuSisHu}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), husband(Alter, D), elder(Alter, Ego).
;; 12
%matapijini:2, spice:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiSisHu}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), husband(Alter, D), elder(Alter, Ego).
;; 13
%matapijini:3, spice:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuMoBroSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), male(Alter), elder(Alter, Ego).
;; 14
%matapijini:3, spice:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuFaSisSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), male(Alter), elder(Alter, Ego).
;; 15
%matapijini:3, spice:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {Bro}  
[ext], [ext],  husband(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter), elder(Alter, Ego).
;; 16
%matapijini:3, spice:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuSisHu}  
[ext], [ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), spouse(Alter, D), male(Alter), elder(Alter, Ego).
;; 17
%matapijini:3, spice:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {MoBroDaHu}  
[ext], [ext],  husband(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), male(Alter), elder(Alter, Ego).
;; 18
%matapijini:3, spice:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {FaSisDaHu}  
[ext], [ext],  husband(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), male(Alter), elder(Alter, Ego).
;; 19
%matapijini:3, spice:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoBroSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), male(Alter), elder(Alter, Ego).
;; 20
%matapijini:3, spice:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaSisSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), male(Alter), elder(Alter, Ego).
;; 21
%matapijini:3, spice:1, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {Bro}  
[ext], [ext],  wife(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter), elder(Alter, Ego).
;; 22
%matapijini:3, spice:1, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiSisHu}  
[ext], [ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), spouse(Alter, D), male(Alter), elder(Alter, Ego).
;; 23
%matapijini:3, spice:1, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {MoBroDaHu}  
[ext], [ext],  wife(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), male(Alter), elder(Alter, Ego).
;; 24
%matapijini:3, spice:1, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {FaSisDaHu}  
[ext], [ext],  wife(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), male(Alter), elder(Alter, Ego).


matapijiva(Alter, Ego) :-  sibling(Alter, Ego), female(Alter), elder(Alter, Ego).
                       |  [ext],  parents(A, Ego), even_gen[aux]16(B, A), child(Alter, B), female(Alter), elder(Alter, Ego).
                       |  [ext],  spice(A, Ego), sibling(B, A), wife(Alter, B), elder(Alter, Ego).
                       |  [ext],  spice(A, Ego), cross_cousin[aux]16(Alter, A), female(Alter), elder(Alter, Ego).
{"FaBroDa_FaFaBroSoDa_FaFaSisDaDa_FaMoBroDaDa_FaMoSisSoDa_FaSisSoWi_HuBroWi_HuFaSisDa_HuMoBroDa_MoBroSoWi_MoFaBroDaDa_MoFaSisSoDa_MoMoBroSoDa_MoMoSisDaDa_MoSisDa_Sis_WiBroWi_WiFaSisDa_WiMoBroDa"}
;; 0
%matapijiva:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Sis}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), elder(Alter, Ego).
;; 1
%matapijiva:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), child(Alter, D), female(Alter), elder(Alter, Ego).
;; 2
%matapijiva:1, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisDaDa}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), female(Alter), elder(Alter, Ego).
;; 3
%matapijiva:1, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroDaDa}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), female(Alter), elder(Alter, Ego).
;; 4
%matapijiva:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroSoDa}  
[ext], [ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), female(Alter), elder(Alter, Ego).
;; 5
%matapijiva:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisSoDa}  
[ext], [ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), female(Alter), elder(Alter, Ego).
;; 6
%matapijiva:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(E, D), child(Alter, D), female(Alter), elder(Alter, Ego).
;; 7
%matapijiva:1, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisSoDa}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), female(Alter), elder(Alter, Ego).
;; 8
%matapijiva:1, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroSoDa}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(G, D), gender(H, A), gender(H, G), child(Alter, G), female(Alter), elder(Alter, Ego).
;; 9
%matapijiva:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroDaDa}  
[ext], [ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), female(Alter), elder(Alter, Ego).
;; 10
%matapijiva:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisDaDa}  
[ext], [ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(H, D), gender(I, A), gender(J, H), not(equal(I, J)), child(Alter, H), female(Alter), elder(Alter, Ego).
;; 11
%matapijiva:2, spice:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuBroWi}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), wife(Alter, D), elder(Alter, Ego).
;; 12
%matapijiva:2, spice:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiBroWi}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), wife(Alter, D), elder(Alter, Ego).
;; 13
%matapijiva:3, spice:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuMoBroDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), female(Alter), elder(Alter, Ego).
;; 14
%matapijiva:3, spice:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuFaSisDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), female(Alter), elder(Alter, Ego).
;; 15
%matapijiva:3, spice:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {Sis}  
[ext], [ext],  husband(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter), elder(Alter, Ego).
;; 16
%matapijiva:3, spice:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuBroWi}  
[ext], [ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), spouse(Alter, D), female(Alter), elder(Alter, Ego).
;; 17
%matapijiva:3, spice:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {MoBroSoWi}  
[ext], [ext],  husband(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), female(Alter), elder(Alter, Ego).
;; 18
%matapijiva:3, spice:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {FaSisSoWi}  
[ext], [ext],  husband(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), female(Alter), elder(Alter, Ego).
;; 19
%matapijiva:3, spice:1, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoBroDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), female(Alter), elder(Alter, Ego).
;; 20
%matapijiva:3, spice:1, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaSisDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(Alter, E), female(Alter), elder(Alter, Ego).
;; 21
%matapijiva:3, spice:1, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {Sis}  
[ext], [ext],  wife(A, Ego), spouse(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter), elder(Alter, Ego).
;; 22
%matapijiva:3, spice:1, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiBroWi}  
[ext], [ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), spouse(Alter, D), female(Alter), elder(Alter, Ego).
;; 23
%matapijiva:3, spice:1, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {MoBroSoWi}  
[ext], [ext],  wife(A, Ego), spouse(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), female(Alter), elder(Alter, Ego).
;; 24
%matapijiva:3, spice:1, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=6, S=3, Star=0,  {FaSisSoWi}  
[ext], [ext],  wife(A, Ego), spouse(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), gender(G, C), gender(H, F), not(equal(G, H)), child(I, F), spouse(Alter, I), female(Alter), elder(Alter, Ego).


momo(Alter, Ego) :-  two_gen[aux]16(Ego, Alter), male(Alter).
                 |   male(Ego), spousal_two_gen[aux]16gn(Ego, Alter), male(Alter).
                 |   female(Ego), spousal_two_gen[aux]16gn(Ego, Alter), male(Alter).
{"BroDaDaHu_BroDaSo_BroSoDaHu_BroSoSo_DaDaHu_DaSo_FaBroDaDaDaHu_FaBroDaDaSo_FaBroDaSoDaHu_FaBroDaSoSo_FaBroSoDaDaHu_FaBroSoDaSo_FaBroSoSoDaHu_FaBroSoSoSo_FaSisDaDaDaHu_FaSisDaDaSo_FaSisDaSoDaHu_FaSisDaSoSo_FaSisSoDaDaHu_FaSisSoDaSo_FaSisSoSoDaHu_FaSisSoSoSo_HuBroDaSo_HuBroSoSo_HuFaBroDaDaSo_HuFaBroDaSoSo_HuFaBroSoDaSo_HuFaBroSoSoSo_HuFaSisDaDaSo_HuFaSisDaSoSo_HuFaSisSoDaSo_HuFaSisSoSoSo_HuMoBroDaDaSo_HuMoBroDaSoSo_HuMoBroSoDaSo_HuMoBroSoSoSo_HuMoSisDaDaSo_HuMoSisDaSoSo_HuMoSisSoDaSo_HuMoSisSoSoSo_HuSisDaSo_HuSisSoSo_MoBroDaDaDaHu_MoBroDaDaSo_MoBroDaSoDaHu_MoBroDaSoSo_MoBroSoDaDaHu_MoBroSoDaSo_MoBroSoSoDaHu_MoBroSoSoSo_MoSisDaDaDaHu_MoSisDaDaSo_MoSisDaSoDaHu_MoSisDaSoSo_MoSisSoDaDaHu_MoSisSoDaSo_MoSisSoSoDaHu_MoSisSoSoSo_SisDaDaHu_SisDaSo_SisSoDaHu_SisSoSo_SoDaHu_SoSo_WiBroDaSo_WiBroSoSo_WiFaBroDaDaSo_WiFaBroDaSoSo_WiFaBroSoDaSo_WiFaBroSoSoSo_WiFaSisDaDaSo_WiFaSisDaSoSo_WiFaSisSoDaSo_WiFaSisSoSoSo_WiMoBroDaDaSo_WiMoBroDaSoSo_WiMoBroSoDaSo_WiMoBroSoSoSo_WiMoSisDaDaSo_WiMoSisDaSoSo_WiMoSisSoDaSo_WiMoSisSoSoSo_WiSisDaSo_WiSisSoSo"}
;; 0
%momo:0, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {DaSo}  
 mother(A, Alter), parent(Ego, A), male(Alter).
;; 1
%momo:0, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {SoSo}  
 father(A, Alter), parent(Ego, A), male(Alter).
;; 2
%momo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisDaSo}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Alter).
;; 3
%momo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaDaSo}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Alter).
;; 4
%momo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaDaSo}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Alter).
;; 5
%momo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaDaSo}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Alter).
;; 6
%momo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaDaSo}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Alter).
;; 7
%momo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroDaSo}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Alter).
;; 8
%momo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoDaSo}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Alter).
;; 9
%momo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoDaSo}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Alter).
;; 10
%momo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoDaSo}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Alter).
;; 11
%momo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoDaSo}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Alter).
;; 12
%momo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisSoSo}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Alter).
;; 13
%momo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaSoSo}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Alter).
;; 14
%momo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaSoSo}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Alter).
;; 15
%momo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaSoSo}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Alter).
;; 16
%momo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaSoSo}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Alter).
;; 17
%momo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroSoSo}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Alter).
;; 18
%momo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoSoSo}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Alter).
;; 19
%momo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoSoSo}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Alter).
;; 20
%momo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoSoSo}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), male(Alter).
;; 21
%momo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoSoSo}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), male(Alter).
;; 22
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {DaDaHu}  
 male(Ego), spouse(A, Alter), mother(B, A), parent(Ego, B), male(Alter).
;; 23
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {SoDaHu}  
 male(Ego), spouse(A, Alter), father(B, A), parent(Ego, B), male(Alter).
;; 24
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {SisDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Alter).
;; 25
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisDaDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 26
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisDaDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 27
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroDaDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 28
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroDaDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 29
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {BroDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Alter).
;; 30
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisSoDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 31
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisSoDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 32
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroSoDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 33
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroSoDaDaHu}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 34
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {SisSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Alter).
;; 35
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisDaSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 36
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisDaSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 37
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroDaSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 38
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroDaSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 39
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {BroSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Alter).
;; 40
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisSoSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 41
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisSoSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 42
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroSoSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 43
%momo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroSoSoDaHu}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 44
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {DaSo}  
 male(Ego), mother(A, Alter), parent(B, A), spouse(Ego, B), male(Alter).
;; 45
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {SoSo}  
 male(Ego), father(A, Alter), parent(B, A), spouse(Ego, B), male(Alter).
;; 46
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {WiSisDaSo}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Alter).
;; 47
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaSisDaDaSo}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 48
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoSisDaDaSo}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 49
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaBroDaDaSo}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 50
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoBroDaDaSo}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 51
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {WiBroDaSo}  
[ext],  male(Ego), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Alter).
;; 52
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaSisSoDaSo}  
[ext],  male(Ego), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 53
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoSisSoDaSo}  
[ext],  male(Ego), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 54
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaBroSoDaSo}  
[ext],  male(Ego), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 55
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoBroSoDaSo}  
[ext],  male(Ego), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 56
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {WiSisSoSo}  
[ext],  male(Ego), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Alter).
;; 57
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaSisDaSoSo}  
[ext],  male(Ego), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 58
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoSisDaSoSo}  
[ext],  male(Ego), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 59
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaBroDaSoSo}  
[ext],  male(Ego), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 60
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoBroDaSoSo}  
[ext],  male(Ego), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 61
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {WiBroSoSo}  
[ext],  male(Ego), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Alter).
;; 62
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaSisSoSoSo}  
[ext],  male(Ego), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 63
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoSisSoSoSo}  
[ext],  male(Ego), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 64
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaBroSoSoSo}  
[ext],  male(Ego), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 65
%momo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoBroSoSoSo}  
[ext],  male(Ego), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 66
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {DaDaHu}  
 female(Ego), spouse(A, Alter), mother(B, A), parent(Ego, B), male(Alter).
;; 67
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {SoDaHu}  
 female(Ego), spouse(A, Alter), father(B, A), parent(Ego, B), male(Alter).
;; 68
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {SisDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Alter).
;; 69
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisDaDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 70
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisDaDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 71
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroDaDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 72
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroDaDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 73
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {BroDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Alter).
;; 74
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisSoDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 75
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisSoDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 76
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroSoDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 77
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroSoDaDaHu}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 78
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {SisSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Alter).
;; 79
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisDaSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 80
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisDaSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 81
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroDaSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 82
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroDaSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 83
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {BroSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), male(Alter).
;; 84
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisSoSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 85
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisSoSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 86
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroSoSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), male(Alter).
;; 87
%momo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroSoSoDaHu}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), male(Alter).
;; 88
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {DaSo}  
 female(Ego), mother(A, Alter), parent(B, A), spouse(Ego, B), male(Alter).
;; 89
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {SoSo}  
 female(Ego), father(A, Alter), parent(B, A), spouse(Ego, B), male(Alter).
;; 90
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {HuSisDaSo}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Alter).
;; 91
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaSisDaDaSo}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 92
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoSisDaDaSo}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 93
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaBroDaDaSo}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 94
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoBroDaDaSo}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 95
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {HuBroDaSo}  
[ext],  female(Ego), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Alter).
;; 96
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaSisSoDaSo}  
[ext],  female(Ego), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 97
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoSisSoDaSo}  
[ext],  female(Ego), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 98
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaBroSoDaSo}  
[ext],  female(Ego), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 99
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoBroSoDaSo}  
[ext],  female(Ego), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 100
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {HuSisSoSo}  
[ext],  female(Ego), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Alter).
;; 101
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaSisDaSoSo}  
[ext],  female(Ego), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 102
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoSisDaSoSo}  
[ext],  female(Ego), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 103
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaBroDaSoSo}  
[ext],  female(Ego), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 104
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoBroDaSoSo}  
[ext],  female(Ego), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 105
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {HuBroSoSo}  
[ext],  female(Ego), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), male(Alter).
;; 106
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaSisSoSoSo}  
[ext],  female(Ego), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 107
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoSisSoSoSo}  
[ext],  female(Ego), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).
;; 108
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaBroSoSoSo}  
[ext],  female(Ego), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), male(Alter).
;; 109
%momo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoBroSoSoSo}  
[ext],  female(Ego), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), male(Alter).


momoyo(Alter, Ego) :-  two_gen[aux]16(Ego, Alter), female(Alter).
                   |   male(Ego), spousal_two_gen[aux]16gn(Ego, Alter), female(Alter).
                   |   female(Ego), spousal_two_gen[aux]16gn(Ego, Alter), female(Alter).
{"BroDaDa_BroDaSoWi_BroSoDa_BroSoSoWi_DaDa_DaSoWi_FaBroDaDaDa_FaBroDaDaSoWi_FaBroDaSoDa_FaBroDaSoSoWi_FaBroSoDaDa_FaBroSoDaSoWi_FaBroSoSoDa_FaBroSoSoSoWi_FaSisDaDaDa_FaSisDaDaSoWi_FaSisDaSoDa_FaSisDaSoSoWi_FaSisSoDaDa_FaSisSoDaSoWi_FaSisSoSoDa_FaSisSoSoSoWi_HuBroDaDa_HuBroSoDa_HuFaBroDaDaDa_HuFaBroDaSoDa_HuFaBroSoDaDa_HuFaBroSoSoDa_HuFaSisDaDaDa_HuFaSisDaSoDa_HuFaSisSoDaDa_HuFaSisSoSoDa_HuMoBroDaDaDa_HuMoBroDaSoDa_HuMoBroSoDaDa_HuMoBroSoSoDa_HuMoSisDaDaDa_HuMoSisDaSoDa_HuMoSisSoDaDa_HuMoSisSoSoDa_HuSisDaDa_HuSisSoDa_MoBroDaDaDa_MoBroDaDaSoWi_MoBroDaSoDa_MoBroDaSoSoWi_MoBroSoDaDa_MoBroSoDaSoWi_MoBroSoSoDa_MoBroSoSoSoWi_MoSisDaDaDa_MoSisDaDaSoWi_MoSisDaSoDa_MoSisDaSoSoWi_MoSisSoDaDa_MoSisSoDaSoWi_MoSisSoSoDa_MoSisSoSoSoWi_SisDaDa_SisDaSoWi_SisSoDa_SisSoSoWi_SoDa_SoSoWi_WiBroDaDa_WiBroSoDa_WiFaBroDaDaDa_WiFaBroDaSoDa_WiFaBroSoDaDa_WiFaBroSoSoDa_WiFaSisDaDaDa_WiFaSisDaSoDa_WiFaSisSoDaDa_WiFaSisSoSoDa_WiMoBroDaDaDa_WiMoBroDaSoDa_WiMoBroSoDaDa_WiMoBroSoSoDa_WiMoSisDaDaDa_WiMoSisDaSoDa_WiMoSisSoDaDa_WiMoSisSoSoDa_WiSisDaDa_WiSisSoDa"}
;; 0
%momoyo:0, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {DaDa}  
 mother(A, Alter), parent(Ego, A), female(Alter).
;; 1
%momoyo:0, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {SoDa}  
 father(A, Alter), parent(Ego, A), female(Alter).
;; 2
%momoyo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisDaDa}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Alter).
;; 3
%momoyo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaDaDa}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Alter).
;; 4
%momoyo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaDaDa}  
[ext],  mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Alter).
;; 5
%momoyo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaDaDa}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Alter).
;; 6
%momoyo:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaDaDa}  
[ext],  mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Alter).
;; 7
%momoyo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroDaDa}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Alter).
;; 8
%momoyo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoDaDa}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Alter).
;; 9
%momoyo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoDaDa}  
[ext],  mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Alter).
;; 10
%momoyo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoDaDa}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Alter).
;; 11
%momoyo:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoDaDa}  
[ext],  mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Alter).
;; 12
%momoyo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisSoDa}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Alter).
;; 13
%momoyo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaSoDa}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Alter).
;; 14
%momoyo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaSoDa}  
[ext],  father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Alter).
;; 15
%momoyo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaSoDa}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Alter).
;; 16
%momoyo:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaSoDa}  
[ext],  father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Alter).
;; 17
%momoyo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroSoDa}  
[ext],  father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Alter).
;; 18
%momoyo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoSoDa}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Alter).
;; 19
%momoyo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoSoDa}  
[ext],  father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Alter).
;; 20
%momoyo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoSoDa}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Ego, F), female(Alter).
;; 21
%momoyo:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoSoDa}  
[ext],  father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Ego, F), female(Alter).
;; 22
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {DaSoWi}  
 male(Ego), spouse(A, Alter), mother(B, A), parent(Ego, B), female(Alter).
;; 23
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {SoSoWi}  
 male(Ego), spouse(A, Alter), father(B, A), parent(Ego, B), female(Alter).
;; 24
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {SisDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Alter).
;; 25
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisDaDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 26
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisDaDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 27
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroDaDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 28
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroDaDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 29
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {BroDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Alter).
;; 30
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisSoDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 31
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisSoDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 32
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroSoDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 33
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroSoDaSoWi}  
[ext],  male(Ego), spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 34
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {SisSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Alter).
;; 35
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisDaSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 36
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisDaSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 37
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroDaSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 38
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroDaSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 39
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {BroSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Alter).
;; 40
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisSoSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 41
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisSoSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 42
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroSoSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 43
%momoyo:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroSoSoSoWi}  
[ext],  male(Ego), spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 44
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {DaDa}  
 male(Ego), mother(A, Alter), parent(B, A), spouse(Ego, B), female(Alter).
;; 45
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {SoDa}  
 male(Ego), father(A, Alter), parent(B, A), spouse(Ego, B), female(Alter).
;; 46
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {WiSisDaDa}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Alter).
;; 47
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaSisDaDaDa}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 48
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoSisDaDaDa}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 49
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaBroDaDaDa}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 50
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoBroDaDaDa}  
[ext],  male(Ego), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 51
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {WiBroDaDa}  
[ext],  male(Ego), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Alter).
;; 52
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaSisSoDaDa}  
[ext],  male(Ego), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 53
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoSisSoDaDa}  
[ext],  male(Ego), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 54
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaBroSoDaDa}  
[ext],  male(Ego), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 55
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoBroSoDaDa}  
[ext],  male(Ego), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 56
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {WiSisSoDa}  
[ext],  male(Ego), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Alter).
;; 57
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaSisDaSoDa}  
[ext],  male(Ego), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 58
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoSisDaSoDa}  
[ext],  male(Ego), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 59
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaBroDaSoDa}  
[ext],  male(Ego), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 60
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoBroDaSoDa}  
[ext],  male(Ego), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 61
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {WiBroSoDa}  
[ext],  male(Ego), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Alter).
;; 62
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaSisSoSoDa}  
[ext],  male(Ego), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 63
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoSisSoSoDa}  
[ext],  male(Ego), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 64
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiFaBroSoSoDa}  
[ext],  male(Ego), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 65
%momoyo:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {WiMoBroSoSoDa}  
[ext],  male(Ego), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 66
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {DaSoWi}  
 female(Ego), spouse(A, Alter), mother(B, A), parent(Ego, B), female(Alter).
;; 67
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {SoSoWi}  
 female(Ego), spouse(A, Alter), father(B, A), parent(Ego, B), female(Alter).
;; 68
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {SisDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Alter).
;; 69
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisDaDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 70
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisDaDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 71
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroDaDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 72
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroDaDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 73
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {BroDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Alter).
;; 74
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisSoDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 75
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisSoDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 76
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroSoDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 77
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroSoDaSoWi}  
[ext],  female(Ego), spouse(A, Alter), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 78
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {SisSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Alter).
;; 79
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisDaSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 80
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisDaSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 81
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroDaSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 82
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroDaSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 83
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {BroSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(Ego, D), child(Ego, E), not(equal(Ego, C)), female(Alter).
;; 84
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaSisSoSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 85
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoSisSoSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 86
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {FaBroSoSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Ego, G), female(Alter).
;; 87
%momoyo:2, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {MoBroSoSoSoWi}  
[ext],  female(Ego), spouse(A, Alter), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Ego, G), female(Alter).
;; 88
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=-2,  PC=2, S=1, Star=0,  {DaDa}  
 female(Ego), mother(A, Alter), parent(B, A), spouse(Ego, B), female(Alter).
;; 89
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=-2,  PC=2, S=1, Star=0,  {SoDa}  
 female(Ego), father(A, Alter), parent(B, A), spouse(Ego, B), female(Alter).
;; 90
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {HuSisDaDa}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Alter).
;; 91
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaSisDaDaDa}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 92
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoSisDaDaDa}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 93
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaBroDaDaDa}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 94
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoBroDaDaDa}  
[ext],  female(Ego), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 95
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {HuBroDaDa}  
[ext],  female(Ego), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Alter).
;; 96
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaSisSoDaDa}  
[ext],  female(Ego), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 97
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoSisSoDaDa}  
[ext],  female(Ego), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 98
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaBroSoDaDa}  
[ext],  female(Ego), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 99
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoBroSoDaDa}  
[ext],  female(Ego), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 100
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {HuSisSoDa}  
[ext],  female(Ego), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Alter).
;; 101
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaSisDaSoDa}  
[ext],  female(Ego), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 102
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoSisDaSoDa}  
[ext],  female(Ego), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 103
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaBroDaSoDa}  
[ext],  female(Ego), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 104
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoBroDaSoDa}  
[ext],  female(Ego), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 105
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=-2,  PC=6, S=1, Star=0,  {HuBroSoDa}  
[ext],  female(Ego), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Ego, E), female(Alter).
;; 106
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaSisSoSoDa}  
[ext],  female(Ego), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 107
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoSisSoSoDa}  
[ext],  female(Ego), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).
;; 108
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuFaBroSoSoDa}  
[ext],  female(Ego), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Ego, G), female(Alter).
;; 109
%momoyo:2, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=8, S=1, Star=0,  {HuMoBroSoSoDa}  
[ext],  female(Ego), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Ego, G), female(Alter).


nave(Alter, Ego) :-  children(A, Ego), children(B, A), children(Alter, B).
                 |   children(A, Ego), children(B, A), children(C, B), spouse(Alter, C).
                 |   square[aux]16DNsmallGS(A, Ego), children(B, A), children(C, B), children(Alter, C), male(Ego).
                 |   square[aux]16DNsmallGS(A, Ego), children(B, A), children(C, B), children(D, C), spouse(Alter, D), male(Ego).
                 |   square[aux]16DNsmallGS(A, Ego), children(B, A), children(C, B), children(Alter, C), female(Ego).
                 |   square[aux]16DNsmallGS(A, Ego), children(B, A), children(C, B), children(D, C), spouse(Alter, D), female(Ego).
{"BroDaDaDa_BroDaDaDaDa_BroDaDaDaDaHu_BroDaDaDaHu_BroDaDaDaSo_BroDaDaDaSoWi_BroDaDaSo_BroDaDaSoDa_BroDaDaSoDaHu_BroDaDaSoSo_BroDaDaSoSoWi_BroDaDaSoWi_BroDaSoDa_BroDaSoDaDa_BroDaSoDaDaHu_BroDaSoDaHu_BroDaSoDaSo_BroDaSoDaSoWi_BroDaSoSo_BroDaSoSoDa_BroDaSoSoDaHu_BroDaSoSoSo_BroDaSoSoSoWi_BroDaSoSoWi_BroSoDaDa_BroSoDaDaDa_BroSoDaDaDaHu_BroSoDaDaHu_BroSoDaDaSo_BroSoDaDaSoWi_BroSoDaSo_BroSoDaSoDa_BroSoDaSoDaHu_BroSoDaSoSo_BroSoDaSoSoWi_BroSoDaSoWi_BroSoSoDa_BroSoSoDaDa_BroSoSoDaDaHu_BroSoSoDaHu_BroSoSoDaSo_BroSoSoDaSoWi_BroSoSoSo_BroSoSoSoDa_BroSoSoSoDaHu_BroSoSoSoSo_BroSoSoSoSoWi_BroSoSoSoWi_DaDaDa_DaDaDaDa_DaDaDaDaDa_DaDaDaDaDaHu_DaDaDaDaHu_DaDaDaDaSo_DaDaDaDaSoWi_DaDaDaHu_DaDaDaSo_DaDaDaSoDa_DaDaDaSoDaHu_DaDaDaSoSo_DaDaDaSoSoWi_DaDaDaSoWi_DaDaSo_DaDaSoDa_DaDaSoDaDa_DaDaSoDaDaHu_DaDaSoDaHu_DaDaSoDaSo_DaDaSoDaSoWi_DaDaSoSo_DaDaSoSoDa_DaDaSoSoDaHu_DaDaSoSoSo_DaDaSoSoSoWi_DaDaSoSoWi_DaDaSoWi_DaSoDa_DaSoDaDa_DaSoDaDaDa_DaSoDaDaDaHu_DaSoDaDaHu_DaSoDaDaSo_DaSoDaDaSoWi_DaSoDaHu_DaSoDaSo_DaSoDaSoDa_DaSoDaSoDaHu_DaSoDaSoSo_DaSoDaSoSoWi_DaSoDaSoWi_DaSoSo_DaSoSoDa_DaSoSoDaDa_DaSoSoDaDaHu_DaSoSoDaHu_DaSoSoDaSo_DaSoSoDaSoWi_DaSoSoSo_DaSoSoSoDa_DaSoSoSoDaHu_DaSoSoSoSo_DaSoSoSoSoWi_DaSoSoSoWi_DaSoSoWi_FaBroDaDaDaDa_FaBroDaDaDaSo_FaBroDaDaSoDa_FaBroDaDaSoSo_FaBroDaSoDaDa_FaBroDaSoDaSo_FaBroDaSoSoDa_FaBroDaSoSoSo_FaBroSoDaDaDa_FaBroSoDaDaSo_FaBroSoDaSoDa_FaBroSoDaSoSo_FaBroSoSoDaDa_FaBroSoSoDaSo_FaBroSoSoSoDa_FaBroSoSoSoSo_FaSisDaDaDaDa_FaSisDaDaDaSo_FaSisDaDaSoDa_FaSisDaDaSoSo_FaSisDaSoDaDa_FaSisDaSoDaSo_FaSisDaSoSoDa_FaSisDaSoSoSo_FaSisSoDaDaDa_FaSisSoDaDaSo_FaSisSoDaSoDa_FaSisSoDaSoSo_FaSisSoSoDaDa_FaSisSoSoDaSo_FaSisSoSoSoDa_FaSisSoSoSoSo_HuBroDaDaDaDa_HuBroDaDaDaDaHu_HuBroDaDaDaSo_HuBroDaDaDaSoWi_HuBroDaDaSoDa_HuBroDaDaSoDaHu_HuBroDaDaSoSo_HuBroDaDaSoSoWi_HuBroDaSoDaDa_HuBroDaSoDaDaHu_HuBroDaSoDaSo_HuBroDaSoDaSoWi_HuBroDaSoSoDa_HuBroDaSoSoDaHu_HuBroDaSoSoSo_HuBroDaSoSoSoWi_HuBroSoDaDaDa_HuBroSoDaDaDaHu_HuBroSoDaDaSo_HuBroSoDaDaSoWi_HuBroSoDaSoDa_HuBroSoDaSoDaHu_HuBroSoDaSoSo_HuBroSoDaSoSoWi_HuBroSoSoDaDa_HuBroSoSoDaDaHu_HuBroSoSoDaSo_HuBroSoSoDaSoWi_HuBroSoSoSoDa_HuBroSoSoSoDaHu_HuBroSoSoSoSo_HuBroSoSoSoSoWi_HuSisDaDaDaDa_HuSisDaDaDaDaHu_HuSisDaDaDaSo_HuSisDaDaDaSoWi_HuSisDaDaSoDa_HuSisDaDaSoDaHu_HuSisDaDaSoSo_HuSisDaDaSoSoWi_HuSisDaSoDaDa_HuSisDaSoDaDaHu_HuSisDaSoDaSo_HuSisDaSoDaSoWi_HuSisDaSoSoDa_HuSisDaSoSoDaHu_HuSisDaSoSoSo_HuSisDaSoSoSoWi_HuSisSoDaDaDa_HuSisSoDaDaDaHu_HuSisSoDaDaSo_HuSisSoDaDaSoWi_HuSisSoDaSoDa_HuSisSoDaSoDaHu_HuSisSoDaSoSo_HuSisSoDaSoSoWi_HuSisSoSoDaDa_HuSisSoSoDaDaHu_HuSisSoSoDaSo_HuSisSoSoDaSoWi_HuSisSoSoSoDa_HuSisSoSoSoDaHu_HuSisSoSoSoSo_HuSisSoSoSoSoWi_MoBroDaDaDaDa_MoBroDaDaDaSo_MoBroDaDaSoDa_MoBroDaDaSoSo_MoBroDaSoDaDa_MoBroDaSoDaSo_MoBroDaSoSoDa_MoBroDaSoSoSo_MoBroSoDaDaDa_MoBroSoDaDaSo_MoBroSoDaSoDa_MoBroSoDaSoSo_MoBroSoSoDaDa_MoBroSoSoDaSo_MoBroSoSoSoDa_MoBroSoSoSoSo_MoSisDaDaDaDa_MoSisDaDaDaSo_MoSisDaDaSoDa_MoSisDaDaSoSo_MoSisDaSoDaDa_MoSisDaSoDaSo_MoSisDaSoSoDa_MoSisDaSoSoSo_MoSisSoDaDaDa_MoSisSoDaDaSo_MoSisSoDaSoDa_MoSisSoDaSoSo_MoSisSoSoDaDa_MoSisSoSoDaSo_MoSisSoSoSoDa_MoSisSoSoSoSo_SisDaDaDa_SisDaDaDaDa_SisDaDaDaDaHu_SisDaDaDaHu_SisDaDaDaSo_SisDaDaDaSoWi_SisDaDaSo_SisDaDaSoDa_SisDaDaSoDaHu_SisDaDaSoSo_SisDaDaSoSoWi_SisDaDaSoWi_SisDaSoDa_SisDaSoDaDa_SisDaSoDaDaHu_SisDaSoDaHu_SisDaSoDaSo_SisDaSoDaSoWi_SisDaSoSo_SisDaSoSoDa_SisDaSoSoDaHu_SisDaSoSoSo_SisDaSoSoSoWi_SisDaSoSoWi_SisSoDaDa_SisSoDaDaDa_SisSoDaDaDaHu_SisSoDaDaHu_SisSoDaDaSo_SisSoDaDaSoWi_SisSoDaSo_SisSoDaSoDa_SisSoDaSoDaHu_SisSoDaSoSo_SisSoDaSoSoWi_SisSoDaSoWi_SisSoSoDa_SisSoSoDaDa_SisSoSoDaDaHu_SisSoSoDaHu_SisSoSoDaSo_SisSoSoDaSoWi_SisSoSoSo_SisSoSoSoDa_SisSoSoSoDaHu_SisSoSoSoSo_SisSoSoSoSoWi_SisSoSoSoWi_SoDaDa_SoDaDaDa_SoDaDaDaDa_SoDaDaDaDaHu_SoDaDaDaHu_SoDaDaDaSo_SoDaDaDaSoWi_SoDaDaHu_SoDaDaSo_SoDaDaSoDa_SoDaDaSoDaHu_SoDaDaSoSo_SoDaDaSoSoWi_SoDaDaSoWi_SoDaSo_SoDaSoDa_SoDaSoDaDa_SoDaSoDaDaHu_SoDaSoDaHu_SoDaSoDaSo_SoDaSoDaSoWi_SoDaSoSo_SoDaSoSoDa_SoDaSoSoDaHu_SoDaSoSoSo_SoDaSoSoSoWi_SoDaSoSoWi_SoDaSoWi_SoSoDa_SoSoDaDa_SoSoDaDaDa_SoSoDaDaDaHu_SoSoDaDaHu_SoSoDaDaSo_SoSoDaDaSoWi_SoSoDaHu_SoSoDaSo_SoSoDaSoDa_SoSoDaSoDaHu_SoSoDaSoSo_SoSoDaSoSoWi_SoSoDaSoWi_SoSoSo_SoSoSoDa_SoSoSoDaDa_SoSoSoDaDaHu_SoSoSoDaHu_SoSoSoDaSo_SoSoSoDaSoWi_SoSoSoSo_SoSoSoSoDa_SoSoSoSoDaHu_SoSoSoSoSo_SoSoSoSoSoWi_SoSoSoSoWi_SoSoSoWi_WiBroDaDaDaDa_WiBroDaDaDaDaHu_WiBroDaDaDaSo_WiBroDaDaDaSoWi_WiBroDaDaSoDa_WiBroDaDaSoDaHu_WiBroDaDaSoSo_WiBroDaDaSoSoWi_WiBroDaSoDaDa_WiBroDaSoDaDaHu_WiBroDaSoDaSo_WiBroDaSoDaSoWi_WiBroDaSoSoDa_WiBroDaSoSoDaHu_WiBroDaSoSoSo_WiBroDaSoSoSoWi_WiBroSoDaDaDa_WiBroSoDaDaDaHu_WiBroSoDaDaSo_WiBroSoDaDaSoWi_WiBroSoDaSoDa_WiBroSoDaSoDaHu_WiBroSoDaSoSo_WiBroSoDaSoSoWi_WiBroSoSoDaDa_WiBroSoSoDaDaHu_WiBroSoSoDaSo_WiBroSoSoDaSoWi_WiBroSoSoSoDa_WiBroSoSoSoDaHu_WiBroSoSoSoSo_WiBroSoSoSoSoWi_WiSisDaDaDaDa_WiSisDaDaDaDaHu_WiSisDaDaDaSo_WiSisDaDaDaSoWi_WiSisDaDaSoDa_WiSisDaDaSoDaHu_WiSisDaDaSoSo_WiSisDaDaSoSoWi_WiSisDaSoDaDa_WiSisDaSoDaDaHu_WiSisDaSoDaSo_WiSisDaSoDaSoWi_WiSisDaSoSoDa_WiSisDaSoSoDaHu_WiSisDaSoSoSo_WiSisDaSoSoSoWi_WiSisSoDaDaDa_WiSisSoDaDaDaHu_WiSisSoDaDaSo_WiSisSoDaDaSoWi_WiSisSoDaSoDa_WiSisSoDaSoDaHu_WiSisSoDaSoSo_WiSisSoDaSoSoWi_WiSisSoSoDaDa_WiSisSoSoDaDaHu_WiSisSoSoDaSo_WiSisSoSoDaSoWi_WiSisSoSoSoDa_WiSisSoSoSoDaHu_WiSisSoSoSoSo_WiSisSoSoSoSoWi"}
;; 0
%nave:0, children:0, children:0, children:0%
 Lvl=-3,  PC=3, S=0, Star=0,  {SoSoSo}  
 son(A, Ego), son(B, A), son(Alter, B).
;; 1
%nave:0, children:0, children:0, children:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {SoSoDa}  
 son(A, Ego), son(B, A), daughter(Alter, B).
;; 2
%nave:0, children:0, children:1, children:0%
 Lvl=-3,  PC=3, S=0, Star=0,  {SoDaSo}  
 son(A, Ego), daughter(B, A), son(Alter, B).
;; 3
%nave:0, children:0, children:1, children:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {SoDaDa}  
 son(A, Ego), daughter(B, A), daughter(Alter, B).
;; 4
%nave:0, children:1, children:0, children:0%
 Lvl=-3,  PC=3, S=0, Star=0,  {DaSoSo}  
 daughter(A, Ego), son(B, A), son(Alter, B).
;; 5
%nave:0, children:1, children:0, children:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {DaSoDa}  
 daughter(A, Ego), son(B, A), daughter(Alter, B).
;; 6
%nave:0, children:1, children:1, children:0%
 Lvl=-3,  PC=3, S=0, Star=0,  {DaDaSo}  
 daughter(A, Ego), daughter(B, A), son(Alter, B).
;; 7
%nave:0, children:1, children:1, children:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {DaDaDa}  
 daughter(A, Ego), daughter(B, A), daughter(Alter, B).
;; 8
%nave:1, children:0, children:0, children:0%
 Lvl=-3,  PC=3, S=1, Star=0,  {SoSoSoWi}  
 son(A, Ego), son(B, A), son(C, B), spouse(Alter, C).
;; 9
%nave:1, children:0, children:0, children:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {SoSoDaHu}  
 son(A, Ego), son(B, A), daughter(C, B), spouse(Alter, C).
;; 10
%nave:1, children:0, children:1, children:0%
 Lvl=-3,  PC=3, S=1, Star=0,  {SoDaSoWi}  
 son(A, Ego), daughter(B, A), son(C, B), spouse(Alter, C).
;; 11
%nave:1, children:0, children:1, children:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {SoDaDaHu}  
 son(A, Ego), daughter(B, A), daughter(C, B), spouse(Alter, C).
;; 12
%nave:1, children:1, children:0, children:0%
 Lvl=-3,  PC=3, S=1, Star=0,  {DaSoSoWi}  
 daughter(A, Ego), son(B, A), son(C, B), spouse(Alter, C).
;; 13
%nave:1, children:1, children:0, children:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {DaSoDaHu}  
 daughter(A, Ego), son(B, A), daughter(C, B), spouse(Alter, C).
;; 14
%nave:1, children:1, children:1, children:0%
 Lvl=-3,  PC=3, S=1, Star=0,  {DaDaSoWi}  
 daughter(A, Ego), daughter(B, A), son(C, B), spouse(Alter, C).
;; 15
%nave:1, children:1, children:1, children:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {DaDaDaHu}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), spouse(Alter, C).
;; 16
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroSoSoSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(E, D), son(Alter, E), male(Ego).
;; 17
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroSoSoDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(E, D), daughter(Alter, E), male(Ego).
;; 18
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroSoDaSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(E, D), son(Alter, E), male(Ego).
;; 19
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroSoDaDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(E, D), daughter(Alter, E), male(Ego).
;; 20
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroDaSoSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(E, D), son(Alter, E), male(Ego).
;; 21
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroDaSoDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(E, D), daughter(Alter, E), male(Ego).
;; 22
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroDaDaSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(E, D), son(Alter, E), male(Ego).
;; 23
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroDaDaDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(E, D), daughter(Alter, E), male(Ego).
;; 24
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisSoSoSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(E, D), son(Alter, E), male(Ego).
;; 25
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisSoSoDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(E, D), daughter(Alter, E), male(Ego).
;; 26
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisSoDaSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(E, D), son(Alter, E), male(Ego).
;; 27
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisSoDaDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(E, D), daughter(Alter, E), male(Ego).
;; 28
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisDaSoSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(E, D), son(Alter, E), male(Ego).
;; 29
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisDaSoDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(E, D), daughter(Alter, E), male(Ego).
;; 30
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisDaDaSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(E, D), son(Alter, E), male(Ego).
;; 31
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisDaDaDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(E, D), daughter(Alter, E), male(Ego).
;; 32
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoSoSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), son(Alter, G), male(Ego).
;; 33
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoSoSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 34
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoSoDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 35
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoSoDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 36
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoDaSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), son(Alter, G), male(Ego).
;; 37
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoDaSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 38
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoDaDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 39
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoDaDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 40
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaSoSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), son(Alter, G), male(Ego).
;; 41
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaSoSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 42
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaSoDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 43
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaSoDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 44
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaDaSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), son(Alter, G), male(Ego).
;; 45
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaDaSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 46
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaDaDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 47
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaDaDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 48
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoSoSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), son(Alter, G), male(Ego).
;; 49
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoSoSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 50
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoSoDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 51
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoSoDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 52
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoDaSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), son(Alter, G), male(Ego).
;; 53
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoDaSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 54
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoDaDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 55
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoDaDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 56
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaSoSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), son(Alter, G), male(Ego).
;; 57
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaSoSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 58
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaSoDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 59
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaSoDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 60
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaDaSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), son(Alter, G), male(Ego).
;; 61
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaDaSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 62
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaDaDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 63
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaDaDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 64
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoSoSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), son(Alter, G), male(Ego).
;; 65
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoSoSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 66
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoSoDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 67
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoSoDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 68
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoDaSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), son(Alter, G), male(Ego).
;; 69
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoDaSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 70
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoDaDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 71
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoDaDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 72
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaSoSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), son(Alter, G), male(Ego).
;; 73
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaSoSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 74
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaSoDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 75
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaSoDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 76
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaDaSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), son(Alter, G), male(Ego).
;; 77
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaDaSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 78
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaDaDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 79
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaDaDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 80
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoSoSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), son(Alter, G), male(Ego).
;; 81
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoSoSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 82
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoSoDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 83
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoSoDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 84
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoDaSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), son(Alter, G), male(Ego).
;; 85
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoDaSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 86
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoDaDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 87
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoDaDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 88
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaSoSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), son(Alter, G), male(Ego).
;; 89
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaSoSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 90
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaSoDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 91
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaSoDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 92
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaDaSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), son(Alter, G), male(Ego).
;; 93
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaDaSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), daughter(Alter, G), male(Ego).
;; 94
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaDaDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), son(Alter, G), male(Ego).
;; 95
%nave:2, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaDaDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), male(Ego).
;; 96
%nave:2, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoSoSo}  
 son(A, Ego), son(B, A), son(C, B), son(Alter, C), male(Ego).
;; 97
%nave:2, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoSoDa}  
 son(A, Ego), son(B, A), son(C, B), daughter(Alter, C), male(Ego).
;; 98
%nave:2, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoDaSo}  
 son(A, Ego), son(B, A), daughter(C, B), son(Alter, C), male(Ego).
;; 99
%nave:2, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoDaDa}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(Alter, C), male(Ego).
;; 100
%nave:2, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaSoSo}  
 son(A, Ego), daughter(B, A), son(C, B), son(Alter, C), male(Ego).
;; 101
%nave:2, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaSoDa}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(Alter, C), male(Ego).
;; 102
%nave:2, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaDaSo}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(Alter, C), male(Ego).
;; 103
%nave:2, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaDaDa}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(Alter, C), male(Ego).
;; 104
%nave:2, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoSoSo}  
 daughter(A, Ego), son(B, A), son(C, B), son(Alter, C), male(Ego).
;; 105
%nave:2, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoSoDa}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(Alter, C), male(Ego).
;; 106
%nave:2, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoDaSo}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(Alter, C), male(Ego).
;; 107
%nave:2, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoDaDa}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(Alter, C), male(Ego).
;; 108
%nave:2, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaSoSo}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(Alter, C), male(Ego).
;; 109
%nave:2, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaSoDa}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(Alter, C), male(Ego).
;; 110
%nave:2, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaDaSo}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(Alter, C), male(Ego).
;; 111
%nave:2, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaDaDa}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(Alter, C), male(Ego).
;; 112
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoSoSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(Alter, F), male(Ego).
;; 113
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoSoDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(Alter, F), male(Ego).
;; 114
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoDaSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(Alter, F), male(Ego).
;; 115
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoDaDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(Alter, F), male(Ego).
;; 116
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaSoSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(Alter, F), male(Ego).
;; 117
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaSoDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(Alter, F), male(Ego).
;; 118
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaDaSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(Alter, F), male(Ego).
;; 119
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaDaDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(Alter, F), male(Ego).
;; 120
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoSoSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(Alter, F), male(Ego).
;; 121
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoSoDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(Alter, F), male(Ego).
;; 122
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoDaSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(Alter, F), male(Ego).
;; 123
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoDaDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(Alter, F), male(Ego).
;; 124
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaSoSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(Alter, F), male(Ego).
;; 125
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaSoDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(Alter, F), male(Ego).
;; 126
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaDaSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(Alter, F), male(Ego).
;; 127
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaDaDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(Alter, F), male(Ego).
;; 128
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoSoSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 129
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoSoSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 130
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoSoDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 131
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoSoDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 132
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoDaSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 133
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoDaSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 134
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoDaDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 135
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoDaDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 136
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaSoSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 137
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaSoSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 138
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaSoDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 139
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaSoDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 140
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaDaSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 141
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaDaSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 142
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaDaDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 143
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaDaDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 144
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoSoSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 145
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoSoSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 146
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoSoDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 147
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoSoDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 148
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoDaSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 149
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoDaSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 150
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoDaDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 151
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoDaDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 152
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaSoSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 153
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaSoSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 154
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaSoDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 155
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaSoDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 156
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaDaSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 157
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaDaSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 158
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaDaDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 159
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaDaDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 160
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 161
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 162
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 163
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 164
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 165
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 166
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 167
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 168
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 169
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 170
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 171
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 172
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 173
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 174
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 175
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 176
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 177
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 178
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 179
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 180
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 181
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 182
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 183
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 184
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 185
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 186
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 187
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 188
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 189
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 190
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 191
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 192
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoSoSoSo}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), son(Alter, D), male(Ego).
;; 193
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoSoSoDa}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), daughter(Alter, D), male(Ego).
;; 194
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoSoDaSo}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), son(Alter, D), male(Ego).
;; 195
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoSoDaDa}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), daughter(Alter, D), male(Ego).
;; 196
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoDaSoSo}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), son(Alter, D), male(Ego).
;; 197
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoDaSoDa}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), daughter(Alter, D), male(Ego).
;; 198
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoDaDaSo}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), son(Alter, D), male(Ego).
;; 199
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoDaDaDa}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), daughter(Alter, D), male(Ego).
;; 200
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaSoSoSo}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), son(Alter, D), male(Ego).
;; 201
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaSoSoDa}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), daughter(Alter, D), male(Ego).
;; 202
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaSoDaSo}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), son(Alter, D), male(Ego).
;; 203
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaSoDaDa}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), daughter(Alter, D), male(Ego).
;; 204
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaDaSoSo}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), son(Alter, D), male(Ego).
;; 205
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaDaSoDa}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), daughter(Alter, D), male(Ego).
;; 206
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaDaDaSo}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), son(Alter, D), male(Ego).
;; 207
%nave:2, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaDaDaDa}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), daughter(Alter, D), male(Ego).
;; 208
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoSoSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(Alter, F), male(Ego).
;; 209
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoSoDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(Alter, F), male(Ego).
;; 210
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoDaSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(Alter, F), male(Ego).
;; 211
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoDaDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(Alter, F), male(Ego).
;; 212
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaSoSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(Alter, F), male(Ego).
;; 213
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaSoDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(Alter, F), male(Ego).
;; 214
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaDaSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(Alter, F), male(Ego).
;; 215
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaDaDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(Alter, F), male(Ego).
;; 216
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoSoSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(Alter, F), male(Ego).
;; 217
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoSoDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(Alter, F), male(Ego).
;; 218
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoDaSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(Alter, F), male(Ego).
;; 219
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoDaDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(Alter, F), male(Ego).
;; 220
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaSoSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(Alter, F), male(Ego).
;; 221
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaSoDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(Alter, F), male(Ego).
;; 222
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaDaSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(Alter, F), male(Ego).
;; 223
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaDaDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(Alter, F), male(Ego).
;; 224
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoSoSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 225
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoSoSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 226
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoSoDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 227
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoSoDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 228
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoDaSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 229
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoDaSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 230
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoDaDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 231
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroSoDaDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 232
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaSoSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 233
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaSoSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 234
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaSoDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 235
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaSoDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 236
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaDaSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 237
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaDaSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 238
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaDaDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 239
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiBroDaDaDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 240
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoSoSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 241
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoSoSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 242
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoSoDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 243
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoSoDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 244
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoDaSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 245
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoDaSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 246
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoDaDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 247
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisSoDaDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 248
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaSoSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 249
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaSoSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 250
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaSoDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 251
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaSoDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 252
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaDaSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 253
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaDaSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 254
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaDaDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 255
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {WiSisDaDaDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 256
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 257
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 258
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 259
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 260
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 261
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 262
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 263
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 264
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 265
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 266
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 267
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 268
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 269
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 270
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 271
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 272
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 273
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 274
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 275
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 276
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 277
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 278
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 279
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 280
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), male(Ego).
;; 281
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 282
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 283
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 284
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), male(Ego).
;; 285
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), male(Ego).
;; 286
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), male(Ego).
;; 287
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), male(Ego).
;; 288
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoSoSoSo}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), son(Alter, D), male(Ego).
;; 289
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoSoSoDa}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), daughter(Alter, D), male(Ego).
;; 290
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoSoDaSo}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), son(Alter, D), male(Ego).
;; 291
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoSoDaDa}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), daughter(Alter, D), male(Ego).
;; 292
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoDaSoSo}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), son(Alter, D), male(Ego).
;; 293
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoDaSoDa}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), daughter(Alter, D), male(Ego).
;; 294
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoDaDaSo}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), son(Alter, D), male(Ego).
;; 295
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoDaDaDa}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), daughter(Alter, D), male(Ego).
;; 296
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaSoSoSo}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), son(Alter, D), male(Ego).
;; 297
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaSoSoDa}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), daughter(Alter, D), male(Ego).
;; 298
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaSoDaSo}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), son(Alter, D), male(Ego).
;; 299
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaSoDaDa}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), daughter(Alter, D), male(Ego).
;; 300
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaDaSoSo}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), son(Alter, D), male(Ego).
;; 301
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaDaSoDa}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), daughter(Alter, D), male(Ego).
;; 302
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaDaDaSo}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), son(Alter, D), male(Ego).
;; 303
%nave:2, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaDaDaDa}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), daughter(Alter, D), male(Ego).
;; 304
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroSoSoSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(E, D), son(F, E), spouse(Alter, F), male(Ego).
;; 305
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroSoSoDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(E, D), daughter(F, E), spouse(Alter, F), male(Ego).
;; 306
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroSoDaSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(E, D), son(F, E), spouse(Alter, F), male(Ego).
;; 307
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroSoDaDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(E, D), daughter(F, E), spouse(Alter, F), male(Ego).
;; 308
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroDaSoSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(E, D), son(F, E), spouse(Alter, F), male(Ego).
;; 309
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroDaSoDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(E, D), daughter(F, E), spouse(Alter, F), male(Ego).
;; 310
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroDaDaSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(E, D), son(F, E), spouse(Alter, F), male(Ego).
;; 311
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroDaDaDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(E, D), daughter(F, E), spouse(Alter, F), male(Ego).
;; 312
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisSoSoSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(E, D), son(F, E), spouse(Alter, F), male(Ego).
;; 313
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisSoSoDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(E, D), daughter(F, E), spouse(Alter, F), male(Ego).
;; 314
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisSoDaSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(E, D), son(F, E), spouse(Alter, F), male(Ego).
;; 315
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisSoDaDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(E, D), daughter(F, E), spouse(Alter, F), male(Ego).
;; 316
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisDaSoSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(E, D), son(F, E), spouse(Alter, F), male(Ego).
;; 317
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisDaSoDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(E, D), daughter(F, E), spouse(Alter, F), male(Ego).
;; 318
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisDaDaSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(E, D), son(F, E), spouse(Alter, F), male(Ego).
;; 319
%nave:3, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisDaDaDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(E, D), daughter(F, E), spouse(Alter, F), male(Ego).
;; 320
%nave:3, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoSoSoWi}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), spouse(Alter, D), male(Ego).
;; 321
%nave:3, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoSoDaHu}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), spouse(Alter, D), male(Ego).
;; 322
%nave:3, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoDaSoWi}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), spouse(Alter, D), male(Ego).
;; 323
%nave:3, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoDaDaHu}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D), male(Ego).
;; 324
%nave:3, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaSoSoWi}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), spouse(Alter, D), male(Ego).
;; 325
%nave:3, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaSoDaHu}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), spouse(Alter, D), male(Ego).
;; 326
%nave:3, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaDaSoWi}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), spouse(Alter, D), male(Ego).
;; 327
%nave:3, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaDaDaHu}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D), male(Ego).
;; 328
%nave:3, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoSoSoWi}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), spouse(Alter, D), male(Ego).
;; 329
%nave:3, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoSoDaHu}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), spouse(Alter, D), male(Ego).
;; 330
%nave:3, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoDaSoWi}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), spouse(Alter, D), male(Ego).
;; 331
%nave:3, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoDaDaHu}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D), male(Ego).
;; 332
%nave:3, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaSoSoWi}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), spouse(Alter, D), male(Ego).
;; 333
%nave:3, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaSoDaHu}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), spouse(Alter, D), male(Ego).
;; 334
%nave:3, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaDaSoWi}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), spouse(Alter, D), male(Ego).
;; 335
%nave:3, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaDaDaHu}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D), male(Ego).
;; 336
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoSoSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 337
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoSoDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 338
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoDaSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 339
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoDaDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 340
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaSoSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 341
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaSoDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 342
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaDaSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 343
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaDaDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 344
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoSoSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 345
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoSoDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 346
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoDaSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 347
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoDaDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 348
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaSoSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 349
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaSoDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 350
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaDaSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 351
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaDaDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 352
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoSoSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 353
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoSoSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 354
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoSoDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 355
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoSoDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 356
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoDaSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 357
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoDaSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 358
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoDaDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 359
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoDaDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 360
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaSoSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 361
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaSoSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 362
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaSoDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 363
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaSoDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 364
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaDaSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 365
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaDaSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 366
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaDaDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 367
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaDaDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 368
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoSoSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 369
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoSoSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 370
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoSoDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 371
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoSoDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 372
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoDaSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 373
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoDaSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 374
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoDaDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 375
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoDaDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 376
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaSoSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 377
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaSoSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 378
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaSoDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 379
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaSoDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 380
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaDaSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 381
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaDaSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 382
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaDaDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 383
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaDaDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 384
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 385
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 386
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 387
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 388
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 389
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 390
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 391
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 392
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 393
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 394
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 395
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 396
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 397
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 398
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 399
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 400
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 401
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 402
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 403
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 404
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 405
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 406
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 407
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 408
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 409
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 410
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 411
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 412
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 413
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 414
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 415
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 416
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoSoSoSoWi}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 417
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoSoSoDaHu}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 418
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoSoDaSoWi}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 419
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoSoDaDaHu}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 420
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoDaSoSoWi}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 421
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoDaSoDaHu}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 422
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoDaDaSoWi}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 423
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoDaDaDaHu}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 424
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaSoSoSoWi}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 425
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaSoSoDaHu}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 426
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaSoDaSoWi}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 427
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaSoDaDaHu}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 428
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaDaSoSoWi}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 429
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaDaSoDaHu}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 430
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaDaDaSoWi}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 431
%nave:3, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaDaDaDaHu}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 432
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoSoSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 433
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoSoDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 434
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoDaSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 435
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoDaDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 436
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaSoSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 437
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaSoDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 438
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaDaSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 439
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaDaDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 440
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoSoSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 441
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoSoDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 442
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoDaSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 443
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoDaDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 444
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaSoSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 445
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaSoDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 446
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaDaSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), spouse(Alter, G), male(Ego).
;; 447
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaDaDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), male(Ego).
;; 448
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoSoSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 449
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoSoSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 450
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoSoDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 451
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoSoDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 452
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoDaSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 453
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoDaSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 454
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoDaDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 455
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroSoDaDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 456
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaSoSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 457
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaSoSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 458
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaSoDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 459
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaSoDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 460
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaDaSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 461
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaDaSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 462
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaDaDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 463
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiBroDaDaDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 464
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoSoSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 465
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoSoSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 466
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoSoDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 467
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoSoDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 468
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoDaSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 469
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoDaSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 470
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoDaDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 471
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisSoDaDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 472
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaSoSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 473
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaSoSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 474
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaSoDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 475
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaSoDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 476
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaDaSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 477
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaDaSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 478
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaDaDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 479
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {WiSisDaDaDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 480
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 481
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 482
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 483
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 484
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 485
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 486
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 487
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 488
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 489
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 490
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 491
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 492
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 493
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 494
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 495
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 496
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 497
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 498
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 499
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 500
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 501
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 502
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 503
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 504
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 505
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 506
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 507
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 508
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 509
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 510
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), male(Ego).
;; 511
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), male(Ego).
;; 512
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoSoSoSoWi}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 513
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoSoSoDaHu}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 514
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoSoDaSoWi}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 515
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoSoDaDaHu}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 516
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoDaSoSoWi}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 517
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoDaSoDaHu}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 518
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoDaDaSoWi}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 519
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoDaDaDaHu}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 520
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaSoSoSoWi}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 521
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaSoSoDaHu}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 522
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaSoDaSoWi}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 523
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaSoDaDaHu}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 524
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaDaSoSoWi}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 525
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaDaSoDaHu}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 526
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaDaDaSoWi}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), son(E, D), spouse(Alter, E), male(Ego).
;; 527
%nave:3, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaDaDaDaHu}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), male(Ego).
;; 528
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroSoSoSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(E, D), son(Alter, E), female(Ego).
;; 529
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroSoSoDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(E, D), daughter(Alter, E), female(Ego).
;; 530
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroSoDaSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(E, D), son(Alter, E), female(Ego).
;; 531
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroSoDaDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(E, D), daughter(Alter, E), female(Ego).
;; 532
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroDaSoSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(E, D), son(Alter, E), female(Ego).
;; 533
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroDaSoDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(E, D), daughter(Alter, E), female(Ego).
;; 534
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroDaDaSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(E, D), son(Alter, E), female(Ego).
;; 535
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {BroDaDaDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(E, D), daughter(Alter, E), female(Ego).
;; 536
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisSoSoSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(E, D), son(Alter, E), female(Ego).
;; 537
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisSoSoDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(E, D), daughter(Alter, E), female(Ego).
;; 538
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisSoDaSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(E, D), son(Alter, E), female(Ego).
;; 539
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisSoDaDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(E, D), daughter(Alter, E), female(Ego).
;; 540
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisDaSoSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(E, D), son(Alter, E), female(Ego).
;; 541
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisDaSoDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(E, D), daughter(Alter, E), female(Ego).
;; 542
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisDaDaSo}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(E, D), son(Alter, E), female(Ego).
;; 543
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-3,  PC=7, S=0, Star=0,  {SisDaDaDa}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(E, D), daughter(Alter, E), female(Ego).
;; 544
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoSoSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), son(Alter, G), female(Ego).
;; 545
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoSoSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 546
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoSoDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 547
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoSoDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 548
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoDaSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), son(Alter, G), female(Ego).
;; 549
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoDaSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 550
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoDaDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 551
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroSoDaDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 552
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaSoSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), son(Alter, G), female(Ego).
;; 553
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaSoSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 554
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaSoDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 555
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaSoDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 556
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaDaSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), son(Alter, G), female(Ego).
;; 557
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaDaSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 558
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaDaDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 559
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoBroDaDaDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 560
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoSoSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), son(Alter, G), female(Ego).
;; 561
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoSoSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 562
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoSoDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 563
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoSoDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 564
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoDaSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), son(Alter, G), female(Ego).
;; 565
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoDaSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 566
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoDaDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 567
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisSoDaDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 568
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaSoSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), son(Alter, G), female(Ego).
;; 569
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaSoSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 570
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaSoDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 571
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaSoDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 572
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaDaSoSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), son(Alter, G), female(Ego).
;; 573
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaDaSoDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 574
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaDaDaSo}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 575
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {MoSisDaDaDaDa}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 576
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoSoSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), son(Alter, G), female(Ego).
;; 577
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoSoSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 578
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoSoDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 579
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoSoDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 580
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoDaSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), son(Alter, G), female(Ego).
;; 581
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoDaSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 582
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoDaDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 583
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroSoDaDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 584
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaSoSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), son(Alter, G), female(Ego).
;; 585
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaSoSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 586
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaSoDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 587
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaSoDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 588
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaDaSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), son(Alter, G), female(Ego).
;; 589
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaDaSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 590
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaDaDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 591
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaBroDaDaDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 592
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoSoSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), son(Alter, G), female(Ego).
;; 593
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoSoSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 594
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoSoDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 595
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoSoDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 596
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoDaSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), son(Alter, G), female(Ego).
;; 597
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoDaSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 598
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoDaDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 599
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisSoDaDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 600
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaSoSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), son(Alter, G), female(Ego).
;; 601
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaSoSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 602
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaSoDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 603
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaSoDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 604
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaDaSoSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), son(Alter, G), female(Ego).
;; 605
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaDaSoDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), daughter(Alter, G), female(Ego).
;; 606
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaDaDaSo}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), son(Alter, G), female(Ego).
;; 607
%nave:4, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-3,  PC=9, S=0, Star=0,  {FaSisDaDaDaDa}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), daughter(Alter, G), female(Ego).
;; 608
%nave:4, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoSoSo}  
 son(A, Ego), son(B, A), son(C, B), son(Alter, C), female(Ego).
;; 609
%nave:4, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoSoDa}  
 son(A, Ego), son(B, A), son(C, B), daughter(Alter, C), female(Ego).
;; 610
%nave:4, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoDaSo}  
 son(A, Ego), son(B, A), daughter(C, B), son(Alter, C), female(Ego).
;; 611
%nave:4, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoDaDa}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(Alter, C), female(Ego).
;; 612
%nave:4, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaSoSo}  
 son(A, Ego), daughter(B, A), son(C, B), son(Alter, C), female(Ego).
;; 613
%nave:4, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaSoDa}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(Alter, C), female(Ego).
;; 614
%nave:4, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaDaSo}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(Alter, C), female(Ego).
;; 615
%nave:4, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaDaDa}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(Alter, C), female(Ego).
;; 616
%nave:4, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoSoSo}  
 daughter(A, Ego), son(B, A), son(C, B), son(Alter, C), female(Ego).
;; 617
%nave:4, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoSoDa}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(Alter, C), female(Ego).
;; 618
%nave:4, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoDaSo}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(Alter, C), female(Ego).
;; 619
%nave:4, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoDaDa}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(Alter, C), female(Ego).
;; 620
%nave:4, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaSoSo}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(Alter, C), female(Ego).
;; 621
%nave:4, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaSoDa}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(Alter, C), female(Ego).
;; 622
%nave:4, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaDaSo}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(Alter, C), female(Ego).
;; 623
%nave:4, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaDaDa}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(Alter, C), female(Ego).
;; 624
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoSoSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(Alter, F), female(Ego).
;; 625
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoSoDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(Alter, F), female(Ego).
;; 626
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoDaSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(Alter, F), female(Ego).
;; 627
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoDaDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(Alter, F), female(Ego).
;; 628
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaSoSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(Alter, F), female(Ego).
;; 629
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaSoDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(Alter, F), female(Ego).
;; 630
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaDaSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(Alter, F), female(Ego).
;; 631
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaDaDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(Alter, F), female(Ego).
;; 632
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoSoSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(Alter, F), female(Ego).
;; 633
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoSoDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(Alter, F), female(Ego).
;; 634
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoDaSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(Alter, F), female(Ego).
;; 635
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoDaDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(Alter, F), female(Ego).
;; 636
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaSoSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(Alter, F), female(Ego).
;; 637
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaSoDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(Alter, F), female(Ego).
;; 638
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaDaSo}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(Alter, F), female(Ego).
;; 639
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaDaDa}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(Alter, F), female(Ego).
;; 640
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 641
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 642
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 643
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 644
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 645
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 646
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 647
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 648
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 649
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 650
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 651
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 652
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 653
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 654
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 655
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 656
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 657
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 658
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 659
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 660
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 661
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 662
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 663
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 664
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 665
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 666
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 667
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 668
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaSoSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 669
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaSoDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 670
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaDaSo}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 671
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaDaDa}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 672
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoSoSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 673
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoSoSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 674
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoSoDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 675
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoSoDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 676
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoDaSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 677
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoDaSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 678
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoDaDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 679
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoDaDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 680
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaSoSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 681
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaSoSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 682
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaSoDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 683
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaSoDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 684
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaDaSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 685
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaDaSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 686
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaDaDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 687
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaDaDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 688
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoSoSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 689
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoSoSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 690
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoSoDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 691
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoSoDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 692
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoDaSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 693
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoDaSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 694
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoDaDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 695
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoDaDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 696
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaSoSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 697
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaSoSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 698
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaSoDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 699
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaSoDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 700
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaDaSoSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 701
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaDaSoDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 702
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaDaDaSo}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 703
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaDaDaDa}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 704
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoSoSoSo}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), son(Alter, D), female(Ego).
;; 705
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoSoSoDa}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), daughter(Alter, D), female(Ego).
;; 706
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoSoDaSo}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), son(Alter, D), female(Ego).
;; 707
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoSoDaDa}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), daughter(Alter, D), female(Ego).
;; 708
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoDaSoSo}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), son(Alter, D), female(Ego).
;; 709
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoDaSoDa}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), daughter(Alter, D), female(Ego).
;; 710
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoDaDaSo}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), son(Alter, D), female(Ego).
;; 711
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoSoDaDaDa}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), daughter(Alter, D), female(Ego).
;; 712
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaSoSoSo}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), son(Alter, D), female(Ego).
;; 713
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaSoSoDa}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), daughter(Alter, D), female(Ego).
;; 714
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaSoDaSo}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), son(Alter, D), female(Ego).
;; 715
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaSoDaDa}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), daughter(Alter, D), female(Ego).
;; 716
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaDaSoSo}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), son(Alter, D), female(Ego).
;; 717
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaDaSoDa}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), daughter(Alter, D), female(Ego).
;; 718
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaDaDaSo}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), son(Alter, D), female(Ego).
;; 719
%nave:4, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {SoDaDaDaDa}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), daughter(Alter, D), female(Ego).
;; 720
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoSoSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(Alter, F), female(Ego).
;; 721
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoSoDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(Alter, F), female(Ego).
;; 722
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoDaSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(Alter, F), female(Ego).
;; 723
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoSoDaDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(Alter, F), female(Ego).
;; 724
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaSoSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(Alter, F), female(Ego).
;; 725
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaSoDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(Alter, F), female(Ego).
;; 726
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaDaSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(Alter, F), female(Ego).
;; 727
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {SoDaDaDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(Alter, F), female(Ego).
;; 728
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoSoSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(Alter, F), female(Ego).
;; 729
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoSoDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(Alter, F), female(Ego).
;; 730
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoDaSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(Alter, F), female(Ego).
;; 731
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaSoDaDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(Alter, F), female(Ego).
;; 732
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaSoSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(Alter, F), female(Ego).
;; 733
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaSoDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(Alter, F), female(Ego).
;; 734
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaDaSo}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(Alter, F), female(Ego).
;; 735
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=0, Star=0,  {DaDaDaDa}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(Alter, F), female(Ego).
;; 736
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 737
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 738
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 739
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoSoDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 740
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 741
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 742
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 743
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroSoDaDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 744
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 745
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 746
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 747
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaSoDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 748
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 749
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 750
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 751
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {BroDaDaDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 752
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 753
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 754
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 755
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoSoDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 756
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 757
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 758
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 759
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisSoDaDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 760
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 761
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 762
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 763
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaSoDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 764
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaSoSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 765
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaSoDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 766
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaDaSo}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 767
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {SisDaDaDaDa}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 768
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoSoSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 769
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoSoSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 770
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoSoDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 771
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoSoDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 772
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoDaSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 773
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoDaSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 774
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoDaDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 775
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroSoDaDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 776
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaSoSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 777
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaSoSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 778
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaSoDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 779
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaSoDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 780
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaDaSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 781
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaDaSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 782
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaDaDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 783
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuBroDaDaDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 784
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoSoSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 785
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoSoSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 786
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoSoDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 787
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoSoDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 788
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoDaSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 789
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoDaSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 790
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoDaDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 791
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisSoDaDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 792
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaSoSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(Alter, H), female(Ego).
;; 793
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaSoSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 794
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaSoDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 795
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaSoDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 796
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaDaSoSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(Alter, H), female(Ego).
;; 797
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaDaSoDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(Alter, H), female(Ego).
;; 798
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaDaDaSo}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(Alter, H), female(Ego).
;; 799
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=0, Star=0,  {HuSisDaDaDaDa}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(Alter, H), female(Ego).
;; 800
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoSoSoSo}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), son(Alter, D), female(Ego).
;; 801
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoSoSoDa}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), daughter(Alter, D), female(Ego).
;; 802
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoSoDaSo}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), son(Alter, D), female(Ego).
;; 803
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoSoDaDa}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), daughter(Alter, D), female(Ego).
;; 804
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoDaSoSo}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), son(Alter, D), female(Ego).
;; 805
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoDaSoDa}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), daughter(Alter, D), female(Ego).
;; 806
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoDaDaSo}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), son(Alter, D), female(Ego).
;; 807
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaSoDaDaDa}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), daughter(Alter, D), female(Ego).
;; 808
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaSoSoSo}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), son(Alter, D), female(Ego).
;; 809
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaSoSoDa}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), daughter(Alter, D), female(Ego).
;; 810
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaSoDaSo}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), son(Alter, D), female(Ego).
;; 811
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaSoDaDa}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), daughter(Alter, D), female(Ego).
;; 812
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaDaSoSo}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), son(Alter, D), female(Ego).
;; 813
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaDaSoDa}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), daughter(Alter, D), female(Ego).
;; 814
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaDaDaSo}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), son(Alter, D), female(Ego).
;; 815
%nave:4, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=0, Star=0,  {DaDaDaDaDa}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), daughter(Alter, D), female(Ego).
;; 816
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroSoSoSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(E, D), son(F, E), spouse(Alter, F), female(Ego).
;; 817
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroSoSoDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), son(E, D), daughter(F, E), spouse(Alter, F), female(Ego).
;; 818
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroSoDaSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(E, D), son(F, E), spouse(Alter, F), female(Ego).
;; 819
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroSoDaDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(D, C), daughter(E, D), daughter(F, E), spouse(Alter, F), female(Ego).
;; 820
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroDaSoSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(E, D), son(F, E), spouse(Alter, F), female(Ego).
;; 821
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroDaSoDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), son(E, D), daughter(F, E), spouse(Alter, F), female(Ego).
;; 822
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroDaDaSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(E, D), son(F, E), spouse(Alter, F), female(Ego).
;; 823
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {BroDaDaDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(D, C), daughter(E, D), daughter(F, E), spouse(Alter, F), female(Ego).
;; 824
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisSoSoSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(E, D), son(F, E), spouse(Alter, F), female(Ego).
;; 825
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisSoSoDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), son(E, D), daughter(F, E), spouse(Alter, F), female(Ego).
;; 826
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisSoDaSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(E, D), son(F, E), spouse(Alter, F), female(Ego).
;; 827
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisSoDaDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(D, C), daughter(E, D), daughter(F, E), spouse(Alter, F), female(Ego).
;; 828
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisDaSoSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(E, D), son(F, E), spouse(Alter, F), female(Ego).
;; 829
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisDaSoDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), son(E, D), daughter(F, E), spouse(Alter, F), female(Ego).
;; 830
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisDaDaSoWi}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(E, D), son(F, E), spouse(Alter, F), female(Ego).
;; 831
%nave:5, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-3,  PC=7, S=1, Star=0,  {SisDaDaDaHu}  
 mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(D, C), daughter(E, D), daughter(F, E), spouse(Alter, F), female(Ego).
;; 832
%nave:5, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoSoSoWi}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), spouse(Alter, D), female(Ego).
;; 833
%nave:5, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoSoDaHu}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), spouse(Alter, D), female(Ego).
;; 834
%nave:5, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoDaSoWi}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), spouse(Alter, D), female(Ego).
;; 835
%nave:5, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoDaDaHu}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D), female(Ego).
;; 836
%nave:5, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaSoSoWi}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), spouse(Alter, D), female(Ego).
;; 837
%nave:5, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaSoDaHu}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), spouse(Alter, D), female(Ego).
;; 838
%nave:5, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaDaSoWi}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), spouse(Alter, D), female(Ego).
;; 839
%nave:5, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaDaDaHu}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D), female(Ego).
;; 840
%nave:5, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoSoSoWi}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), spouse(Alter, D), female(Ego).
;; 841
%nave:5, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoSoDaHu}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), spouse(Alter, D), female(Ego).
;; 842
%nave:5, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoDaSoWi}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), spouse(Alter, D), female(Ego).
;; 843
%nave:5, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoDaDaHu}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D), female(Ego).
;; 844
%nave:5, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaSoSoWi}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), spouse(Alter, D), female(Ego).
;; 845
%nave:5, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaSoDaHu}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), spouse(Alter, D), female(Ego).
;; 846
%nave:5, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaDaSoWi}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), spouse(Alter, D), female(Ego).
;; 847
%nave:5, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaDaDaHu}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D), female(Ego).
;; 848
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoSoSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 849
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoSoDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 850
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoDaSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 851
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoDaDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 852
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaSoSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 853
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaSoDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 854
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaDaSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 855
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaDaDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 856
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoSoSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 857
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoSoDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 858
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoDaSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 859
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoDaDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 860
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaSoSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 861
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaSoDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 862
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaDaSoWi}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 863
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaDaDaHu}  
 son(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 864
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 865
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 866
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 867
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 868
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 869
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 870
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 871
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 872
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 873
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 874
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 875
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 876
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 877
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 878
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 879
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 880
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 881
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 882
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 883
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 884
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 885
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 886
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 887
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 888
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 889
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 890
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 891
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 892
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaSoSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 893
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaSoDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 894
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaDaSoWi}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 895
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaDaDaHu}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 896
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoSoSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 897
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoSoSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 898
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoSoDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 899
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoSoDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 900
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoDaSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 901
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoDaSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 902
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoDaDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 903
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoDaDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 904
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaSoSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 905
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaSoSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 906
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaSoDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 907
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaSoDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 908
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaDaSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 909
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaDaSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 910
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaDaDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 911
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaDaDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 912
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoSoSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 913
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoSoSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 914
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoSoDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 915
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoSoDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 916
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoDaSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 917
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoDaSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 918
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoDaDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 919
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoDaDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 920
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaSoSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 921
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaSoSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 922
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaSoDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 923
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaSoDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 924
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaDaSoSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 925
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaDaSoDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 926
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaDaDaSoWi}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 927
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaDaDaDaHu}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 928
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoSoSoSoWi}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 929
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoSoSoDaHu}  
 son(A, Ego), son(B, A), son(C, B), son(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 930
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoSoDaSoWi}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 931
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoSoDaDaHu}  
 son(A, Ego), son(B, A), son(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 932
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoDaSoSoWi}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 933
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoDaSoDaHu}  
 son(A, Ego), son(B, A), daughter(C, B), son(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 934
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoDaDaSoWi}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 935
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoSoDaDaDaHu}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 936
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaSoSoSoWi}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 937
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaSoSoDaHu}  
 son(A, Ego), daughter(B, A), son(C, B), son(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 938
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaSoDaSoWi}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 939
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaSoDaDaHu}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 940
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaDaSoSoWi}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 941
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaDaSoDaHu}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 942
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaDaDaSoWi}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 943
%nave:5, square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {SoDaDaDaDaHu}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 944
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoSoSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 945
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoSoDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 946
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoDaSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 947
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoSoDaDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 948
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaSoSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 949
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaSoDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 950
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaDaSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 951
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {SoDaDaDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 952
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoSoSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 953
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoSoDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 954
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoDaSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 955
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaSoDaDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 956
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaSoSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 957
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaSoDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 958
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaDaSoWi}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), son(G, F), spouse(Alter, G), female(Ego).
;; 959
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-4,  PC=8, S=1, Star=0,  {DaDaDaDaHu}  
 daughter(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(F, E), daughter(G, F), spouse(Alter, G), female(Ego).
;; 960
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 961
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 962
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 963
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoSoDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 964
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 965
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 966
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 967
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroSoDaDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 968
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 969
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 970
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 971
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaSoDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 972
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 973
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 974
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 975
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {BroDaDaDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 976
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 977
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 978
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 979
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoSoDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 980
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 981
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 982
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 983
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisSoDaDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 984
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 985
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 986
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 987
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaSoDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 988
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaSoSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 989
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaSoDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 990
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaDaSoWi}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 991
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {SisDaDaDaDaHu}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 992
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoSoSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 993
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoSoSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 994
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoSoDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 995
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoSoDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 996
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoDaSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 997
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoDaSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 998
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoDaDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 999
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroSoDaDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1000
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaSoSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1001
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaSoSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1002
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaSoDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1003
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaSoDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1004
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaDaSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1005
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaDaSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1006
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaDaDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1007
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuBroDaDaDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1008
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoSoSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1009
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoSoSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1010
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoSoDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1011
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoSoDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1012
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoDaSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1013
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoDaSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1014
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoDaDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1015
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisSoDaDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1016
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaSoSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1017
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaSoSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1018
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaSoDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1019
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaSoDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1020
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaDaSoSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1021
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaDaSoDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1022
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaDaDaSoWi}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), son(I, H), spouse(Alter, I), female(Ego).
;; 1023
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=10, S=1, Star=0,  {HuSisDaDaDaDaHu}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(H, G), daughter(I, H), spouse(Alter, I), female(Ego).
;; 1024
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoSoSoSoWi}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 1025
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoSoSoDaHu}  
 daughter(A, Ego), son(B, A), son(C, B), son(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 1026
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoSoDaSoWi}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 1027
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoSoDaDaHu}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 1028
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoDaSoSoWi}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 1029
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoDaSoDaHu}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 1030
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoDaDaSoWi}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 1031
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaSoDaDaDaHu}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 1032
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaSoSoSoWi}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 1033
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaSoSoDaHu}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 1034
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaSoDaSoWi}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 1035
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:0, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaSoDaDaHu}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 1036
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaDaSoSoWi}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 1037
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:0, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaDaSoDaHu}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), daughter(E, D), spouse(Alter, E), female(Ego).
;; 1038
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:0%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaDaDaSoWi}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), son(E, D), spouse(Alter, E), female(Ego).
;; 1039
%nave:5, square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1, children:1, children:1, children:1%
 Lvl=-5,  PC=5, S=1, Star=0,  {DaDaDaDaDaHu}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), daughter(E, D), spouse(Alter, E), female(Ego).


nerimani(Alter, Ego) :-  amojo(Alter, Ego).
;; 0
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), male(Ego), male(Alter).
;; 1
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), male(Alter).
;; 2
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), male(Alter).
;; 3
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), male(Alter).
;; 4
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), male(Alter).
;; 5
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), male(Ego), male(Alter).
;; 6
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), male(Alter).
;; 7
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), male(Ego), male(Alter).
;; 8
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), male(Alter).
;; 9
%nerimani:0, amojo:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), male(Ego), male(Alter).
;; 10
%nerimani:0, amojo:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Ego), male(Alter).
;; 11
%nerimani:0, amojo:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C), male(Ego), male(Alter).
;; 12
%nerimani:0, amojo:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), male(Ego), male(Alter).
;; 13
%nerimani:0, amojo:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), male(Ego), male(Alter).


neriva(Alter, Ego) :-  amojova(Alter, Ego).
;; 0
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), female(Ego), female(Alter).
;; 1
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), female(Alter).
;; 2
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), female(Alter).
;; 3
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), female(Alter).
;; 4
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:0, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), female(Alter).
;; 5
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), gender(E, A), gender(F, D), not(equal(E, F)), child(Alter, D), female(Ego), female(Alter).
;; 6
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), female(Alter).
;; 7
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(G, D), child(H, D), gender(I, A), gender(I, H), not(equal(F, G)), child(Alter, H), female(Ego), female(Alter).
;; 8
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), female(Alter).
;; 9
%neriva:0, amojova:0, cross_cousin[aux]16:0, parents:1, odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, B), gender(F, D), child(G, D), gender(H, A), gender(I, G), not(equal(H, I)), child(Alter, G), female(Ego), female(Alter).
;; 10
%neriva:0, amojova:0, cross_cousin[aux]16:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Ego), female(Alter).
;; 11
%neriva:0, amojova:0, cross_cousin[aux]16:2, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), spouse(Alter, C), female(Ego), female(Alter).
;; 12
%neriva:0, amojova:0, cross_cousin[aux]16:3, parents:0, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), female(Ego), female(Alter).
;; 13
%neriva:0, amojova:0, cross_cousin[aux]16:3, parents:1, odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), gender(F, B), gender(G, E), not(equal(F, G)), child(H, E), spouse(Alter, H), female(Ego), female(Alter).


odd_gen[aux]16(Alter, Ego) :-  sibling(Alter, Ego), gender(A, Ego), gender(B, Alter), not(equal(A, B)).
                           |  [ext],  parents(A, Ego), odd_gen[aux]16(A, B), child(Alter, B), gender(C, Ego), gender(C, Alter).
                           |  [ext],  parents(A, Ego), even_gen[aux]16(A, B), child(Alter, B), gender(C, Ego), gender(D, Alter), not(equal(C, D)).
;; 0
%odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(D, Alter), not(equal(C, D)).
;; 1
%odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), gender(G, Ego), gender(G, Alter).
;; 2
%odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(J, Alter).
;; 3
%odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(J, Alter).
;; 4
%odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), gender(G, Ego), gender(G, Alter).
;; 5
%odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(J, Alter).
;; 6
%odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(J, Alter).
;; 7
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(G, Alter), not(equal(F, G)).
;; 8
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(J, Alter), not(equal(I, J)).
;; 9
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(J, Alter), not(equal(I, J)).
;; 10
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(L, Alter), not(equal(K, L)).
;; 11
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(L, Alter), not(equal(K, L)).
;; 12
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(G, Alter), not(equal(F, G)).
;; 13
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(J, Alter), not(equal(I, J)).
;; 14
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(J, Alter), not(equal(I, J)).
;; 15
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(L, Alter), not(equal(K, L)).
;; 16
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(L, Alter), not(equal(K, L)).
;; 17
%odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(D, Alter), not(equal(C, D)).
;; 18
%odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), gender(G, Ego), gender(G, Alter).
;; 19
%odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(J, Alter).
;; 20
%odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(J, Alter).
;; 21
%odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(F, A), not(equal(E, F)), child(Alter, C), gender(G, Ego), gender(G, Alter).
;; 22
%odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(J, Alter).
;; 23
%odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(I, A), not(equal(H, I)), child(Alter, C), gender(J, Ego), gender(J, Alter).
;; 24
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(G, Alter), not(equal(F, G)).
;; 25
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(J, Alter), not(equal(I, J)).
;; 26
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(J, Alter), not(equal(I, J)).
;; 27
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(L, Alter), not(equal(K, L)).
;; 28
%odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(L, Alter), not(equal(K, L)).
;; 29
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, C), gender(E, A), child(Alter, C), gender(F, Ego), gender(G, Alter), not(equal(F, G)).
;; 30
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(J, Alter), not(equal(I, J)).
;; 31
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(G, B), child(A, E), gender(H, C), gender(H, A), child(Alter, C), gender(I, Ego), gender(J, Alter), not(equal(I, J)).
;; 32
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(L, Alter), not(equal(K, L)).
;; 33
%odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, C), mother(D, E), father(F, E), child(B, D), child(B, F), not(equal(B, E)), gender(G, E), gender(H, B), not(equal(G, H)), child(A, E), gender(I, C), gender(J, A), not(equal(I, J)), child(Alter, C), gender(K, Ego), gender(L, Alter), not(equal(K, L)).


odd_gen[aux]16small(Alter, Ego) :-  sibling(Alter, Ego), gender(A, Ego), gender(B, Alter), not(equal(A, B)).
                                |  [ext],  parents(A, Ego), sibling(A, B), gender(C, A), gender(D, B), child(Alter, B), gender(E, Ego), gender(E, Alter), not(equal(C, D)).
                                |  [ext],  parents(A, Ego), sibling(A, B), gender(C, A), gender(C, B), child(Alter, B), gender(D, Ego), gender(E, Alter), not(equal(D, E)).
;; 0
%odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(D, Alter), not(equal(C, D)).
;; 1
%odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(F, C), child(Alter, C), gender(G, Ego), gender(G, Alter), not(equal(E, F)).
;; 2
%odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(F, C), child(Alter, C), gender(G, Ego), gender(G, Alter), not(equal(E, F)).
;; 3
%odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), child(Alter, C), gender(F, Ego), gender(G, Alter), not(equal(F, G)).
;; 4
%odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), child(Alter, C), gender(F, Ego), gender(G, Alter), not(equal(F, G)).
;; 5
%odd_gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), gender(C, Ego), gender(D, Alter), not(equal(C, D)).
;; 6
%odd_gen[aux]16small:1, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(F, C), child(Alter, C), gender(G, Ego), gender(G, Alter), not(equal(E, F)).
;; 7
%odd_gen[aux]16small:1, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(F, C), child(Alter, C), gender(G, Ego), gender(G, Alter), not(equal(E, F)).
;; 8
%odd_gen[aux]16small:2, parents:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), child(Alter, C), gender(F, Ego), gender(G, Alter), not(equal(F, G)).
;; 9
%odd_gen[aux]16small:2, parents:1, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), gender(E, A), gender(E, C), child(Alter, C), gender(F, Ego), gender(G, Alter), not(equal(F, G)).


opaxa(Alter, Ego) :-  cross_dn1[aux]16(Alter, Ego), male(Alter).
                  |  [ext],  spice(A, Ego), para_dn1[aux]16(Alter, A), male(Alter).
                  |  [ext],  para_dn1[aux]16(A, Ego), husband(Alter, A).
{"BroDaHu_BroSo_FaBroDaDaHu_FaBroDaSo_FaBroSoDaHu_FaBroSoSo_FaFaBroDaDaDaHu_FaFaBroDaDaSo_FaFaBroDaSoDaHu_FaFaBroDaSoSo_FaFaBroSoDaSo_FaFaBroSoSoSo_FaFaSisDaDaDaHu_FaFaSisDaDaSo_FaFaSisDaSoDaHu_FaFaSisDaSoSo_FaFaSisSoDaDaHu_FaFaSisSoSoDaHu_FaMoBroDaDaDaHu_FaMoBroDaDaSo_FaMoBroDaSoDaHu_FaMoBroDaSoSo_FaMoBroSoDaDaHu_FaMoBroSoSoDaHu_FaMoSisDaDaDaHu_FaMoSisDaDaSo_FaMoSisDaSoDaHu_FaMoSisDaSoSo_FaMoSisSoDaSo_FaMoSisSoSoSo_FaSisDaDaHu_FaSisDaSo_FaSisSoDaHu_FaSisSoSo_HuBroSo_HuFaBroSoSo_HuFaFaSisDaSoSo_HuFaMoBroDaSoSo_HuFaSisDaSo_HuMoBroDaSo_HuMoFaSisSoSoSo_HuMoMoBroSoSoSo_HuMoSisSoSo_MoBroDaDaHu_MoBroDaSo_MoBroSoDaHu_MoBroSoSo_MoFaBroDaDaSo_MoFaBroDaSoSo_MoFaBroSoDaDaHu_MoFaBroSoDaSo_MoFaBroSoSoDaHu_MoFaBroSoSoSo_MoFaSisDaDaDaHu_MoFaSisDaSoDaHu_MoFaSisSoDaDaHu_MoFaSisSoDaSo_MoFaSisSoSoDaHu_MoFaSisSoSoSo_MoMoBroDaDaDaHu_MoMoBroDaSoDaHu_MoMoBroSoDaDaHu_MoMoBroSoDaSo_MoMoBroSoSoDaHu_MoMoBroSoSoSo_MoMoSisDaDaSo_MoMoSisDaSoSo_MoMoSisSoDaDaHu_MoMoSisSoDaSo_MoMoSisSoSoDaHu_MoMoSisSoSoSo_MoSisDaDaHu_MoSisDaSo_MoSisSoDaHu_MoSisSoSo_SisDaHu_SisSo_WiFaBroDaSo_WiFaFaSisDaDaSo_WiFaMoBroDaDaSo_WiFaSisSoSo_WiMoBroSoSo_WiMoFaSisSoDaSo_WiMoMoBroSoDaSo_WiMoSisDaSo_WiSisSo"}
;; 0
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {SisSo}  
 male(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(E, Ego), not(equal(D, E)), male(Alter).
;; 1
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisSoSo}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego), male(Alter).
;; 2
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaSoSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), male(Alter).
;; 3
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaSoSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), male(Alter).
;; 4
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroSoSo}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego), male(Alter).
;; 5
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoSoSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), male(Alter).
;; 6
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoSoSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), male(Alter).
;; 7
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisDaSo}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)), male(Alter).
;; 8
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisDaDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), male(Alter).
;; 9
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroDaDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), male(Alter).
;; 10
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), male(Alter).
;; 11
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), male(Alter).
;; 12
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroDaSo}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)), male(Alter).
;; 13
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisSoDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), male(Alter).
;; 14
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroSoDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), male(Alter).
;; 15
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), male(Alter).
;; 16
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoDaSo}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), male(Alter).
;; 17
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {HuBroSo}  
[ext],  husband(A, Ego), parent(B, Alter), mother(C, B), father(D, B), child(A, C), child(A, D), not(equal(A, B)), gender(E, B), gender(E, A), male(Alter).
;; 18
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoSisSoSo}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(H, A), male(Alter).
;; 19
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroDaSoSo}  
[ext], [ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), male(Alter).
;; 20
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisDaSoSo}  
[ext], [ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), male(Alter).
;; 21
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaBroSoSo}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(H, A), male(Alter).
;; 22
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroSoSoSo}  
[ext], [ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), male(Alter).
;; 23
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisSoSoSo}  
[ext], [ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), male(Alter).
;; 24
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaSisDaSo}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(J, A), not(equal(I, J)), male(Alter).
;; 25
%opaxa:1, spice:0, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoBroDaSo}  
[ext], [ext],  husband(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(J, A), not(equal(I, J)), male(Alter).
;; 26
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {WiSisSo}  
[ext],  wife(A, Ego), parent(B, Alter), mother(C, B), father(D, B), child(A, C), child(A, D), not(equal(A, B)), gender(E, B), gender(E, A), male(Alter).
;; 27
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoSisDaSo}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(H, A), male(Alter).
;; 28
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroDaDaSo}  
[ext], [ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), male(Alter).
;; 29
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisDaDaSo}  
[ext], [ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), male(Alter).
;; 30
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaBroDaSo}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(A, E), gender(H, B), gender(H, A), male(Alter).
;; 31
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroSoDaSo}  
[ext], [ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), male(Alter).
;; 32
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisSoDaSo}  
[ext], [ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(A, E), gender(M, B), gender(M, A), male(Alter).
;; 33
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaSisSoSo}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), mother(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(J, A), not(equal(I, J)), male(Alter).
;; 34
%opaxa:1, spice:1, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoBroSoSo}  
[ext], [ext],  wife(A, Ego), parent(B, Alter), father(C, B), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(A, E), gender(I, B), gender(J, A), not(equal(I, J)), male(Alter).
;; 35
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {BroDaHu}  
[ext],  male(Ego), parent(A, B), mother(C, A), father(D, A), child(Ego, C), child(Ego, D), not(equal(Ego, A)), gender(E, A), gender(E, Ego), husband(Alter, B).
;; 36
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisSoDaHu}  
[ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(H, Ego), husband(Alter, B).
;; 37
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroDaSoDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), husband(Alter, B).
;; 38
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisDaSoDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), husband(Alter, B).
;; 39
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroSoDaHu}  
[ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(H, Ego), husband(Alter, B).
;; 40
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroSoSoDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), husband(Alter, B).
;; 41
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisSoSoDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), husband(Alter, B).
;; 42
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisDaDaHu}  
[ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(J, Ego), not(equal(I, J)), husband(Alter, B).
;; 43
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroDaDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 44
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisDaDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 45
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisDaDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 46
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroDaDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 47
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroDaDaHu}  
[ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(J, Ego), not(equal(I, J)), husband(Alter, B).
;; 48
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroSoDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 49
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisSoDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 50
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisSoDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 51
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroSoDaDaHu}  
[ext], [ext], [ext],  male(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 52
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {BroSo}  
 female(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(E, Ego), not(equal(D, E)), male(Alter).
;; 53
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisDaSo}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego), male(Alter).
;; 54
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaDaSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), male(Alter).
;; 55
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaDaSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), male(Alter).
;; 56
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroDaSo}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(H, Ego), male(Alter).
;; 57
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoDaSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), male(Alter).
;; 58
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoDaSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(K, Ego), male(Alter).
;; 59
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisSoSo}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)), male(Alter).
;; 60
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisDaSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), male(Alter).
;; 61
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroDaSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), male(Alter).
;; 62
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), male(Alter).
;; 63
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), male(Alter).
;; 64
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroSoSo}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(H, Ego), not(equal(G, H)), male(Alter).
;; 65
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisSoSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), male(Alter).
;; 66
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroSoSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(I, B), child(Ego, D), gender(J, A), gender(K, Ego), not(equal(J, K)), male(Alter).
;; 67
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), male(Alter).
;; 68
%opaxa:0, cross_dn1[aux]16:0, cross_up1[aux]16:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoSoSo}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(M, Ego), not(equal(L, M)), male(Alter).
;; 69
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {SisDaHu}  
[ext],  female(Ego), parent(A, B), mother(C, A), father(D, A), child(Ego, C), child(Ego, D), not(equal(Ego, A)), gender(E, A), gender(E, Ego), husband(Alter, B).
;; 70
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisDaDaHu}  
[ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(H, Ego), husband(Alter, B).
;; 71
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroDaDaDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), husband(Alter, B).
;; 72
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisDaDaDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), husband(Alter, B).
;; 73
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroDaDaHu}  
[ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(G, C), child(Ego, E), gender(H, A), gender(H, Ego), husband(Alter, B).
;; 74
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroSoDaDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), husband(Alter, B).
;; 75
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisSoDaDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(L, C), not(equal(K, L)), child(Ego, E), gender(M, A), gender(M, Ego), husband(Alter, B).
;; 76
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisSoDaHu}  
[ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(J, Ego), not(equal(I, J)), husband(Alter, B).
;; 77
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoBroDaSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 78
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaSisDaSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 79
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoSisDaSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 80
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaBroDaSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), mother(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 81
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroSoDaHu}  
[ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), father(F, E), child(C, D), child(C, F), not(equal(C, E)), gender(G, E), gender(H, C), not(equal(G, H)), child(Ego, E), gender(I, A), gender(J, Ego), not(equal(I, J)), husband(Alter, B).
;; 82
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaMoBroSoSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 83
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {FaFaSisSoSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(J, D), not(equal(I, J)), child(C, G), gender(K, E), gender(K, C), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 84
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoMoSisSoSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), mother(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).
;; 85
%opaxa:2, para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {MoFaBroSoSoDaHu}  
[ext], [ext], [ext],  female(Ego), parent(A, B), father(C, A), father(D, E), mother(F, G), father(H, G), child(D, F), child(D, H), not(equal(D, G)), gender(I, G), gender(I, D), child(C, G), gender(J, E), gender(K, C), not(equal(J, K)), child(Ego, E), gender(L, A), gender(M, Ego), not(equal(L, M)), husband(Alter, B).


orove(Alter, Ego) :-  parents(A, Ego), two_gen[aux]16(Alter, A), male(Alter).
                  |   parents(A, Ego), two_gen[aux]16(Alter, A), female(Alter).
                  |   parents(A, Ego), spousal_two_gen[aux]16gn(Alter, A), male(Alter).
                  |   parents(A, Ego), spousal_two_gen[aux]16gn(Alter, A), female(Alter).
{"FaFaFa_FaFaFaBro_FaFaFaBroWi_FaFaFaFaBroDa_FaFaFaFaBroSo_FaFaFaFaSisDa_FaFaFaFaSisSo_FaFaFaMoBroDa_FaFaFaMoBroSo_FaFaFaMoSisDa_FaFaFaMoSisSo_FaFaFaSis_FaFaFaSisHu_FaFaMo_FaFaMoBro_FaFaMoBroWi_FaFaMoFaBroDa_FaFaMoFaBroSo_FaFaMoFaSisDa_FaFaMoFaSisSo_FaFaMoMoBroDa_FaFaMoMoBroSo_FaFaMoMoSisDa_FaFaMoMoSisSo_FaFaMoSis_FaFaMoSisHu_FaMoFa_FaMoFaBro_FaMoFaBroWi_FaMoFaFaBroDa_FaMoFaFaBroSo_FaMoFaFaSisDa_FaMoFaFaSisSo_FaMoFaMoBroDa_FaMoFaMoBroSo_FaMoFaMoSisDa_FaMoFaMoSisSo_FaMoFaSis_FaMoFaSisHu_FaMoMo_FaMoMoBro_FaMoMoBroWi_FaMoMoFaBroDa_FaMoMoFaBroSo_FaMoMoFaSisDa_FaMoMoFaSisSo_FaMoMoMoBroDa_FaMoMoMoBroSo_FaMoMoMoSisDa_FaMoMoMoSisSo_FaMoMoSis_FaMoMoSisHu_MoFaFa_MoFaFaBro_MoFaFaBroWi_MoFaFaFaBroDa_MoFaFaFaBroSo_MoFaFaFaSisDa_MoFaFaFaSisSo_MoFaFaMoBroDa_MoFaFaMoBroSo_MoFaFaMoSisDa_MoFaFaMoSisSo_MoFaFaSis_MoFaFaSisHu_MoFaMo_MoFaMoBro_MoFaMoBroWi_MoFaMoFaBroDa_MoFaMoFaBroSo_MoFaMoFaSisDa_MoFaMoFaSisSo_MoFaMoMoBroDa_MoFaMoMoBroSo_MoFaMoMoSisDa_MoFaMoMoSisSo_MoFaMoSis_MoFaMoSisHu_MoMoFa_MoMoFaBro_MoMoFaBroWi_MoMoFaFaBroDa_MoMoFaFaBroSo_MoMoFaFaSisDa_MoMoFaFaSisSo_MoMoFaMoBroDa_MoMoFaMoBroSo_MoMoFaMoSisDa_MoMoFaMoSisSo_MoMoFaSis_MoMoFaSisHu_MoMoMo_MoMoMoBro_MoMoMoBroWi_MoMoMoFaBroDa_MoMoMoFaBroSo_MoMoMoFaSisDa_MoMoMoFaSisSo_MoMoMoMoBroDa_MoMoMoMoBroSo_MoMoMoMoSisDa_MoMoMoMoSisSo_MoMoMoSis_MoMoMoSisHu"}
;; 0
%orove:0, parents:0, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=0, Star=0,  {MoMoFa}  
 mother(A, Ego), mother(B, A), parent(Alter, B), male(Alter).
;; 1
%orove:0, parents:0, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=0, Star=0,  {MoFaFa}  
 mother(A, Ego), father(B, A), parent(Alter, B), male(Alter).
;; 2
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoMoMoBro}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 3
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoMoMoBroSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 4
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoMoMoSisSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 5
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoMoFaBroSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 6
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoMoFaSisSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 7
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoMoFaBro}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 8
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoFaMoBroSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 9
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoFaMoSisSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 10
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoFaFaBroSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 11
%orove:0, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoFaFaSisSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 12
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoFaMoBro}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 13
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaMoMoBroSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 14
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaMoMoSisSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 15
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaMoFaBroSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 16
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaMoFaSisSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 17
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoFaFaBro}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 18
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaFaMoBroSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 19
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaFaMoSisSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 20
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaFaFaBroSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 21
%orove:0, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaFaFaSisSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 22
%orove:0, parents:1, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=0, Star=0,  {FaMoFa}  
 father(A, Ego), mother(B, A), parent(Alter, B), male(Alter).
;; 23
%orove:0, parents:1, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=0, Star=0,  {FaFaFa}  
 father(A, Ego), father(B, A), parent(Alter, B), male(Alter).
;; 24
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaMoMoBro}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 25
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoMoMoBroSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 26
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoMoMoSisSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 27
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoMoFaBroSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 28
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoMoFaSisSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 29
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaMoFaBro}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 30
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoFaMoBroSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 31
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoFaMoSisSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 32
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoFaFaBroSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 33
%orove:0, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoFaFaSisSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 34
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaFaMoBro}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 35
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaMoMoBroSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 36
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaMoMoSisSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 37
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaMoFaBroSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 38
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaMoFaSisSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 39
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaFaFaBro}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 40
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaFaMoBroSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 41
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaFaMoSisSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 42
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaFaFaBroSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), male(Alter).
;; 43
%orove:0, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaFaFaSisSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), male(Alter).
;; 44
%orove:1, parents:0, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=0, Star=0,  {MoMoMo}  
 mother(A, Ego), mother(B, A), parent(Alter, B), female(Alter).
;; 45
%orove:1, parents:0, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=0, Star=0,  {MoFaMo}  
 mother(A, Ego), father(B, A), parent(Alter, B), female(Alter).
;; 46
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoMoMoSis}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 47
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoMoMoBroDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 48
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoMoMoSisDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 49
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoMoFaBroDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 50
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoMoFaSisDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 51
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoMoFaSis}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 52
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoFaMoBroDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 53
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoFaMoSisDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 54
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoFaFaBroDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 55
%orove:1, parents:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoMoFaFaSisDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 56
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoFaMoSis}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 57
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaMoMoBroDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 58
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaMoMoSisDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 59
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaMoFaBroDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 60
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaMoFaSisDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 61
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoFaFaSis}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 62
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaFaMoBroDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 63
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaFaMoSisDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 64
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaFaFaBroDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 65
%orove:1, parents:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {MoFaFaFaSisDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 66
%orove:1, parents:1, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=0, Star=0,  {FaMoMo}  
 father(A, Ego), mother(B, A), parent(Alter, B), female(Alter).
;; 67
%orove:1, parents:1, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=0, Star=0,  {FaFaMo}  
 father(A, Ego), father(B, A), parent(Alter, B), female(Alter).
;; 68
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaMoMoSis}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 69
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoMoMoBroDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 70
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoMoMoSisDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 71
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoMoFaBroDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 72
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoMoFaSisDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 73
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaMoFaSis}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 74
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoFaMoBroDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 75
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoFaMoSisDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 76
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoFaFaBroDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 77
%orove:1, parents:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaMoFaFaSisDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 78
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaFaMoSis}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 79
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaMoMoBroDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 80
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaMoMoSisDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 81
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaMoFaBroDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 82
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaMoFaSisDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 83
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaFaFaSis}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 84
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaFaMoBroDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 85
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaFaMoSisDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 86
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaFaFaBroDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G), female(Alter).
;; 87
%orove:1, parents:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=9, S=0, Star=0,  {FaFaFaFaSisDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G), female(Alter).
;; 88
%orove:2, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {FaMoFa}  
 mother(A, Ego), spouse(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 89
%orove:2, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {FaFaFa}  
 mother(A, Ego), spouse(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 90
%orove:2, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoMoBro}  
[ext],  mother(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 91
%orove:2, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoFaBro}  
[ext],  mother(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 92
%orove:2, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaMoBro}  
[ext],  mother(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 93
%orove:2, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaFaBro}  
[ext],  mother(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 94
%orove:2, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {MoMoFa}  
 mother(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C), male(Alter).
;; 95
%orove:2, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {MoFaFa}  
 mother(A, Ego), father(B, A), parent(C, B), spouse(Alter, C), male(Alter).
;; 96
%orove:2, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoMoSisHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 97
%orove:2, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoFaSisHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 98
%orove:2, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaMoSisHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 99
%orove:2, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaFaSisHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 100
%orove:2, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {MoMoFa}  
 father(A, Ego), spouse(B, A), mother(C, B), parent(Alter, C), male(Alter).
;; 101
%orove:2, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {MoFaFa}  
 father(A, Ego), spouse(B, A), father(C, B), parent(Alter, C), male(Alter).
;; 102
%orove:2, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoMoBro}  
[ext],  father(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 103
%orove:2, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoFaBro}  
[ext],  father(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 104
%orove:2, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaMoBro}  
[ext],  father(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 105
%orove:2, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaFaBro}  
[ext],  father(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 106
%orove:2, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {FaMoFa}  
 father(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C), male(Alter).
;; 107
%orove:2, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {FaFaFa}  
 father(A, Ego), father(B, A), parent(C, B), spouse(Alter, C), male(Alter).
;; 108
%orove:2, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoMoSisHu}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 109
%orove:2, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoFaSisHu}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 110
%orove:2, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaMoSisHu}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 111
%orove:2, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaFaSisHu}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), male(Alter).
;; 112
%orove:3, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {FaMoMo}  
 mother(A, Ego), spouse(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 113
%orove:3, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {FaFaMo}  
 mother(A, Ego), spouse(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 114
%orove:3, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoMoSis}  
[ext],  mother(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 115
%orove:3, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoFaSis}  
[ext],  mother(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 116
%orove:3, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaMoSis}  
[ext],  mother(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 117
%orove:3, parents:0, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaFaSis}  
[ext],  mother(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 118
%orove:3, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {MoMoMo}  
 mother(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C), female(Alter).
;; 119
%orove:3, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {MoFaMo}  
 mother(A, Ego), father(B, A), parent(C, B), spouse(Alter, C), female(Alter).
;; 120
%orove:3, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoMoBroWi}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 121
%orove:3, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoFaBroWi}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 122
%orove:3, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaMoBroWi}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 123
%orove:3, parents:0, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaFaBroWi}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 124
%orove:3, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {MoMoMo}  
 father(A, Ego), spouse(B, A), mother(C, B), parent(Alter, C), female(Alter).
;; 125
%orove:3, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {MoFaMo}  
 father(A, Ego), spouse(B, A), father(C, B), parent(Alter, C), female(Alter).
;; 126
%orove:3, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoMoSis}  
[ext],  father(A, Ego), spouse(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 127
%orove:3, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoFaSis}  
[ext],  father(A, Ego), spouse(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 128
%orove:3, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaMoSis}  
[ext],  father(A, Ego), spouse(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 129
%orove:3, parents:1, spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaFaSis}  
[ext],  father(A, Ego), spouse(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 130
%orove:3, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {FaMoMo}  
 father(A, Ego), mother(B, A), parent(C, B), spouse(Alter, C), female(Alter).
;; 131
%orove:3, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {FaFaMo}  
 father(A, Ego), father(B, A), parent(C, B), spouse(Alter, C), female(Alter).
;; 132
%orove:3, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoMoBroWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 133
%orove:3, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoFaBroWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 134
%orove:3, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaMoBroWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).
;; 135
%orove:3, parents:1, spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaFaBroWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), spouse(Alter, F), female(Alter).


para_dn1[aux]16(Alter, Ego) :-  para_up1[aux]16(Ego, Alter).
;; 0
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(D, Ego).
;; 1
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego).
;; 2
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego).
;; 3
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego).
;; 4
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego).
;; 5
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego).
;; 6
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego).
;; 7
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)).
;; 8
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 9
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 10
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 11
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 12
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)).
;; 13
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 14
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 15
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 16
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  male(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 17
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), parent(A, Alter), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), gender(D, A), gender(D, Ego).
;; 18
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego).
;; 19
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego).
;; 20
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego).
;; 21
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Ego, D), gender(G, A), gender(G, Ego).
;; 22
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego).
;; 23
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(K, B), not(equal(J, K)), child(Ego, D), gender(L, A), gender(L, Ego).
;; 24
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)).
;; 25
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 26
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 27
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 28
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), mother(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 29
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Ego, D), gender(H, A), gender(I, Ego), not(equal(H, I)).
;; 30
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 31
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:1, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(I, C), not(equal(H, I)), child(B, F), gender(J, D), gender(J, B), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 32
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), mother(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).
;; 33
%para_dn1[aux]16:0, para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:2, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext], [ext],  female(Ego), parent(A, Alter), father(B, A), father(C, D), mother(E, F), father(G, F), child(C, E), child(C, G), not(equal(C, F)), gender(H, F), gender(H, C), child(B, F), gender(I, D), gender(J, B), not(equal(I, J)), child(Ego, D), gender(K, A), gender(L, Ego), not(equal(K, L)).


para_up1[aux]16(Alter, Ego) :-  parent(A, Ego), even_gen[aux]16(Alter, A).
;; 0
%para_up1[aux]16:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 parent(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), gender(D, A), gender(D, Alter).
;; 1
%para_up1[aux]16:0, even_gen[aux]16:1, parents:0, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(G, Alter).
;; 2
%para_up1[aux]16:0, even_gen[aux]16:1, parents:1, even_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(F, B), child(Alter, D), gender(G, A), gender(G, Alter).
;; 3
%para_up1[aux]16:0, even_gen[aux]16:2, parents:0, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  parent(A, Ego), mother(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(I, Alter), not(equal(H, I)).
;; 4
%para_up1[aux]16:0, even_gen[aux]16:2, parents:1, odd_gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  parent(A, Ego), father(B, A), mother(C, D), father(E, D), child(B, C), child(B, E), not(equal(B, D)), gender(F, D), gender(G, B), not(equal(F, G)), child(Alter, D), gender(H, A), gender(I, Alter), not(equal(H, I)).


parents(Alter, Ego) :-  mother(Alter, Ego).
                    |   father(Alter, Ego).
;; 0
%parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(Alter, Ego).
;; 1
%parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(Alter, Ego).


sibling(Alter, Ego) :-  mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 0
%sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).


siblings(Alter, Ego) :-  brother(Alter, Ego).
                     |   sister(Alter, Ego).
;; 0
%siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).


sister(Alter, Ego) :-  sibling(Alter, Ego), female(Alter).
;; 0
%sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).


spice(Alter, Ego) :-  husband(Alter, Ego).
                  |   wife(Alter, Ego).
;; 0
%spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(Alter, Ego).
;; 1
%spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(Alter, Ego).


spousal_two_gen[aux]16(Alter, Ego) :-  spice(A, Ego), two_gen[aux]16(Alter, A).
                                   |   two_gen[aux]16(A, Ego), spouse(Alter, A).
;; 0
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), mother(B, A), parent(Alter, B).
;; 1
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), father(B, A), parent(Alter, B).
;; 2
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 3
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 4
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 5
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 6
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 7
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 8
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 9
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 10
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 11
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 12
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 13
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 14
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 15
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 16
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 17
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 18
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 19
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 20
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 21
%spousal_two_gen[aux]16:0, spice:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 22
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), mother(B, A), parent(Alter, B).
;; 23
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), father(B, A), parent(Alter, B).
;; 24
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 25
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 26
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 27
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 28
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 29
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 30
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 31
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 32
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 33
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 34
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 35
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 36
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 37
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 38
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 39
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 40
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 41
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 42
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 43
%spousal_two_gen[aux]16:0, spice:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 44
%spousal_two_gen[aux]16:1, two_gen[aux]16:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(B, A), spouse(Alter, B).
;; 45
%spousal_two_gen[aux]16:1, two_gen[aux]16:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(B, A), spouse(Alter, B).
;; 46
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 47
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 48
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 49
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 50
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 51
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 52
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 53
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 54
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 55
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 56
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 57
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 58
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 59
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 60
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 61
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 62
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 63
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 64
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 65
%spousal_two_gen[aux]16:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).


spousal_two_gen[aux]16gn(Alter, Ego) :-  spouse(A, Ego), two_gen[aux]16(Alter, A).
                                     |   two_gen[aux]16(A, Ego), spouse(Alter, A).
;; 0
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), mother(B, A), parent(Alter, B).
;; 1
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), father(B, A), parent(Alter, B).
;; 2
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 3
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 4
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 5
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 6
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 7
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 8
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 9
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 10
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 11
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 12
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 13
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 14
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 15
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 16
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 17
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)).
;; 18
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 19
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 20
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), child(Alter, G).
;; 21
%spousal_two_gen[aux]16gn:0, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  spouse(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), child(Alter, G).
;; 22
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(B, A), spouse(Alter, B).
;; 23
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(B, A), spouse(Alter, B).
;; 24
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 25
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 26
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 27
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 28
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 29
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 30
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 31
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 32
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 33
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 34
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 35
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 36
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 37
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 38
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 39
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), spouse(Alter, E).
;; 40
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 41
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).
;; 42
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), spouse(Alter, G).
;; 43
%spousal_two_gen[aux]16gn:1, two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), spouse(Alter, G).


square[aux]16(Alter, Ego) :-  gen[aux]16(Alter, Ego).
                          |   parent(Alter, Ego).
                          |   parents(A, Ego), square[aux]16(Alter, A).
;; 0
%square[aux]16:0, gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 4
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 5
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 6
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 7
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 8
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 9
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 10
%square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 11
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 12
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 13
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 14
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 15
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 16
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 17
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 18
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 19
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 20
%square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 21
%square[aux]16:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 parent(Alter, Ego).
;; 22
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 23
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 24
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 25
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 26
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 27
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 28
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 29
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 30
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 31
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 32
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 33
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 34
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 35
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 36
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 37
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 38
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 39
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 40
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 41
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 42
%square[aux]16:2, parents:0, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 43
%square[aux]16:2, parents:0, square[aux]16:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(Alter, A).
;; 44
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 45
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 46
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 47
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 48
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 49
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 50
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 51
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 52
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 53
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 54
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:0, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 55
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 56
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 57
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 58
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 59
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 60
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:0, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 61
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 62
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 63
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 64
%square[aux]16:2, parents:1, square[aux]16:0, gen[aux]16:1, parents:1, gen[aux]16gs:1, parents:1, gen[aux]16gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 65
%square[aux]16:2, parents:1, square[aux]16:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(Alter, A).


square[aux]16DNsmallGS(Alter, Ego) :-  gen[aux]16smallGS(Alter, Ego).
                                   |   children(Alter, Ego).
                                   |   children(A, Ego), square[aux]16DNsmallGS(Alter, A).
;; 0
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).
;; 2
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 3
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 4
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 5
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 6
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 7
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 8
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 9
%square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 10
%square[aux]16DNsmallGS:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(Alter, Ego).
;; 11
%square[aux]16DNsmallGS:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(Alter, Ego).
;; 12
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).
;; 13
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 14
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 15
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 16
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 17
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 18
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 19
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 20
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 21
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 22
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), son(Alter, A).
;; 23
%square[aux]16DNsmallGS:2, children:0, square[aux]16DNsmallGS:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(A, Ego), daughter(Alter, A).
;; 24
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).
;; 25
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 26
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 27
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 28
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 29
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 30
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 31
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 32
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 33
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 34
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), son(Alter, A).
;; 35
%square[aux]16DNsmallGS:2, children:1, square[aux]16DNsmallGS:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(A, Ego), daughter(Alter, A).


square[aux]16small(Alter, Ego) :-  gen[aux]16small(Alter, Ego).
                               |   parent(Alter, Ego).
                               |   parents(A, Ego), square[aux]16small(Alter, A).
;; 0
%square[aux]16small:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%square[aux]16small:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%square[aux]16small:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%square[aux]16small:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 4
%square[aux]16small:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 5
%square[aux]16small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 parent(Alter, Ego).
;; 6
%square[aux]16small:2, parents:0, square[aux]16small:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 7
%square[aux]16small:2, parents:0, square[aux]16small:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 8
%square[aux]16small:2, parents:0, square[aux]16small:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 9
%square[aux]16small:2, parents:0, square[aux]16small:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 10
%square[aux]16small:2, parents:0, square[aux]16small:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 11
%square[aux]16small:2, parents:0, square[aux]16small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(Alter, A).
;; 12
%square[aux]16small:2, parents:1, square[aux]16small:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 13
%square[aux]16small:2, parents:1, square[aux]16small:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 14
%square[aux]16small:2, parents:1, square[aux]16small:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 15
%square[aux]16small:2, parents:1, square[aux]16small:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 16
%square[aux]16small:2, parents:1, square[aux]16small:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 17
%square[aux]16small:2, parents:1, square[aux]16small:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(Alter, A).


square[aux]16smallGS(Alter, Ego) :-  gen[aux]16smallGS(Alter, Ego).
                                 |   parents(Alter, Ego).
                                 |   parents(A, Ego), square[aux]16smallGS(Alter, A).
;; 0
%square[aux]16smallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%square[aux]16smallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).
;; 2
%square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 3
%square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 4
%square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 5
%square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 6
%square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 7
%square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 8
%square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 9
%square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 10
%square[aux]16smallGS:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(Alter, Ego).
;; 11
%square[aux]16smallGS:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(Alter, Ego).
;; 12
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).
;; 13
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 14
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 15
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 16
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 17
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 18
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 19
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 20
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 21
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 22
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(Alter, A).
;; 23
%square[aux]16smallGS:2, parents:0, square[aux]16smallGS:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(Alter, A).
;; 24
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).
;; 25
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 26
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 27
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 28
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 29
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 30
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 31
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 32
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 33
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:0, gen[aux]16smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 34
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(Alter, A).
;; 35
%square[aux]16smallGS:2, parents:1, square[aux]16smallGS:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(Alter, A).


step_brother(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), son(Alter, D), son(Alter, C).
                         |   father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), son(Alter, D), son(Alter, C).
;; 0
%step_brother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), son(Alter, D), son(Alter, C).
;; 1
%step_brother:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), son(Alter, D), son(Alter, C).


step_child[aux]16(Alter, Ego) :-  spice(A, Ego), spouse(B, A), not(equal(Ego, B)), children(Alter, B), child(Alter, A).
;; 0
%step_child[aux]16:0, spice:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), child(Alter, A).
;; 1
%step_child[aux]16:0, spice:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), child(Alter, A).
;; 2
%step_child[aux]16:0, spice:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), child(Alter, A).
;; 3
%step_child[aux]16:0, spice:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), child(Alter, A).


step_child[aux]16gn(Alter, Ego) :-  spice(A, Ego), spouse(B, A), not(equal(Ego, B)), child(Alter, B), child(Alter, A).
;; 0
%step_child[aux]16gn:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), spouse(B, A), not(equal(Ego, B)), child(Alter, B), child(Alter, A).
;; 1
%step_child[aux]16gn:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), spouse(B, A), not(equal(Ego, B)), child(Alter, B), child(Alter, A).


step_child[aux]16gngn(Alter, Ego) :-  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), child(Alter, B), child(Alter, A).
;; 0
%step_child[aux]16gngn:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), child(Alter, B), child(Alter, A).


step_daughter(Alter, Ego) :-  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).
;; 0
%step_daughter:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).


step_father(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).
;; 0
%step_father:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).


step_mother(Alter, Ego) :-  father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).
;; 0
%step_mother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).


step_sister(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), daughter(Alter, D), daughter(Alter, C).
                        |   father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), daughter(Alter, D), daughter(Alter, C).
;; 0
%step_sister:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), daughter(Alter, D), daughter(Alter, C).
;; 1
%step_sister:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), daughter(Alter, D), daughter(Alter, C).


step_son(Alter, Ego) :-  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).
;; 0
%step_son:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).


two_gen[aux]16(Alter, Ego) :-  parents(A, Ego), parent(Alter, A).
                           |  [ext],  parents(A, Ego), parents(B, A), gen[aux]16small(Alter, B).
;; 0
%two_gen[aux]16:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), parent(Alter, A).
;; 1
%two_gen[aux]16:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), parent(Alter, A).
;; 2
%two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 3
%two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 4
%two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 5
%two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 6
%two_gen[aux]16:1, parents:0, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 7
%two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 8
%two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 9
%two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 10
%two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 11
%two_gen[aux]16:1, parents:0, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 12
%two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 13
%two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 14
%two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 15
%two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 16
%two_gen[aux]16:1, parents:1, parents:0, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 17
%two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 18
%two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 19
%two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 20
%two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 21
%two_gen[aux]16:1, parents:1, parents:1, gen[aux]16small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).


va(Alter, Ego) :-  wife(Alter, Ego).
{"Wi"}
;; 0
%va:0%
 Lvl=0,  PC=0, S=1, Star=0,  {Wi}  
 wife(Alter, Ego).


xinato(Alter, Ego) :-  son(Alter, Ego).
                   |  [ext],  step_son(Alter, Ego).
{"So_Stso"}
;; 0
%xinato:0%
 Lvl=-1,  PC=1, S=0, Star=0,  {So}  
 son(Alter, Ego).
;; 1
%xinato:1, step_son:0%
 Lvl=-1,  PC=2, S=2, Star=0,  {Stso}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).


xinatoyo(Alter, Ego) :-  daughter(Alter, Ego).
                     |  [ext],  step_daughter(Alter, Ego).
{"Da_Stda"}
;; 0
%xinatoyo:0%
 Lvl=-1,  PC=1, S=0, Star=0,  {Da}  
 daughter(Alter, Ego).
;; 1
%xinatoyo:1, step_daughter:0%
 Lvl=-1,  PC=2, S=2, Star=0,  {Stda}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).

